# Multivariate Polynomials

| **Documentation** | **Build Status** | **Social** | **References to cite** |
|:-----------------:|:----------------:|:----------:|:----------------------:|
| [![][docs-stable-img]][docs-stable-url] | [![Build Status][build-img]][build-url] | [![Gitter][gitter-img]][gitter-url] | [![DOI][zenodo-img]][zenodo-url] |
| [![][docs-latest-img]][docs-latest-url] | [![Codecov branch][codecov-img]][codecov-url] | [<img src="https://upload.wikimedia.org/wikipedia/commons/c/cf/Discourse_logo.svg" width="64">][discourse-url] | |

**WARNING** MultivariatePolynomials v0.5 has a few breaking changes including the change in the order of monomials. This means that the leading term will now appear last in the order of monomials instead of first.

This package provides an interface for manipulating multivariate polynomials.
Implementing algorithms on polynomials using this interface will allow the algorithm to work for all polynomials implementing the interface.

The interface contains functions for accessing the coefficients, monomials, terms of the polynomial, defines arithmetic operations on them, rational functions, division with remainder, calculus/differentiation and evaluation/substitution.

## Documentation

- [**STABLE**][docs-stable-url] &mdash; **most recently tagged version of the documentation.**
- [**LATEST**][docs-latest-url] &mdash; *in-development version of the documentation.*

## Citing

Please cite the [JuliaCon 2022 presentation](https://pretalx.com/juliacon-2022/talk/TRFSJY/) [[Slides](https://drive.google.com/file/d/1q9UT5rpcmm0GdRmWm7llhVpbOx7OxGnZ/view)].
See [CITATION.bib](https://github.com/JuliaAlgebra/MultivariatePolynomials.jl/blob/main/CITATION.bib) for the BibTeX.

## Examples

Below is a simple usage example
```julia
using TypedPolynomials
@polyvar x y # assigns x (resp. y) to a variable of name x (resp. y)
p = 2x + 3.0x*y^2 + y
@test differentiate(p, x) # compute the derivative of p with respect to x
@test differentiate.(p, (x, y)) # compute the gradient of p
@test p((x, y)=>(y, x)) # replace any x by y and y by x
@test subs(p, y=>x^2) # replace any occurence of y by x^2
@test p(x=>1, y=>2) # evaluate p at [1, 2]
```
Below is an example with `@polyvar x[1:3]`
```julia
using TypedPolynomials
A = rand(3, 3)
@polyvar x[1:3] # assign x to a tuple of variables x1, x2, x3
p = sum(x .* x) # x_1^2 + x_2^2 + x_3^2
subs(p, x[1]=>2, x[3]=>3) # x_2^2 + 13
p(x=>A*vec(x)) # corresponds to dot(A*x, A*x), need vec to convert the tuple to a vector
```

## Ecosystem

The following packages provides multivariate polynomials that implement the interface:

* [TypedPolynomials](https://github.com/rdeits/TypedPolynomials.jl) : Commutative polynomials of arbitrary coefficient types
* [DynamicPolynomials](https://github.com/JuliaAlgebra/DynamicPolynomials.jl) : Commutative and non-commutative polynomials of arbitrary coefficient types

The following packages extend/use the interface:

* [SemialgebraicSets](https://github.com/JuliaAlgebra/SemialgebraicSets.jl) : Sets defined by inequalities and equalities between polynomials and algorithms for solving polynomial systems of equations.
* [FixedPolynomials](https://github.com/JuliaAlgebra/FixedPolynomials.jl) : Fast evaluation of multivariate polynomials
* [HomotopyContinuation](https://github.com/saschatimme/HomotopyContinuation.jl) : Solving systems of polynomials via homotopy continuation.
* [MultivariateBases](https://github.com/JuliaAlgebra/MultivariateBases.jl/) : Standardized API for multivariate polynomial bases.
* [MultivariateMoments](https://github.com/JuliaAlgebra/MultivariateMoments.jl) : Moments of multivariate measures and their scalar product with polynomials.
* [PolyJuMP](https://github.com/JuliaOpt/PolyJuMP.jl) : A [JuMP](https://github.com/JuliaOpt/JuMP.jl) extension for Polynomial Optimization.
* [SumOfSquares](https://github.com/JuliaOpt/SumOfSquares.jl) : Certifying the nonnegativity of polynomials, minimizing/maximizing polynomials and optimization over sum of squares polynomials using Sum of Squares Programming.

### See also

* [Nemo](https://github.com/wbhart/Nemo.jl) for generic polynomial rings, matrix spaces, fraction fields, residue rings, power series
* [Polynomials](https://github.com/Keno/Polynomials.jl) for univariate polynomials
* [PolynomialRoots](https://github.com/giordano/PolynomialRoots.jl) for a fast complex polynomial root finder

[docs-stable-img]: https://img.shields.io/badge/docs-stable-blue.svg
[docs-latest-img]: https://img.shields.io/badge/docs-dev-blue.svg
[docs-stable-url]: https://JuliaAlgebra.github.io/MultivariatePolynomials.jl/stable
[docs-latest-url]: https://juliaalgebra.github.io/MultivariatePolynomials.jl/dev

[build-img]: https://github.com/JuliaAlgebra/MultivariatePolynomials.jl/actions/workflows/ci.yml/badge.svg?branch=main
[build-url]: https://github.com/JuliaAlgebra/MultivariatePolynomials.jl/actions?query=workflow%3ACI
[codecov-img]: http://codecov.io/gh/JuliaAlgebra/MultivariatePolynomials.jl/branch/main/graph/badge.svg
[codecov-url]: http://codecov.io/gh/JuliaAlgebra/MultivariatePolynomials.jl

[gitter-url]: https://gitter.im/JuliaAlgebra/Lobby?utm_source=share-link&utm_medium=link&utm_campaign=share-link
[gitter-img]: https://badges.gitter.im/JuliaAlgebra/Lobby.svg
[discourse-url]: https://discourse.julialang.org/c/domain/opt

[zenodo-url]: https://zenodo.org/badge/latestdoi/72210778
[zenodo-img]: https://zenodo.org/badge/72210778.svg

@testset "Example 1" begin
    Mod.@polyvar x y
    p = 2x + 3.0x * y^2 + y
    @test differentiate(p, x) == 2 + 3y^2
    @test differentiate.(p, (x, y)) == (2 + 3y^2, 6x * y + 1)
    @test p((x, y) => (y, x)) == 2y + 3y * x^2 + x
    @test subs(p, y => x^2) == 2x + 3x^5 + x^2
    @test p(x => 1, y => 2) == 2 + 3 * 4 + 2
end

@testset "Differentiation" begin
    Mod.@polyvar x y z
    @test differentiate(3, y) == 0
    @test differentiate.([x, y], y) == [0, 1]
    @test differentiate([x, y], (x, y)) == Matrix(1.0I, 2, 2) # TODO: this can be just `I` on v0.7 and above
    @test differentiate(true * x + true * x^2, y) == 0
    @inferred differentiate(true * x + true * x^2, y)
    @test differentiate(x * y + 3y^2, [x, y]) == [y, x + 6y]
    @inferred differentiate(x * y + 3y^2, x)
    @inferred differentiate(x * y + 3y^2, [x, y])
    @test differentiate(1 / x, [x, y]) == [-1 / x^2, 0]
    @test differentiate((x - y) / (x * y), [x, y]) ==
          [y^2 / (x * y)^2, -x^2 / (x * y)^2]
    p = x^2 - y + x * y
    @test differentiate(p, x, 2) == 2
    @test differentiate(p, x, 0) === p
    @test_throws DomainError differentiate(p, x, -1)
    @test differentiate(x, x, 1) == 1
    #@inferred differentiate(x, x, 0) # FIXME failing at the moment
    @inferred differentiate(x, x, 1)
    @test differentiate(4x * y^3, y) == 12x * y^2
    @inferred differentiate(4x * y^3, y)
    @test differentiate(differentiate(x * y^4, y), y) == 12x * y^2
    @inferred differentiate(differentiate(x * y^4, y), y)
    @test differentiate(x * y^4, y, 3) == 24x * y
    @inferred differentiate(x * y^4, y, 3)
    @test differentiate(x * y^4, y, 0) == x * y^4
    @test differentiate(2x^2, x, 2) == 4
    @inferred differentiate(2x^2, x, 2)
    @inferred differentiate(2x^2 + x * y + y^2, [x, y])
    p = differentiate(2x^2 + 3x * y + y^2, [x, y], 2)
    @test isa(p, Matrix{<:AbstractPolynomial{Int}})
    @test p == [4 3; 3 2]
    p = differentiate(2x^2 + 3x * y^2 + 4y^3 + 2.0, (x, y), 2)
    @test isa(p, Matrix{<:AbstractPolynomial{Float64}})
    @test p == [4.0 6.0y; 6.0y 6.0x+24.0y]

    f = [x^2 + y, z^2 + 4x]
    @test differentiate(f, [x, y, z]) == [2x 1 0; 4 0 2z]
    @test differentiate(f, (x, y, z)) == [2x 1 0; 4 0 2z]

    @testset "differentiation with Val{}" begin
        @test @inferred(differentiate(x, x, Val{0}())) == x
        @test @inferred(differentiate(x, x, Val{1}())) == 1
        @test @inferred(differentiate(x^2, x, Val{1}())) == 2x
        @test @inferred(differentiate(x^2, y, Val{1}())) == 0
        @test @inferred(differentiate(2x^2 + 3y, x, Val{1}())) == 4x
        @test @inferred(differentiate(2x^2 + 3y, x, Val{2}())) == 4
        p = differentiate(2x^2 + 3x * y + y^2, [x, y], Val{2}())
        @test isa(p, Matrix{<:AbstractPolynomial{Int}})
        @test p == [4 3; 3 2]
    end
end

using BenchmarkTools

function bench0(x, T)
    o = one(T)
    p = o * x^2 + 2o * x + o
    q = o * x + o
    @benchmark gcd($p, $q)
end

function bench1(x, y, z, T)
    o = one(T)
    p = (o * x + o * y^2) * (o * z^3 + o * y^2 + o * x)
    q = (o * x + o * y + o * z) * (o * x^2 + o * y)
    @benchmark gcd($p, $q)
end

function bench2(x, y, z, t, T)
    p = x * y + T(3) * (z * t)
    q = (p + T(1)) * p
    @benchmark gcd($p, $q)
end

function bench3(x, y, z, t, T)
    c1 = T(10)*(x * z + x)
    c2 = T(2)*(x^2 + z)
    c3 = T(2)*(2 - z)
    c4 = T(20)*(x * z^2)
    e1 = 0
    e2 = 5
    e3 = 7
    e4 = 10
    p = c1 * y^e1 + c2 * y^e2 + c3 * y^e3 + c4 * y^e4
    q = prod(i->p + i, 0:3)
    @benchmark for i in 0:3
        gcd($p + i, $q)
    end
end

import SIMDPolynomials
function bench_SP(T)
    x, y, z, t = [SIMDPolynomials.PackedMonomial{4,7}(i) for i in 0:3]
    b0 = bench0(x, T)
    b1 = bench1(x, y, z, T)
    b2 = bench2(x, y, z, t, T)
    b3 = bench3(x, y, z, t, T)
    return b0, b1, b2, b3
end

import DynamicPolynomials
function bench_DP(T)
    DynamicPolynomials.@polyvar x y z t
    b0 = bench0(x, T)
    b1 = bench1(x, y, z, T)
    b2 = bench2(x, y, z, t, T)
    b3 = bench3(x, y, z, t, T)
    return b0, b1, b2, b3
end

import TypedPolynomials
function bench_TP(T)
    TypedPolynomials.@polyvar x y z t
    b0 = bench0(x, T)
    b1 = bench1(x, y, z, T)
    b2 = bench2(x, y, z, t, T)
    b3 = bench3(x, y, z, t, T)
    return b0, b1, b2, b3
end

include("table.jl")

function bench(T)
    bs0, bs1, bs2, bs3 = bench_SP(T)
    bd0, bd1, bd2, bd3 = bench_DP(T)
    bt0, bt1, bt2, bt3 = bench_TP(T)
    println("### Benchmark 0")
    println()
    prettyprint(bs0, bd0, bt0)
    println()
    println("### Benchmark 1")
    println()
    prettyprint(bs1, bd1, bt1)
    println()
    println("### Benchmark 2")
    println()
    prettyprint(bs2, bd2, bt2)
    println()
    println("### Benchmark 3")
    println()
    prettyprint(bs3, bd3, bt3)
    println()
end

function bench()
    for T in [Int, BigInt, Rational{BigInt}]
        println("## $T")
        println()
        bench(T)
    end
end

bench()

"""
    antidifferentiate(p::AbstractPolynomialLike, v::AbstractVariable, deg::Union{Int, Val}=1)

Antidifferentiate `deg` times the polynomial `p` by the variable `v`. The free constant involved by
the antidifferentiation is set to 0.


    antidifferentiate(p::AbstractPolynomialLike, vs, deg::Union{Int, Val}=1)

Antidifferentiate `deg` times the polynomial `p` by the variables of the vector or
tuple of variable `vs` and return an array of dimension `deg`. It is recommended
to pass `deg` as a `Val` instance when the degree is known at compile time, e.g.
`antidifferentiate(p, v, Val{2}())` instead of `antidifferentiate(p, x, 2)`, as this
will help the compiler infer the return type.

### Examples

```julia
p = 3x^2*y + x + 2y + 1
antidifferentiate(p, x) # should return 3x^3* + 1/2*x + 2xy + x
antidifferentiate(p, x, Val{1}()) # equivalent to the above
antidifferentiate(p, (x, y)) # should return [3x^3* + 1/2*x + 2xy + x, 3/2x^2*y^2 + xy + y^2 + y]
```
"""
function antidifferentiate end

# Fallback for everything else
antidifferentiate(α::T, v::AbstractVariable) where {T} = α * v
function antidifferentiate(v1::AbstractVariable, v2::AbstractVariable)
    return v1 == v2 ? 1 // 2 * v1 * v2 : v1 * v2
end
function antidifferentiate(t::AbstractTermLike, v::AbstractVariable)
    return coefficient(t) * antidifferentiate(monomial(t), v)
end
function antidifferentiate(p::_APL, v::AbstractVariable)
    return polynomial!(antidifferentiate.(terms(p), v), SortedState())
end

# TODO: this signature is probably too wide and creates the potential
# for stack overflows
antidifferentiate(p::_APL, xs) = [antidifferentiate(p, x) for x in xs]

# antidifferentiate(p, [x, y]) with TypedPolynomials promote x to a Monomial
function antidifferentiate(p::_APL, m::AbstractMonomial)
    return antidifferentiate(p, variable(m))
end

# The `R` argument indicates a desired result type. We use this in order
# to attempt to preserve type-stability even though the value of `deg` cannot
# be known at compile time. For scalar `p` and `x`, we set R to be the type
# of antidifferentiate(p, x) to give a stable result type regardless of `deg`. For
# vectors p and/or x this is impossible (since antidifferentiate may return an array),
# so we just set `R` to `Any`
function (_antidifferentiate_recursive(p, x, deg::Int, ::Type{R})::R) where {R}
    if deg < 0
        throw(DomainError(deg, "degree is negative"))
    elseif deg == 0
        return p
    else
        return antidifferentiate(antidifferentiate(p, x), x, deg - 1)
    end
end

function antidifferentiate(p, x, deg::Int)
    return _antidifferentiate_recursive(
        p,
        x,
        deg,
        Base.promote_op(antidifferentiate, typeof(p), typeof(x)),
    )
end
function antidifferentiate(p::AbstractArray, x, deg::Int)
    return _antidifferentiate_recursive(p, x, deg, Any)
end
function antidifferentiate(p, x::Union{AbstractArray,Tuple}, deg::Int)
    return _antidifferentiate_recursive(p, x, deg, Any)
end
function antidifferentiate(
    p::AbstractArray,
    x::Union{AbstractArray,Tuple},
    deg::Int,
)
    return _antidifferentiate_recursive(p, x, deg, Any)
end

# This is alternative, Val-based interface for nested antidifferentiation.
# It has the advantage of not requiring an conversion or calls to
# Base.promote_op, while maintaining type stability for any argument
# type.
antidifferentiate(p, x, ::Val{0}) = p
antidifferentiate(p, x, ::Val{1}) = antidifferentiate(p, x)

function antidifferentiate(p, x, deg::Val{N}) where {N}
    if N < 0
        throw(DomainError(deg))
    else
        antidifferentiate(antidifferentiate(p, x), x, Val{N - 1}())
    end
end

using Documenter, MultivariatePolynomials

DocMeta.setdocmeta!(
    MultivariatePolynomials,
    :DocTestSetup,
    :(using MultivariatePolynomials);
    recursive=true,
)

makedocs(
    sitename = "MultivariatePolynomials",

    format = Documenter.HTML(
        # See https://github.com/JuliaDocs/Documenter.jl/issues/868
        prettyurls = get(ENV, "CI", nothing) == "true"
    ),

    pages = [
        "Introduction" => "index.md",
        "Types" => "types.md",
        "Substitution" => "substitution.md",
        "Differentiation" => "differentiation.md",
        "Division" => "division.md",
        "Internal" => "internal.md",
    ],

    # The following ensures that we only include the docstrings from
    # this module for functions define in Base that we overwrite.
    modules = [MultivariatePolynomials],
)

deploydocs(
    repo   = "github.com/JuliaAlgebra/MultivariatePolynomials.jl.git",
)

_copy(p, ::MA.IsMutable) = p
# `Base.copy` does not copy anything for `BigInt` so we need `MA.copy_if_mutable`
_copy(p, ::MA.IsNotMutable) = MA.copy_if_mutable(p)

"""
    abstract type AbstractUnivariateGCDAlgorithm end

Algorithm computing the greatest common divisor of univariate polynomials.
See [`GeneralizedEuclideanAlgorithm`](@ref) and [`SubresultantAlgorithm`](@ref).
"""
abstract type AbstractUnivariateGCDAlgorithm end

"""
    struct GeneralizedEuclideanAlgorithm <: AbstractUnivariateGCDAlgorithm
        primitive_rem::Bool
        skip_last::Bool
    end

Algorithm computing the greatest common divisor of univariate polynomials using
the Euclidean algorithm generalized for polynomials with coefficients over a
a unique factorization domain, see [Knu14, Algorithm E, p. 426-427].

If `primitive_rem` is `true`, the intermediate remainders produced in the
polynomial division are made primitive. If `primitive_part` is set to `false`,
only the resuting remainder is made primitive (the intermediate remainders
of the generalized Euclidean algorithm still need to be made primitive).

[Knu14] Knuth, D.E., 2014.
*Art of computer programming, volume 2: Seminumerical algorithms.*
Addison-Wesley Professional. Third edition.
"""
struct GeneralizedEuclideanAlgorithm <: AbstractUnivariateGCDAlgorithm
    primitive_rem::Bool
    skip_last::Bool
    function GeneralizedEuclideanAlgorithm(
        primitive_rem::Bool = false,
        skip_last::Bool = false,
    )
        return new(primitive_rem, skip_last)
    end
end

_primitive_rem(algo::GeneralizedEuclideanAlgorithm) = algo.primitive_rem
_skip_last(algo::GeneralizedEuclideanAlgorithm) = algo.skip_last
function _set_skipped_divisions!(::GeneralizedEuclideanAlgorithm, ::Int) end

"""
    mutable struct SubresultantAlgorithm <: AbstractUnivariateGCDAlgorithm
        skipped_divisions::Int
    end

Algorithm computing the greatest common divisor of univariate polynomials using
the Subresultant algorithm, see [Knu14, Algorithm C, p. 428-429].

The division by `g*h^δ` in the algorithm only works if the iteration of
[Knu14, Algorithm R, p. 426] is carried out even when the divided polynomial
has a zero term. For computational savings, we don't do that so we store
in `skipped_division` the number of skipped divisions so that the division
by `g*h^δ` can be adapted accordingly.

In [Knu14, Algorithm C, p. 426], it is stated that there should be ``

[Knu14] Knuth, D.E., 2014.
*Art of computer programming, volume 2: Seminumerical algorithms.*
Addison-Wesley Professional. Third edition.
"""
mutable struct SubresultantAlgorithm <: AbstractUnivariateGCDAlgorithm
    skipped_divisions::Int
    SubresultantAlgorithm() = new(0)
end

_primitive_rem(::SubresultantAlgorithm) = false
_skip_last(::SubresultantAlgorithm) = false
function _set_skipped_divisions!(algo::SubresultantAlgorithm, n::Int)
    algo.skipped_divisions = n
    return
end

_coefficient_gcd(α, β) = gcd(α, β)
_coefficient_gcd(α::AbstractFloat, β) = one(Base.promote_typeof(α, β))
_coefficient_gcd(α, β::AbstractFloat) = one(Base.promote_typeof(α, β))
_coefficient_gcd(α::Complex, β) = one(Base.promote_typeof(α, β))
_coefficient_gcd(α, β::Complex) = one(Base.promote_typeof(α, β))
_coefficient_gcd(α::Complex, β::AbstractFloat) = one(Base.promote_typeof(α, β))
_coefficient_gcd(α::AbstractFloat, β::Complex) = one(Base.promote_typeof(α, β))
function _coefficient_gcd(α::AbstractFloat, β::AbstractFloat)
    return one(Base.promote_typeof(α, β))
end
function _coefficient_gcd(α::Complex, β::Complex)
    return one(Base.promote_typeof(α, β))
end

function Base.lcm(
    p::_APL,
    q::_APL,
    algo::AbstractUnivariateGCDAlgorithm = SubresultantAlgorithm(),
)
    return p * div(q, gcd(p, q, algo))
end
function Base.gcd(
    α,
    p::_APL,
    algo::AbstractUnivariateGCDAlgorithm = SubresultantAlgorithm(),
    ::MA.MutableTrait = MA.IsNotMutable(),
    mp::MA.MutableTrait = MA.IsNotMutable(),
)
    return _coefficient_gcd(α, content(p, algo, mp))
end
function Base.gcd(
    p::_APL,
    α,
    algo::AbstractUnivariateGCDAlgorithm = SubresultantAlgorithm(),
    mp::MA.MutableTrait = MA.IsNotMutable(),
    mα::MA.MutableTrait = MA.IsNotMutable(),
)
    return _coefficient_gcd(content(p, algo, mp), α)
end

#function MA.promote_operation(::typeof(gcd), P::Type{<:Number}, Q::Type{<:Number})
#    return typeof(gcd(one(P), one(Q)))
#end
function MA.promote_operation(
    ::typeof(gcd),
    P::Type{<:_APL},
    Q::Type{<:_APL},
    A::Type = SubresultantAlgorithm,
)
    return MA.promote_operation(rem_or_pseudo_rem, P, Q, A)
end

"""
    function gcd(p1::AbstractPolynomialLike{T}, p2::AbstractPolynomialLike{S}) where {T, S}

Returns a greatest common divisor of `p1` and `p2`. Note that it does not make
sense, in general, to speak of "the" greatest common divisor of u and v; there
is a set of greatest common divisors, each one being a unit multiple of the
others [Knu14, p. 424].

# Implementation notes

The classical algorithm for computing the `gcd`, commonly referred to as the
Euclidean Algorithm is to use a recursion with the base case `gcd(p, 0) = p`
and the relation `gcd(p1, p2) = gcd(p2, rem(p1, p2))`.
The relation comes from the Euclidean division:
`p1 = q * p2 + r`,
if `g` divides `p1` and `p2` then it divides `r` and
if `g` divides `r` and `p2` then it divides `p1`.

For multivariate polynomials, you may have `rem(p1, p2) = p1` hence this will not
terminate.
To ensure we make progress, we can pick a given variable `xi` and try to find
`q1` and `q2` such that
`q2 * p1 = q1 * p2 + r`
and the degree of `r` in `xi` is strictly smaller than the degree of `p1` in `xi`.
Note that if `g` divides `p1` and `p2` then it divides `r` but
if `g` divides `r` and `p2` then it might divide `q2` and not `p1`.
So what do we do ?
Let `dj` be the degree of `pj` in `xi`.
Suppose we pick `qj` to be the coefficient of `pj` in `xi^dj`.
If `g` divides `q2` then it means that the degree of `g` in `xi` is zero.
Therefore, if it divides `p2` then it also divides the coefficients
of `p2` in `xi^k` for `k = 0, 1, ..., d2`.
This means that if we ensure that these are relatively prime then we won't have
any issue.
So we start by computing a `gcd` `gj` of the coefficients in each degree of
`xi` of `pj`, this is called the [`content`](@ref) of `pj`.
And then we compute `_gcd(p1 / g1, p2 / g2) * gcd(g1, g2)` where we can use the
recursion `_gcd(p1, p2) = _gcd(p2, q2 * p1 - q1 * p2)` where `q1, q2` are as
defined above.
This is the [`GeneralizedEuclideanAlgorithm`](@ref).

[Knu14] Knuth, D.E., 2014.
*Art of computer programming, volume 2: Seminumerical algorithms.*
Addison-Wesley Professional. Third edition.
"""
function Base.gcd(
    p1::_APL{T},
    p2::_APL{S},
    algo::AbstractUnivariateGCDAlgorithm = SubresultantAlgorithm(),
    m1::MA.MutableTrait = MA.IsNotMutable(),
    m2::MA.MutableTrait = MA.IsNotMutable(),
) where {T,S}
    # If one of these is zero, `shift` should be infinite
    # for this method to work so we exclude these cases.
    if isapproxzero(p1)
        return convert(
            MA.promote_operation(gcd, typeof(p1), typeof(p2)),
            _copy(p2, m2),
        )
    end
    if isapproxzero(p2)
        return convert(
            MA.promote_operation(gcd, typeof(p1), typeof(p2)),
            _copy(p1, m1),
        )
    end
    shift1, defl1 = deflation(p1)
    shift2, defl2 = deflation(p2)
    shift = gcd(shift1, shift2)
    defl = map_exponents(gcd, defl1, defl2)
    # We factor out `x.^shift1` from `p1` and
    # `x.^shift2` from `p2`. The `gcd` of these
    # monomials is `x.^shift`.
    # Then, we subsitute `y[i] = x[i]^defl[i]`.
    q1 = deflate(p1, shift1, defl)
    q2 = deflate(p2, shift2, defl)
    g = deflated_gcd(q1, q2, algo, m1, m2)
    return inflate(
        g,
        shift,
        defl,
    )::MA.promote_operation(gcd, typeof(p1), typeof(p2))
end

function Base.gcd(
    t1::AbstractTermLike{T},
    t2::AbstractTermLike{S},
    ::AbstractUnivariateGCDAlgorithm = SubresultantAlgorithm(),
    m1::MA.MutableTrait = MA.IsNotMutable(),
    m2::MA.MutableTrait = MA.IsNotMutable(),
) where {T,S}
    return term(
        _coefficient_gcd(coefficient(t1), coefficient(t2)),
        gcd(monomial(t1), monomial(t2)),
    )
end

function shift_deflation(p::AbstractPolynomialLike, v::AbstractVariable)
    shift = -1
    defl = 0
    for mono in monomials(p)
        exp = degree(mono, v)
        if shift == -1
            shift = exp
        elseif exp < shift
            # There are two cases:
            # 1) If `defl[i]` is zero then it means all previous monomials
            #    had degree `shift[i]` so we just set `defl[i]` to
            #    `shift[i] - exp` or equivalently `gcd(0, shift[i] - exp)`.
            # 2) If  `defl[i]` is positive then we have some monomials with
            #    degree `shift[i]` and some with degree
            #    `shift[i] + k * defl[i]` for some `k > 0`. We have
            #    `gcd(shift[i] - exp, shift[i] + k1 * defl[i] - exp, shift[i] + k2 * defl[i] - exp, ...) =`
            #    `gcd(shift[i] - exp, k1 * defl[i], k2 * defl[i], ...)`
            #    Since `gcd(k1, k2, ...) = 1`, this is equal to
            #    `gcd(shift[i] - exp, defl[i])`
            defl = gcd(defl, shift - exp)
            shift = exp
        else
            defl = gcd(defl, exp - shift)
        end
    end
    return shift, defl
end

# Inspired from to `AbstractAlgebra.deflation`
function deflation(p::AbstractPolynomialLike)
    if iszero(p)
        return constant_monomial(p), constant_monomial(p)
    end
    shift_defl = shift_deflation.(p, variables(p))
    shift = getindex.(shift_defl, 1)
    defl = getindex.(shift_defl, 2)
    s = monomial(variables(p), shift)
    d = monomial(variables(p), defl)
    return s, d
end

function _zero_to_one_exp(defl::AbstractMonomial)
    # TODO Make it faster by calling something like `map_exponents`.
    return prod(
        variables(defl) .^ map(d -> iszero(d) ? one(d) : d, exponents(defl)),
    )
end
function deflate(p::AbstractPolynomialLike, shift, defl)
    if isconstant(shift) && all(d -> isone(d) || iszero(d), exponents(defl))
        return p
    end
    q = MA.operate(deflate, p, shift, _zero_to_one_exp(defl))
    return q
end
function inflate(α, shift, defl)
    return inflate(convert(polynomial_type(shift, typeof(α)), α), shift, defl)
end
function inflate(p::AbstractPolynomialLike, shift, defl)
    if isconstant(shift) && all(d -> isone(d) || iszero(d), exponents(defl))
        return p
    end
    q = MA.operate(inflate, p, shift, _zero_to_one_exp(defl))
    return q
end

function MA.operate(::typeof(deflate), mono::AbstractMonomial, shift, defl)
    mutable_mono = map_exponents(-, mono, shift)
    return map_exponents!(div, mutable_mono, defl)
end
function MA.operate(::typeof(inflate), mono::AbstractMonomial, shift, defl)
    mutable_mono = map_exponents(*, mono, defl)
    return map_exponents!(+, mutable_mono, shift)
end

# Inspired from to `AbstractAlgebra.deflate`
function MA.operate(
    op::Union{typeof(deflate),typeof(inflate)},
    p::AbstractPolynomialLike,
    shift,
    defl,
)
    return polynomial(
        coefficients(p),
        map(monomials(p)) do m
            return MA.operate(op, m, shift, defl)
        end,
    )
end

function deflated_gcd(
    p1::_APL{T},
    p2::_APL{S},
    algo,
    m1::MA.MutableTrait,
    m2::MA.MutableTrait,
) where {T,S}
    i1, i2, num_common = _extracted_variable(p1, p2)
    if iszero(i1)
        if iszero(i2)
            return univariate_gcd(p1, p2, algo, m1, m2)
        else
            if isapproxzero(p1)
                return convert(
                    MA.promote_operation(gcd, typeof(p1), typeof(p2)),
                    _copy(p2, m2),
                )
            end
            v2 = variables(p2)[i2]
            q2 = isolate_variable(p2, v2, m2)
            g = content(q2, algo, MA.IsMutable())
            return gcd(p1, g, algo, m1, MA.IsMutable())
        end
    else
        if iszero(i2)
            if isapproxzero(p2)
                return convert(
                    MA.promote_operation(gcd, typeof(p1), typeof(p2)),
                    _copy(p1, m1),
                )
            end
            v1 = variables(p1)[i1]
            q1 = isolate_variable(p1, v1, m1)
            g = content(q1, algo, MA.IsMutable())
            return gcd(g, p2, algo, MA.IsMutable(), m2)
        else
            if num_common > 1
                v1 = variables(p1)[i1]
                @assert v1 == variables(p2)[i2]
                return multivariate_gcd(p1, p2, v1, algo, m1, m2)
            else
                return univariate_gcd(p1, p2, algo, m1, m2)
            end
        end
    end
end

function Base.gcdx(
    p1::_APL{T},
    p2::_APL{S},
    algo::AbstractUnivariateGCDAlgorithm = GeneralizedEuclideanAlgorithm(),
) where {T,S}
    i1, i2, num_common = _extracted_variable(p1, p2)
    R = MA.promote_operation(gcd, typeof(p1), typeof(p2))
    if iszero(i1)
        if iszero(i2)
            return univariate_gcdx(p1, p2, algo)
        else
            if isapproxzero(p1)
                return zero(R), one(R), convert(R, p2)
            end
            error("Not implemented yet")
        end
    else
        if iszero(i2)
            if isapproxzero(p2)
                return one(R), zero(R), convert(R, p1)
            end
            error("Not implemented yet")
        else
            if num_common > 1
                @assert i1 == i2
                error("Not implemented yet")
            else
                return univariate_gcdx(p1, p2, algo)
            end
        end
    end
end

# Returns first element in the union of two decreasing vectors
function _extracted_variable(p1, p2)
    v1 = variables(p1)
    v2 = variables(p2)
    i1 = i2 = 1
    best = nothing
    best_var1 = 0
    best_var2 = 0
    num_common = 0
    while i1 <= length(v1) || i2 <= length(v2)
        if i2 > length(v2) || (i1 <= length(v1) && v1[i1] > v2[i2])
            if !iszero(maxdegree(p1, v1[i1]))
                return i1, 0, num_common
            end
            i1 += 1
        elseif i1 > length(v1) || v2[i2] > v1[i1]
            if !iszero(maxdegree(p2, v2[i2]))
                return 0, i2, num_common
            end
            i2 += 1
        else
            @assert v1[i1] == v2[i2]
            v = v1[i1]
            i1 += 1
            i2 += 1
            d1, n1 = deg_num_leading_terms(p1, v)
            d2, n2 = deg_num_leading_terms(p2, v)
            if iszero(d1)
                if iszero(d2)
                    continue
                else
                    return 0, i2 - 1, num_common
                end
            else
                if iszero(d2)
                    return i1 - 1, 0, num_common
                end
            end
            if d1 < d2
                d1, d2 = d2, d1
                n1, n2 = n2, n1
            end
            # Heuristic used in `AbstractAlgebra`:
            # https://github.com/Nemocas/AbstractAlgebra.jl/blob/4c6b0a366e550df3db84a665de186111bc3cf8ed/src/generic/MPoly.jl#L4347
            # FIXME what is this based on ? Is there any analysis somewhere comparing different heuristics ?
            cur = max(log(n2) * d1 * d2, log(2) * d2)
            if best === nothing || best > cur
                best = cur
                best_var1 = i1 - 1
                best_var2 = i2 - 1
            end
            num_common += 1
        end
    end
    return best_var1, best_var2, num_common
end

function multivariate_gcd(
    p1::_APL,
    p2::_APL,
    var,
    algo,
    m1::MA.MutableTrait,
    m2::MA.MutableTrait,
)
    q1 = isolate_variable(p1, var, m1)
    q2 = isolate_variable(p2, var, m2)
    q = univariate_gcd(q1, q2, algo, MA.IsMutable(), MA.IsMutable())
    P = MA.promote_operation(gcd, typeof(p1), typeof(p2))
    return flatten_variable!(term_type(P), q)::P
end

_vector(t::AbstractVector) = collect(t)
_vector(t::Vector) = t

"""
    isolate_variable(poly::_APL, var::AbstractVariable, mutability::MA.MutableTrait)

Returns a polynomial with variable `var`. The other variables of `poly` are moved as coefficients.

The output can be mutated without affecting `poly` if `mutability` is
`MA.IsNotMutable`.
"""
function isolate_variable(
    poly::_APL,
    var::AbstractVariable,
    mutability::MA.MutableTrait,
)
    old_terms = sort!(
        _vector(terms(_copy(poly, mutability))),
        by = Base.Fix2(degree, var),
    )
    U = MA.promote_operation(
        substitute,
        Subs,
        typeof(poly),
        Pair{typeof(var),Int},
    )
    T = term_type(var, U)
    new_terms = T[]
    i = firstindex(old_terms)
    while i <= lastindex(old_terms)
        j = i + 1
        d = degree(old_terms[i], var)
        while j <= lastindex(old_terms)
            if degree(old_terms[j], var) != d
                break
            end
            j += 1
        end
        coef = _polynomial(
            [subs(old_terms[k], (var,) => (1,)) for k in i:(j-1)],
            SortedUniqState(),
            mutability,
        )
        push!(new_terms, term(coef, var^d))
        i = j
    end
    return polynomial!(new_terms, SortedUniqState())
end

function flatten_variable!(::Type{TT}, poly::_APL) where {TT<:AbstractTerm}
    ts = TT[]
    for t in terms(poly)
        m = monomial(t)
        for _t in terms(coefficient(t))
            push!(ts, _t * m)
        end
    end
    return polynomial!(ts, UniqState())
end

_polynomial(ts, state, ::MA.IsNotMutable) = polynomial(ts, state)
_polynomial(ts, state, ::MA.IsMutable) = polynomial!(ts, state)

"""
    primitive_univariate_gcd!(p::_APL, q::_APL, algo::AbstractUnivariateGCDAlgorithm)

Returns the `gcd` of primitive polynomials `p` and `q` using algorithm `algo`
which is a subtype of [`AbstractUnivariateGCDAlgorithm`](@ref).
The function might modify `p` or `q`.
"""
function primitive_univariate_gcd! end

function not_divided_error(u, v)
    return error(
        "Polynomial `$v` of degree `$(maxdegree(v))` and effective",
        " variables `$(effective_variables(v))` does not divide",
        " polynomial `$u` of degree `$(maxdegree(u))` and effective",
        " variables `$(effective_variables(u))`. Did you call",
        " `univariate_gcd` with polynomials with more than one",
        " variable in common ? If yes, call `gcd` instead, otherwise,",
        " please report this.",
    )
end

# If `p` and `q` do not have the same type then the local variables `p` and `q`
# won't be type stable so we create `u` and `v`.
function primitive_univariate_gcd!(
    p::_APL,
    q::_APL,
    algo::GeneralizedEuclideanAlgorithm,
)
    if maxdegree(p) < maxdegree(q)
        return primitive_univariate_gcd!(q, p, algo)
    end
    R = MA.promote_operation(gcd, typeof(p), typeof(q))
    u = convert(R, p)
    v = convert(R, q)
    while true
        if isapproxzero(v)
            return u
        elseif isconstant(v)
            # `p` and `q` are primitive so if one of them is constant, it cannot
            # divide the content of the other one.
            return MA.operate!(one, u)
        end

        d_before = degree(leading_monomial(u))
        r = MA.operate!(rem_or_pseudo_rem, u, v, algo)
        d_after = degree(leading_monomial(r))
        if d_after == d_before
            not_divided_error(u, v)
        end

        if !algo.primitive_rem
            r = primitive_part(r, algo, MA.IsMutable())::R
        end
        u, v = v, r::R
    end
end

function _pow_no_copy(a, b)
    if isone(b)
        # `a^1` is `copy(a)` but that copy is not needed here
        return a
    else
        return a^b
    end
end

function primitive_univariate_gcd!(
    p::_APL,
    q::_APL,
    algo::SubresultantAlgorithm,
)
    if maxdegree(p) < maxdegree(q)
        return primitive_univariate_gcd!(q, p, algo)
    end
    R = MA.promote_operation(gcd, typeof(p), typeof(q))
    u = convert(R, p)
    v = convert(R, q)
    if isapproxzero(v)
        return primitive_part(u, algo, MA.IsMutable())::R
    elseif isconstant(v)
        # `p` and `q` are primitive so if one of them is constant, it cannot
        # divide the content of the other one.
        return MA.operate!(one, u)
    end
    g = h = nothing # `nothing` means `1`
    while true
        δ = maxdegree(u) - maxdegree(v)
        d_before = degree(leading_monomial(u))
        r = MA.operate!(rem_or_pseudo_rem, u, v, algo)
        if isapproxzero(r)
            return primitive_part(v, algo, MA.IsMutable())::R
        elseif isconstant(r)
            return MA.operate!(one, v)
        end

        d_after = degree(leading_monomial(r))
        if d_after == d_before
            not_divided_error(u, v)
        end
        if !isnothing(g)
            if isnothing(h) # equivalent to `iszero(δ)`
                ghδ = g
            else
                ghδ = g * _pow_no_copy(h, δ)
            end
            if !iszero(algo.skipped_divisions)
                @assert algo.skipped_divisions > 0
                if isnothing(h)
                    # It is an alias to `g`
                    ghδ = MA.copy_if_mutable(ghδ)
                end
                # TODO not sure this works, sometimes it `ghδ` is not a multiple of `leading_coefficient(v)`
                #      we just know it divides the content of `r`, it is not guaranteed to be equal to the content of `r`
                #      We could maybe do better than multiply `r` here though but let's start with this approach as a baseline
                #ghδ = div_multiple(ghδ, _pow_no_copy(leading_coefficient(v), algo.skipped_divisions), MA.IsMutable())
                r = MA.operate!(
                    right_constant_mult,
                    r,
                    _pow_no_copy(
                        leading_coefficient(v),
                        algo.skipped_divisions,
                    ),
                )
            end
            r = right_constant_div_multiple(r, ghδ, MA.IsMutable())::R
        end
        u, v = v, r::R
        g = leading_coefficient(u)
        # Computes `h = h^(1 - δ) * g^δ` (step C3) of [Knu14, Algorithm C p. 429]
        # If `δ` is zero then `h^(1 - δ) * g^δ = h` so there is nothing to do
        if δ == 1
            h = g
        elseif δ > 1
            if isnothing(h) || δ == 2
                # `h^1` is `copy(h)` but that copy is not needed here
                hδ = h
            else
                hδ = h^(δ - 1)
            end
            if isnothing(h)
                h = g
            else
                # We assume that `g^δ` is mutable since `δ > 1`
                h = div_multiple(g^δ, hδ, MA.IsMutable())
            end
        end
    end
end

function primitive_univariate_gcdx(
    u0::_APL,
    v0::_APL,
    algo::GeneralizedEuclideanAlgorithm,
)
    if maxdegree(u0) < maxdegree(v0)
        a, b, g = primitive_univariate_gcdx(v0, u0, algo)
        return b, a, g
    end
    R = MA.promote_operation(gcd, typeof(u0), typeof(v0))
    u = convert(R, u0)
    v = convert(R, v0)
    if isapproxzero(v)
        return one(R), zero(R), u
    elseif isconstant(v)
        # `p` and `q` are primitive so if one of them is constant, it cannot
        # divide the content of the other one.
        return zero(R), one(R), v
    end
    # p * u = q * v + r
    p, q, r = pseudo_divrem(u, v, algo)
    if iszero(q)
        not_divided_error(u, v)
    end
    if iszero(r)
        # Shortcut, does not change the output
        return zero(R), one(R), v
    end
    # TODO
    #if !algo.primitive_rem
    #    r = primitive_part(r, algo)::R
    #end
    # a * v + b * r = g
    # a * v + b * (p * u - q * v) = g
    # b * p * u + (a - b * q) * v = g
    a, b, g = primitive_univariate_gcdx(v, r, algo)
    return p * b, (a - b * q), g
end

function primitive_univariate_gcdx(p::_APL, q::_APL, ::SubresultantAlgorithm)
    return error("Not implemented yet")
end

"""
    univariate_gcd(p1::AbstractPolynomialLike, p2::AbstractPolynomialLike, algo::AbstractUnivariateGCDAlgorithm)

Return the *greatest common divisor* of the polynomials `p1` and `p2` that have
at most one variable in common and for which the coefficients are either
`AbstractFloat` or part of a unique factorization domain, e.g., rational numbers,
integers or multivariate polynomials. So `p1` and `p2` should have at most one
variable in common but their coefficients can be multivariate polynomials that
share arbitrarily many variables.

If the coefficients are not `AbstractFloat`, this
1. separates `p1` and `p2` in their [`content`](@ref) and
   [`primitive_part`](@ref) using [`primitive_part_content`](@ref); see
   [Knu14, Algorithm E: E1, p. 426] or [Knu14, Algorithm C: C1, p. 428].
2. Computes the [`gcd`](@ref) of the contents and primitive parts, using
   [`primitive_univariate_gcd!`](@ref) for primitive parts.
3. Return the product of these two `gcd`; see
   [Knu14, Algorithm E: E4, p. 427] or [Knu14, Algorithm C: C4, p. 429].

[Knu14] Knuth, D.E., 2014.
*Art of computer programming, volume 2: Seminumerical algorithms.*
Addison-Wesley Professional. Third edition.
"""
function univariate_gcd(
    p1::_APL{S},
    p2::_APL{T},
    algo::AbstractUnivariateGCDAlgorithm,
    m1::MA.MutableTrait,
    m2::MA.MutableTrait,
) where {S,T}
    return univariate_gcd(
        _field_absorb(algebraic_structure(S), algebraic_structure(T)),
        p1,
        p2,
        algo,
        m1,
        m2,
    )
end
function univariate_gcd(
    ::UFD,
    p1::_APL,
    p2::_APL,
    algo::AbstractUnivariateGCDAlgorithm,
    m1::MA.MutableTrait,
    m2::MA.MutableTrait,
)
    f1, g1 = primitive_part_content(p1, algo, m1)
    f2, g2 = primitive_part_content(p2, algo, m2)
    pp = primitive_univariate_gcd!(f1, f2, algo)
    gg = _gcd(g1, g2, algo, MA.IsMutable(), MA.IsMutable())#::MA.promote_operation(gcd, typeof(g1), typeof(g2))
    # Multiply each coefficient by the gcd of the contents.
    if !isone(gg)
        MA.operate!(right_constant_mult, pp, gg)
    end
    return pp
end

function univariate_gcd(
    ::Field,
    p1::_APL,
    p2::_APL,
    algo::AbstractUnivariateGCDAlgorithm,
    m1::MA.MutableTrait,
    m2::MA.MutableTrait,
)
    return primitive_univariate_gcd!(_copy(p1, m1), _copy(p2, m2), algo)
end

function univariate_gcdx(
    p1::_APL{S},
    p2::_APL{T},
    algo::AbstractUnivariateGCDAlgorithm,
) where {S,T}
    return univariate_gcdx(
        _field_absorb(algebraic_structure(S), algebraic_structure(T)),
        p1,
        p2,
        algo,
    )
end
function univariate_gcdx(
    ::UFD,
    p1::_APL,
    p2::_APL,
    algo::AbstractUnivariateGCDAlgorithm,
)
    f1, g1 = primitive_part_content(p1, algo, MA.IsNotMutable())
    f2, g2 = primitive_part_content(p2, algo, MA.IsNotMutable())
    a, b, pp = primitive_univariate_gcdx(f1, f2, algo)
    gg = _gcd(g1, g2, algo, MA.IsMutable(), MA.IsMutable())#::MA.promote_operation(gcd, typeof(g1), typeof(g2))
    # Multiply each coefficient by the gcd of the contents.
    return g2 * a,
    g1 * b,
    g1 * g2 * map_coefficients(Base.Fix1(*, gg), pp, nonzero = true)
end
function univariate_gcdx(
    ::Field,
    p1::_APL,
    p2::_APL,
    algo::AbstractUnivariateGCDAlgorithm,
)
    return primitive_univariate_gcdx(p1, p2, algo)
end

_gcd(a::_APL, b::_APL, algo, ma, mb) = gcd(a, b, algo, ma, mb)
_gcd(a, b::_APL, algo, ma, mb) = gcd(a, b, algo, ma, mb)
_gcd(a::_APL, b, algo, ma, mb) = gcd(a, b, algo, ma, mb)
_gcd(a, b, algo, ma, mb) = gcd(a, b)

_simplifier(a::_APL, b::_APL, algo, ma, mb) = gcd(a, b, algo, ma, mb)
_simplifier(a, b, algo, ma, mb) = _gcd(a, b, algo, ma, mb)
# Before Julia v1.4, it is not defined.
# After Julia v1.4, it is defined as `gcd of num / lcm of den`.
# We prefer `gcd of den`, otherwise,
# `1/a0 + 1/a1 x + 1/a2 x^2 + ... + 1/an x^n`
# will be transformed into
# `a1*a2*...*an + a0*a2*...*an x + ...`
# which makes the size of the `BigInt`s grow significantly which slows things down.
function _simplifier(a::Rational, b::Rational, algo, ma, mb)
    return gcd(a.num, b.num) // gcd(a.den, b.den)
end

# Largely inspired from from `YingboMa/SIMDPolynomials.jl`.
function termwise_content(p::_APL, algo, mutability::MA.MutableTrait)
    ts = terms(p)
    length(ts) == 1 && return _copy(first(ts), mutability)
    g = gcd(ts[1], ts[2], algo, mutability, mutability)
    isone(g) || for i in 3:length(ts)
        g = gcd(g, ts[i], algo, MA.IsMutable(), mutability)
        isone(g) && break
    end
    return g
end

"""
    content(poly::AbstractPolynomialLike{T}, algo::AbstractUnivariateGCDAlgorithm, mutability::MA.MutableTrait) where {T}

Return the *content* of the polynomial `poly` over a unique factorization
domain `S` as defined in [Knu14, (3) p. 423].
That is, return the `gcd` of the coefficients of `poly`.
See also [`primitive_part_content`](@ref).

The output can be mutated without affecting `poly` if `mutability` is
`MA.IsNotMutable`.

[Knu14] Knuth, D.E., 2014.
*Art of computer programming, volume 2: Seminumerical algorithms.*
Addison-Wesley Professional. Third edition.
"""
function content(
    poly::_APL{T},
    algo::AbstractUnivariateGCDAlgorithm,
    mutability::MA.MutableTrait,
) where {T}
    P = MA.promote_operation(gcd, T, T)
    coefs = coefficients(poly)
    if isempty(coefs)
        return zero(P)
    end
    if length(coefs) == 1
        return convert(P, _copy(first(coefs), mutability))
    end
    # Largely inspired from from `YingboMa/SIMDPolynomials.jl`.
    if T <: _APL
        for i in eachindex(coefs)
            if nterms(coefs[i]) == 1
                g = _gcd(
                    termwise_content(coefs[1], algo, mutability),
                    termwise_content(coefs[2], algo, mutability),
                    algo,
                    MA.IsMutable(),
                    MA.IsMutable(),
                )
                isone(g) || for i in 3:length(coefs)
                    g = _gcd(
                        g,
                        termwise_content(coefs[i], algo, mutability),
                        algo,
                        MA.IsMutable(),
                        MA.IsMutable(),
                    )
                    isone(g) && break
                end
                return convert(P, g)
            end
        end
    end
    # This is tricky to infer as `content` calls `gcd` which calls `content`, etc...
    # To help Julia break the loop, we annotate the result here.
    g = _gcd(coefs[1], coefs[2], algo, mutability, mutability)::P
    isone(g) || for i in 3:length(coefs)
        g = _simplifier(g, coefs[i], algo, MA.IsMutable(), mutability)::P
        isone(g) && break
    end
    return g::P
end
function content(
    ::_APL{T},
    ::AbstractUnivariateGCDAlgorithm,
    ::MA.MutableTrait,
) where {T<:AbstractFloat}
    return one(T)
end

"""
    primitive_part(poly::AbstractPolynomialLike{T}, algo::AbstractUnivariateGCDAlgorithm) where {T}

Return the *primitive part* of the polynomial `poly` over a unique
factorization domain `S` as defined in [Knu14, (3) p. 423].
That is, return the exact division of `poly` by its [`content`](@ref).
If the content is also needed, call [`primitive_part_content`](@ref)
instead.

[Knu14] Knuth, D.E., 2014.
*Art of computer programming, volume 2: Seminumerical algorithms.*
Addison-Wesley Professional. Third edition.
"""
function primitive_part(
    p::_APL,
    algo::AbstractUnivariateGCDAlgorithm,
    mutability::MA.MutableTrait,
)
    return primitive_part_content(p, algo, mutability)[1]
end
function primitive_part(
    p::_APL{<:AbstractFloat},
    ::AbstractUnivariateGCDAlgorithm,
    ::MA.MutableTrait,
)
    return p
end
function primitive_part(
    p::_APL{<:Complex{<:AbstractFloat}},
    ::AbstractUnivariateGCDAlgorithm,
    ::MA.MutableTrait,
)
    return p
end

"""
    primitive_part_content(poly::AbstractPolynomialLike{T}, algo::AbstractUnivariateGCDAlgorithm) where {T}

Return the *primitive part* and *content* of the polynomial `poly` over a unique
factorization domain `S` as defined in [Knu14, (3) p. 423]. This is more
efficient to call this function rather than calling [`primitive_part`](@ref) and
[`content`](@ref) separately since computing the primitive part requires
computing the content first and this function avoid computing the content twice.

[Knu14] Knuth, D.E., 2014.
*Art of computer programming, volume 2: Seminumerical algorithms.*
Addison-Wesley Professional. Third edition.
"""
function primitive_part_content(
    p,
    algo::AbstractUnivariateGCDAlgorithm,
    mutability::MA.MutableTrait,
)
    g = content(p, algo, MA.IsNotMutable())
    return right_constant_div_multiple(p, g, mutability), g
end

@testset "ComplexPoly" begin
    Mod.@polyvar a
    @test isreal(a)
    @test !isrealpart(a)
    @test !isimagpart(a)
    @test !isconj(a)
    @test ordinary_variable(a) == a
    @test conj(a) == real(a) == a
    @test iszero(imag(a))
    @test isreal(a^3 + 5a^2 + 4a)
    @test !isreal(a^3 + 5im * a^2 + 4a)

    Mod.@complex_polyvar x y
    @test !isreal(x)
    @test !isrealpart(x) &&
          !isrealpart(conj(x)) &&
          isrealpart(real(x)) &&
          !isrealpart(imag(x))
    @test !isimagpart(x) &&
          !isimagpart(conj(x)) &&
          !isimagpart(real(x)) &&
          isimagpart(imag(x))
    @test !isconj(x) && isconj(conj(x)) && !isconj(real(x)) && !isconj(imag(x))
    @test ordinary_variable(conj(x)) ==
          ordinary_variable(real(x)) ==
          ordinary_variable(imag(x)) ==
          ordinary_variable(x)
    @testset "show" begin
        struct SymbolVar <: MP.AbstractVariable end
        struct SymbolConjVar <: MP.AbstractVariable end
        Base.isreal(::Union{SymbolVar,SymbolConjVar}) = false
        MP.name_base_indices(::Union{SymbolVar,SymbolConjVar}) = (:xy, (1, 2))
        MP.isconj(::SymbolConjVar) = true
        @test sprint(show, SymbolVar()) == "xy₁₋₂"
        @test sprint(show, SymbolConjVar()) == "x̅y̅₁₋₂"
    end
    @test conj(x) != x && conj(conj(x)) == x
    @test real(x) == real(conj(x))
    @test imag(conj(x)) == -imag(x)
    @test real(x * conj(x)) == real(x)^2 + imag(x)^2
    @test real(x + conj(x)) == 2real(x)
    @test iszero(imag(x + conj(x)))
    @test iszero(real(x - conj(x)))
    @test imag(x - conj(x)) == 2imag(x)
    @test !isreal(x^3 + 5x^2 + 4x)
    @test isreal(a^3 + 5a^2 + 4a + x^0)
    @test conj(7x^3 + 6y^2 - (3 + im)x + 8a) ==
          7conj(x)^3 + 6conj(y)^2 - (3 - im) * conj(x) + 8a
    @test conj(monomial_vector([x, y, x * y^3, y * x^4])) ==
          monomial_vector([conj(x), conj(y), conj(x * y^3), conj(y * x^4)])
    @test real(x * y^2 * a) ==
          (
        real(x) * real(y)^2 - imag(x) * 2 * real(y) * imag(y) -
        real(x) * imag(y)^2
    ) * a
    @test imag(x * y^2 * a) ==
          (
        imag(x) * real(y)^2 + real(x) * 2 * real(y) * imag(y) -
        imag(x) * imag(y)^2
    ) * a
    herm = [a x+y^2; conj(x)+conj(y)^2 x^2+conj(x)^2]
    @test herm == herm'

    @test degree_complex(x * y^2 * conj(y)^3) == 3
    @test degree_complex(x * y^2 * conj(y)^3, x) == 1
    @test degree_complex(x * y^2 * conj(y)^3, y) == 3
    @test degree_complex(a^5 * x * y^2 * conj(y)^4) == 9
    @test degree_complex(a^5 * x * y^2 * conj(y)^2) == 8
    @test halfdegree(x * y^2 * conj(y^3)) == 3
    @test halfdegree(x * a^5 * conj(y^2)) == 5
    @test halfdegree(x^2 * a^5 * conj(y^2)) == 5
    @test ordinary_variable([x, y, conj(x), a, real(x), imag(y)]) == [x, y, a]

    @test subs(4x + 8y^2 - 6x^3, [x, y] => [2 + 4im, 9 - im]) ==
          (1176 - 32im) * x^0
    # the following are currently not supported by DP (substitution variables may
    # only be the ordinary_variable, not a conjugate or real/imaginary part)
    @test_broken subs(4x + 8y^2 - 6x^3, [x, conj(y)] => [2 + 4im, 9 - im]) ==
                 (1176 + 256im) * x^0
    @test_broken subs(4x + 8y^2 - 6x^3, [x, real(y)] => [2 + 4im, 9])
    @test_broken subs(
        4x + 8y^2 - 6x^3,
        [x, real(y)] => [2 + 4im, 9 + 0 * x^0],
    ) == 1184 + 112im + 144im * imag(y) - 8imag(y)^2

    @testset "Symmetric and Hermitian" begin
        p = a + 1
        P = typeof(p)
        @test LinearAlgebra.symmetric_type(P) == P
        @test LinearAlgebra.issymmetric(p)
        @test LinearAlgebra.symmetric(p, :U) === p
        @test LinearAlgebra.symmetric(p, :L) === p
        @test LinearAlgebra.hermitian_type(P) == P
        @test LinearAlgebra.ishermitian(p)
        @test LinearAlgebra.hermitian(p, :U) === p
        @test LinearAlgebra.hermitian(p, :L) === p
        @test !LinearAlgebra.ishermitian(a + im)
        q = x + 1
        @test !LinearAlgebra.ishermitian(q)
        err = ErrorException(
            "Complex-valued polynomials cannot be interpreted as hermitian scalars",
        )
        @test_throws err LinearAlgebra.hermitian(q, :U)
        @test_throws err LinearAlgebra.hermitian(q, :L)
    end
end

const NonMutable = Union{Int,Float64}
const MP = MultivariatePolynomials
are_independent(::NonMutable, ::NonMutable) = true
are_independent(::BigInt, ::NonMutable) = true
are_independent(::NonMutable, ::BigInt) = true
function are_independent(a::BigInt, b::BigInt)
    return a !== b
end

function are_independent(a::Integer, b::Rational)
    return are_independent(a, b.num) && are_independent(a, b.den)
end

function are_independent(a::Rational, b::Real)
    return are_independent(a.num, b) && are_independent(a.den, b)
end

function are_independent(a::Number, p::MP._APL)
    return all(are_independent(a, coef) for coef in MP.coefficients(p))
end

function are_independent(p::MP._APL, a::Number)
    return are_independent(a, p)
end

function are_independent(p::MP._APL, q::MP._APL)
    for t in terms(p)
        for s in terms(q)
            if !are_independent(coefficient(t), coefficient(s))
                return false
            end
        end
    end
    return true
end

# promoting multiplication is not a good idea
# For example a polynomial of Float64 * a polynomial of JuMP affine expression
# is a polynomial of JuMP affine expression but if we promote it would be a
# polynomial of quadratic expression
for op in [:+, :-, :(==)]
    @eval Base.$op(p1::_APL, p2::_APL) = $op(promote(p1, p2)...)
end
# Promotion between `I` and `1` is `Any`.
# Promotion between `I` and `2I` is `UniformScaling`.
for op in [:+, :-]
    @eval function Base.$op(p1::_APL, p2::_APL{<:LinearAlgebra.UniformScaling})
        return $op(p1, map_coefficients(J -> J.λ, p2, nonzero = true))
    end
    @eval function Base.$op(p1::_APL{<:LinearAlgebra.UniformScaling}, p2::_APL)
        return $op(map_coefficients(J -> J.λ, p1, nonzero = true), p2)
    end
    @eval function Base.$op(
        p1::_APL{<:LinearAlgebra.UniformScaling},
        p2::_APL{<:LinearAlgebra.UniformScaling},
    )
        return $op(map_coefficients(J -> J.λ, p1, nonzero = true), p2)
    end
end

function Base.isapprox(t1::AbstractTermLike, t2::AbstractTermLike; kwargs...)
    return isapprox(coefficient(t1), coefficient(t2); kwargs...) &&
           monomial(t1) == monomial(t2)
end

function Base.isapprox(p1::_APL, p2::_APL; kwargs...)
    return isapprox(promote(p1, p2)...; kwargs...)
end

# @eval $op(p::_APL, α) = $op(promote(p, α)...) would be less efficient
for (op, fun) in [
    (:+, :right_constant_plus),
    (:-, :right_constant_minus),
    (:*, :right_constant_mult),
    (:(==), :right_constant_eq),
]
    @eval Base.$op(p::_APL, α) = $fun(p, α)
end
for (op, fun) in [
    (:+, :left_constant_plus),
    (:-, :left_constant_minus),
    (:*, :left_constant_mult),
    (:(==), :left_constant_eq),
]
    @eval Base.$op(α, p::_APL) = $fun(α, p)
end
## Fix ambiguity between above methods and methods in MA
Base.:+(::MA.Zero, p::_APL) = MA.copy_if_mutable(p)
Base.:+(p::_APL, ::MA.Zero) = MA.copy_if_mutable(p)
Base.:-(::MA.Zero, p::_APL) = MA.operate(-, p)
Base.:-(p::_APL, ::MA.Zero) = MA.copy_if_mutable(p)

# Special case AbstractArrays of _APLs
# We add these instead of relying on the broadcasting API since the above method definitions are very wide.
# In particular, there is support for Matrices as coefficents. In order to avoid issues like #104 we therefore
# explicitly define this (instead of implictly getting unexpected results).
for op in [:+, :-]
    @eval Base.$op(p::_APL, A::AbstractArray{<:_APL}) = map(f -> $op(p, f), A)
    @eval Base.$op(A::AbstractArray{<:_APL}, p::_APL) = map(f -> $op(f, p), A)
end
Base.:*(p::_APL, A::AbstractArray) = map(f -> p * f, A)
Base.:*(A::AbstractArray, p::_APL) = map(f -> f * p, A)
Base.:/(A::AbstractArray, p::_APL) = map(f -> f / p, A)

right_constant_function(::typeof(+)) = right_constant_plus
right_constant_function(::typeof(-)) = right_constant_minus
right_constant_function(::typeof(*)) = right_constant_mult
function MA.operate!(op::Union{typeof(+),typeof(-),typeof(*)}, p::_APL, α)
    return MA.operate!(right_constant_function(op), p, α)
end

MA.operate!(op::typeof(*), α, p::_APL) = MA.operate!(left_constant_mult, α, p)
MA.operate!(op::typeof(*), p::_APL, α) = MA.operate!(right_constant_mult, p, α)
MA.operate!(op::typeof(/), p::_APL, α) = map_coefficients!(Base.Fix2(op, α), p)
function MA.operate_to!(output::AbstractPolynomial, op::typeof(*), α, p::_APL)
    return MA.operate_to!(output, left_constant_mult, α, p)
end
function MA.operate_to!(output::AbstractPolynomial, op::typeof(*), p::_APL, α)
    return MA.operate_to!(output, right_constant_mult, p, α)
end
function MA.operate_to!(output::_APL, op::typeof(/), p::_APL, α)
    return map_coefficients_to!(output, Base.Fix2(op, α), p)
end

function polynomial_merge!(
    n1::Int,
    n2::Int,
    get1::F1,
    get2::F2,
    set::F3,
    push::F4,
    compare_monomials::F5,
    combine::F6,
    keep::F7,
    resize::F8,
    ::Type{term_type} = n1 > 0 ? typeof(get1(1)) :
                        n2 > 0 ? typeof(get2(1)) : Nothing,
) where {F1,F2,F3,F4,F5,F6,F7,F8,term_type}
    buffer = nothing
    i = j = k = 1
    # Invariant:
    # The terms p[0] -> p[k-1] are sorted and are smaller than the remaining terms.
    # The terms p[k] -> p[i-1] are garbage.
    # The terms p[i] -> p[end] are sorted and still need to be added.
    # The terms q[j] -> p[end] are sorted and still need to be added.
    # If `buffer` is not empty:
    #   The terms in `buffer` are sorted and still need to be added.
    #   Moreover, they are smaller than the terms p[i] -> p[end].
    while i <= n1 && j <= n2
        @assert buffer === nothing || isempty(buffer)
        comp = compare_monomials(i, j)
        if comp < 0
            if k == i
                t0 = get1(i)
                if buffer === nothing
                    buffer = DataStructures.Queue{term_type}()
                end
                push!(buffer, t0)
                i += 1
            end
            set(k, get2(j))
            j += 1
            k += 1
        elseif iszero(comp)
            combine(i, j)
            if keep(i)
                if k != i
                    @assert k < i
                    set(k, get1(i))
                end
                k += 1
            end
            i += 1
            j += 1
        else
            if k != i
                set(k, get1(i))
            end
            i += 1
            k += 1
        end
        while buffer !== nothing && !isempty(buffer) && j <= n2
            @assert i == k
            t = first(buffer)
            comp = compare_monomials(t, j)
            if comp <= 0
                if comp < 0
                    t = get2(j)
                else
                    t = combine(t, j)
                end
                j += 1
            end
            if comp >= 0
                popfirst!(buffer)
            end
            # if `comp` is zero, we called `combine` so `t`
            # might not be kept. If `comp` is not zero, we
            # skip the `keep` call that might be costly.
            if iszero(comp) && !keep(t)
                continue
            end
            if k <= n1
                push!(buffer, get1(i))
                set(k, t)
            else
                push(t)
                n1 += 1
            end
            i += 1
            k += 1
        end
    end
    if buffer !== nothing && !isempty(buffer)
        @assert j == n2 + 1
        @assert i == k
        n = length(buffer)
        resize(n1 + n)
        for k in n1:-1:i
            set(k + n, get1(k))
        end
        for k in i:(i+n-1)
            set(k, popfirst!(buffer))
        end
        n1 += n
    else
        len = (k - 1) + (n2 - (j - 1)) + (n1 - (i - 1))
        if n1 < len
            resize(len)
        end
        while j <= n2
            set(k, get2(j))
            j += 1
            k += 1
        end
        @assert j == n2 + 1
        while i <= n1
            set(k, get1(i))
            i += 1
            k += 1
        end
        if len < n1
            resize(len)
        end
        @assert i == n1 + 1
        @assert k == len + 1
    end
    return
end

#MA.operate!(op::Union{typeof(+), typeof(-)}, p::AbstractPolynomial, q::AbstractPolynomial) = MA.operate_to!(p, op, p, q)
function MA.operate!(
    op::Union{typeof(+),typeof(-)},
    p::AbstractPolynomial,
    q::AbstractPolynomialLike,
)
    return MA.operate!(op, p, polynomial(q))
end

function mul_to_terms!(ts::Vector{<:AbstractTerm}, p1::_APL, p2::_APL)
    for t1 in terms(p1)
        for t2 in terms(p2)
            push!(ts, t1 * t2)
        end
    end
    return ts
end
function Base.:*(p::AbstractPolynomial, q::AbstractPolynomial)
    return polynomial!(
        mul_to_terms!(
            MA.promote_operation(*, term_type(p), term_type(q))[],
            p,
            q,
        ),
    )
end

Base.isapprox(p::_APL, α; kwargs...) = isapprox(promote(p, α)...; kwargs...)
Base.isapprox(α, p::_APL; kwargs...) = isapprox(promote(p, α)...; kwargs...)

# `MA.operate(-, p)` redirects to `-p` as it assumes that `-p` can be modified
# through the MA API without modifying `p`. We should either copy the monomial
# here or implement a `MA.operate(-, p)` that copies it. We choose the first
# option.
Base.:-(m::AbstractMonomialLike) = _term(-1, MA.copy_if_mutable(m))
Base.:-(t::AbstractTermLike) = _term(MA.operate(-, coefficient(t)), monomial(t))
Base.:-(p::_APL) = map_coefficients(-, p)
Base.:+(p::Union{_APL,RationalPoly}) = p
Base.:*(p::Union{_APL,RationalPoly}) = p

# Avoid adding a zero constant that might artificially increase the Newton polytope
# Need to add polynomial conversion for type stability
function right_constant_plus(p::_APL{S}, α::T) where {S,T}
    return iszero(α) ? polynomial(p, MA.promote_operation(+, S, T)) :
           p + constant_term(α, p)
end
function left_constant_plus(α::S, p::_APL{T}) where {S,T}
    return iszero(α) ? polynomial(p, MA.promote_operation(+, S, T)) :
           constant_term(α, p) + p
end
function MA.operate!(::typeof(right_constant_plus), p::_APL, α)
    if !iszero(α)
        MA.operate!(+, p, constant_term(α, p))
    end
    return p
end
function right_constant_minus(p::_APL{S}, α::T) where {S,T}
    return iszero(α) ? polynomial(p, MA.promote_operation(-, S, T)) :
           p - constant_term(α, p)
end
function left_constant_minus(α::S, p::_APL{T}) where {S,T}
    return iszero(α) ? polynomial(-p, MA.promote_operation(-, S, T)) :
           constant_term(α, p) - p
end
function MA.operate!(::typeof(right_constant_minus), p::_APL, α)
    if !iszero(α)
        MA.operate!(-, p, constant_term(α, p))
    end
    return p
end

# Coefficients and variables commute
left_constant_mult(α, v::AbstractMonomial) = term_type(v, typeof(α))(α, v)
left_constant_mult(α, v::AbstractVariable) = left_constant_mult(α, monomial(v)) # TODO linear term
right_constant_mult(m::AbstractMonomialLike, α) = left_constant_mult(α, m)

function left_constant_mult(α, p::AbstractPolynomialLike)
    return map_coefficients(Base.Fix1(*, α), p)
end
function right_constant_mult(p::AbstractPolynomialLike, α)
    return map_coefficients(Base.Fix2(*, α), p)
end

function MA.operate_to!(output, ::typeof(left_constant_mult), α, p::_APL)
    return map_coefficients_to!(output, Base.Fix1(*, α), p)
end
function MA.operate_to!(output, ::typeof(right_constant_mult), p::_APL, α)
    return map_coefficients_to!(output, Base.Fix2(*, α), p)
end
function MA.operate!(::typeof(left_constant_mult), α, p::_APL)
    return map_coefficients!(Base.Fix1(*, α), p)
end
function MA.operate!(::typeof(right_constant_mult), p::_APL, α)
    return map_coefficients!(Base.Fix2(MA.mul!!, α), p)
end

function MA.operate_to!(
    output::AbstractMonomial,
    ::typeof(*),
    m1::AbstractMonomialLike,
    m2::AbstractMonomialLike,
)
    return map_exponents_to!(output, +, m1, m2)
end
function MA.operate!(
    ::typeof(*),
    m1::AbstractMonomial,
    m2::AbstractMonomialLike,
)
    return map_exponents!(+, m1, m2)
end
function Base.:*(m1::AbstractMonomialLike, m2::AbstractMonomialLike)
    return map_exponents(+, m1, m2)
end
#Base.:*(m1::AbstractMonomialLike, m2::AbstractMonomialLike) = *(monomial(m1), monomial(m2))

function Base.:*(m::AbstractMonomialLike, t::AbstractTermLike)
    return left_constant_mult(coefficient(t), m * monomial(t))
end
function Base.:*(t::AbstractTermLike, m::AbstractMonomialLike)
    return left_constant_mult(coefficient(t), monomial(t) * m)
end
function Base.:*(t1::AbstractTermLike, t2::AbstractTermLike)
    return left_constant_mult(
        coefficient(t1) * coefficient(t2),
        monomial(t1) * monomial(t2),
    )
end

function MA.operate!(::typeof(*), p::_APL, t::AbstractMonomialLike)
    return map_exponents!(+, p, t)
end
Base.:*(p::_APL, t::AbstractMonomialLike) = map_exponents(+, p, t)
Base.:*(t::AbstractTermLike, p::_APL) = polynomial!(map(te -> t * te, terms(p)))
Base.:*(p::_APL, t::AbstractTermLike) = polynomial!(map(te -> te * t, terms(p)))
Base.:*(p::_APL, q::_APL) = polynomial(p) * polynomial(q)

# guaranteed that monomial(t1) > monomial(t2)
function _polynomial_2terms(
    t1::TT,
    t2::TT,
    ::Type{T},
) where {TT<:AbstractTerm,T}
    if iszero(t1)
        polynomial(t2, T)
    elseif iszero(t2)
        polynomial(t1, T)
    else
        # not `polynomial!` because we `t1` and `t2` cannot be modified
        polynomial(term_type(TT, T)[t1, t2], SortedUniqState())
    end
end

_term(α, mono) = term(α, MA.copy_if_mutable(mono))

for op in [:+, :-]
    @eval begin
        function Base.$op(t1::AbstractTermLike, t2::AbstractTermLike)
            return $op(term(t1), term(t2))
        end
        function Base.$op(t1::AbstractTerm, t2::AbstractTerm)
            return $op(_promote_terms(t1, t2)...)
        end
        function Base.$op(t1::TT, t2::TT) where {T,TT<:AbstractTerm{T}}
            S = MA.promote_operation($op, T, T)
            # t1 > t2 would compare the coefficient in case the monomials are equal
            # and it will throw a MethodError in case the coefficients are not comparable
            if monomial(t1) == monomial(t2)
                return polynomial(
                    _term($op(coefficient(t1), coefficient(t2)), monomial(t1)),
                    S,
                )
            elseif monomial(t1) < monomial(t2)
                return _polynomial_2terms(t1, $op(t2), S)
            else
                return _polynomial_2terms($op(t2), t1, S)
            end
        end
    end
end
_promote_terms(t1, t2) = promote(t1, t2)
# Promotion between `I` and `1` is `Any`.
function _promote_terms(
    t1::AbstractTerm,
    t2::AbstractTerm{<:LinearAlgebra.UniformScaling},
)
    return _promote_terms(t1, coefficient(t2).λ * monomial(t2))
end
function _promote_terms(
    t1::AbstractTerm{<:LinearAlgebra.UniformScaling},
    t2::AbstractTerm,
)
    return _promote_terms(coefficient(t1).λ * monomial(t1), t2)
end
# Promotion between `I` and `2I` is `UniformScaling`, not `UniformScaling{Int}`.
function _promote_terms(
    t1::AbstractTerm{LinearAlgebra.UniformScaling{S}},
    t2::AbstractTerm{LinearAlgebra.UniformScaling{T}},
) where {S<:Number,T<:Number}
    U = LinearAlgebra.UniformScaling{promote_type(S, T)}
    return _promote_terms(
        MA.scaling_convert(U, coefficient(t1)) * monomial(t1),
        MA.scaling_convert(U, coefficient(t2)) * monomial(t2),
    )
end
function _promote_terms(
    t1::AbstractTerm{LinearAlgebra.UniformScaling{T}},
    t2::AbstractTerm{LinearAlgebra.UniformScaling{T}},
) where {T<:Number}
    return promote(t1, t2)
end

LinearAlgebra.adjoint(v::AbstractVariable) = conj(v)
LinearAlgebra.adjoint(m::AbstractMonomial) = conj(m)
function LinearAlgebra.adjoint(t::AbstractTerm)
    return _term(adjoint(coefficient(t)), adjoint(monomial(t)))
end
function LinearAlgebra.adjoint(p::AbstractPolynomialLike)
    return polynomial(map(LinearAlgebra.adjoint, terms(p)))
end
function LinearAlgebra.adjoint(r::RationalPoly)
    return adjoint(numerator(r)) / adjoint(denominator(r))
end
LinearAlgebra.hermitian_type(::Type{T}) where {T<:AbstractPolynomialLike} = T
function LinearAlgebra.hermitian(v::AbstractPolynomialLike, ::Symbol)
    isreal(v) || error(
        "Complex-valued polynomials cannot be interpreted as hermitian scalars",
    )
    return v
end
# This is the same implementation as `LinearAlgebra.ishermitian(::Number)`
LinearAlgebra.ishermitian(p::AbstractPolynomialLike) = p == conj(p)

LinearAlgebra.transpose(v::AbstractVariable) = v
LinearAlgebra.transpose(m::AbstractMonomial) = m
function LinearAlgebra.transpose(t::AbstractTerm)
    return _term(LinearAlgebra.transpose(coefficient(t)), monomial(t))
end
function LinearAlgebra.transpose(p::AbstractPolynomialLike)
    return polynomial(map(LinearAlgebra.transpose, terms(p)))
end
function LinearAlgebra.transpose(r::RationalPoly)
    return transpose(numerator(r)) / transpose(denominator(r))
end

function LinearAlgebra.dot(
    p1::AbstractPolynomialLike,
    p2::AbstractPolynomialLike,
)
    return p1' * p2
end
LinearAlgebra.dot(x, p::AbstractPolynomialLike) = x' * p
LinearAlgebra.dot(p::AbstractPolynomialLike, x) = p' * x

LinearAlgebra.symmetric_type(PT::Type{<:_APL}) = PT
LinearAlgebra.symmetric(p::_APL, ::Symbol) = p
LinearAlgebra.issymmetric(::_APL) = true

# Amazingly, this works! Thanks, StaticArrays.jl!
"""
Convert a tuple of variables into a static vector to allow array-like usage.
The element type of the vector will be Monomial{vars, length(vars)}.
"""
Base.vec(vars::Tuple{Vararg{AbstractVariable}}) = [vars...]
# vec(vars::Tuple{Vararg{TypedVariable}}) = SVector(vars)

# https://github.com/JuliaLang/julia/pull/23332
Base.:^(x::AbstractPolynomialLike, p::Integer) = Base.power_by_squaring(x, p)

function MA.operate_to!(
    output::AbstractPolynomial,
    op::MA.AddSubMul,
    x,
    args::Vararg{Any,N},
) where {N}
    return MA.operate_to!(output, MA.add_sub_op(op), x, *(args...))
end
function MA.operate!(
    op::MA.AddSubMul,
    x::AbstractPolynomial,
    y,
    z,
    args::Vararg{Any,N},
) where {N}
    return MA.operate!(MA.add_sub_op(op), x, *(y, z, args...))
end
function MA.buffer_for(
    ::MA.AddSubMul,
    ::Type{<:AbstractPolynomial},
    args::Vararg{Type,N},
) where {N}
    return zero(MA.promote_operation(*, args...))
end
function MA.buffered_operate_to!(
    buffer::AbstractPolynomial,
    output::AbstractPolynomial,
    op::MA.AddSubMul,
    x::AbstractPolynomial,
    y,
    z,
    args::Vararg{Any,N},
) where {N}
    product = MA.operate_to!!(buffer, *, y, z, args...)
    return MA.operate_to!(output, MA.add_sub_op(op), x, product)
end
function MA.buffered_operate!(
    buffer,
    op::MA.AddSubMul,
    x::AbstractPolynomial,
    y,
    z,
    args::Vararg{Any,N},
) where {N}
    product = MA.operate_to!!(buffer, *, y, z, args...)
    return MA.operate!(MA.add_sub_op(op), x, product)
end

using Test
import Test: @inferred

import MutableArithmetics as MA

@testset "Substitution" begin
    Mod.@polyvar x[1:3]

    @test subs(2, x[1] => 3) == 2
    @test iszero((x[1] - x[1])(x[1] => x[2]))
    @test subs(CustomPoly(x[1] + x[2]), x[2] => x[1]) == 2x[1]

    a = (x[1])(x[1] => x[2])
    b = x[2]
    @test (x[1])(x[1] => x[2]) == x[2]

    p = x[1] * x[2] * x[3]
    @test convert(Int, p(x => (1, 2, 3))) == 6

    p = x[1]^2 + x[1] * x[3] - 3
    @test convert(Int, p(x => (5, x[1] * x[2], 4))) == 42

    p = x[1]^2 + x[2]^2
    q = p(x[1:2] => [1 -1; 1 1] * vec(x[1:2]))
    @test q == 2p

    t = 2.0 * x[1] * x[2]^2
    @test t(x => [1, 2, 3]) == 8.0
    @test t((x[2], x[1]) => [1, 3]) == 6.0

    p = x[1] + x[2] + 2 * x[1]^2 + 3 * x[1] * x[2]^2
    #@inferred p((x[1], x[2]) => (1.0, 2.0))

    m = x[1] * x[2]
    @inferred subs(m, x[2] => 2.0)
    @inferred subs(p, x[2] => 2.0)
    @test subs(p, x[2] => 2.0) == 13x[1] + 2 + 2x[1]^2
    @inferred subs(p, x[2] => x[1])
    @inferred subs(p, x[2] => x[1]) == 2x[1] + 2x[1]^2 + 3x[1]^3

    p = x[1] - x[1]
    @test iszero(p)
    @inferred p(x[1] => 1)
    @test iszero(p(x[1] => 1))
    @inferred subs(p, x[1] => 1)
    @test iszero(subs(p, x[1] => 1))

    # https://github.com/JuliaAlgebra/DynamicPolynomials.jl/issues/141
    @test subs(x[1]^2 + x[2]^2, x[1] => x[3]^2) == x[2]^2 + x[3]^4

    q = (x[1] + 1) / (x[1] + 2)
    @test isapproxzero(q(x[1] => -1))
    @test !isapproxzero(q(x[1] => 1))
    @test q(x[1] => 1) ≈ 2 / 3

    q = (x[1] + x[3]) / (x[2] - 1)
    @test subs(q, x[1:2] => (x[2], x[1])) == (x[2] + x[3]) / (x[1] - 1)

    # Taken from perf/runbenchmark.jl
    p = x[1] + x[2] + 2x[1]^2 + x[2]^3

    varst = (x[1], x[2])
    varsv = [x[1], x[2]]
    valst = (1.0, 2.0)
    valsv = [1.0, 2.0]

    @test variable.(Tuple(varsv)) == varst
    @test variable.(Tuple(varsv)) isa
          Tuple{<:AbstractVariable,<:AbstractVariable}

    @test p(variables(p) => valst) == 13
    @test p(variables(p) => valsv) == 13
    @test p(varst => valst) == 13
    @test p(varsv => valsv) == 13

    @testset "Eval on constant monomial" begin
        m = constant_monomial(prod(x))
        mr = m(x => reverse(x))
        @test isconstant(mr)
        @test variables(mr) == x
    end

    Mod.@polyvar x y
    @test subs([x^2 + y, x + y], x => y) == [y^2 + y, 2y]

    @testset "Subs with no variables" begin
        Mod.@polyvar x
        t = convert(term_type(x, Int), 3)
        @test t == @inferred subs(t, x => x + 1)
        @test t == @inferred subs(t, x => x + 1.0)
        @test t == @inferred subs(t, x => 1x)
        @test t == @inferred subs(t, x => 1.0x)
        @test t == @inferred subs(t, x => 1.0)
    end

    for (p, s) in [(x^1, x => 2x)]
        @test MA.promote_operation(substitute, Subs, typeof(p), typeof(s)) ==
              typeof(subs(p, s))
    end

    @testset "Issue #302 $T" for T in [BigFloat, BigInt]
        Mod.@polyvar x[1:3]
        t = T(1) * x[1]
        @test copy(t).coefficient !== t.coefficient
        @test MA.mutable_copy(t).coefficient !== t.coefficient
        F = T(5) * x[1] * x[2] * x[3] + T(1) * x[1] * x[2]^2
        @test subs(F, x[3] => T(0)) == x[1] * x[2]^2
        @test subs(F, x[3] => 0) == x[1] * x[2]^2
    end
end

Base.copy(x::AbstractVariable) = x

"""
    variable_union_type(p::AbstractPolynomialLike)

Return the supertype for variables of `p`. If `p` is a variable, it should not
be the type of `p` but the supertype of all variables that could be created.

### Examples

For `TypedPolynomials`, a variable of name `x` has type `Variable{:x}` so
`variable_union_type` should return `Variable`.
For `DynamicPolynomials`, all variables have the same type `Variable{C}` where
`C` is `true` for commutative variables and `false` for non-commutative ones so
`variable_union_type` should return `Variable{C}`.
"""
function variable_union_type end
function variable_union_type(::Type{MT}) where {MT<:AbstractMonomialLike}
    return error("`variable_union_type` not implemented for $MT.")
end
function variable_union_type(::Type{PT}) where {PT<:_APL}
    return variable_union_type(monomial_type(PT))
end
variable_union_type(p::_APL) = variable_union_type(typeof(p))

"""
    variable(p::AbstractPolynomialLike)

Converts `p` to a variable. Throws `InexactError` if it is not possible.

### Examples

Calling `variable(x^2 + x - x^2)` should return the variable `x` and
calling `variable(1.0y)` should return the variable `y` however calling
`variable(2x)` or `variable(x + y)` should throw `InexactError`.

### Note

This operation is not type stable for the TypedPolynomials implementation if `nvariables(p) > 1` but is type stable for DynamicPolynomials.
"""
variable(t::_APL) = convert(variable_union_type(t), t)

"""
    is_commutative(::Type{<:AbstractVariable})::Bool

Returns whether variables of the given type are commutative, i.e., whether
`x * y == y * x`.
"""
function is_commutative end
function is_commutative(
    ::Type{P},
) where {P<:Union{AbstractTerm,AbstractPolynomial}}
    return is_commutative(monomial_type(P))
end
is_commutative(p::_APL) = is_commutative(typeof(p))
is_commutative(v::AbstractVector) = is_commutative(eltype(v))
is_commutative(::Type{V}) where {V<:AbstractVector} = is_commutative(eltype(V))
is_commutative(v::Tuple) = all(is_commutative, v)
# Recursive dispatch allows the compiler to constant-fold for concrete Tuple types,
# enabling type-stable branches on `is_commutative(V)` in downstream packages.
is_commutative(::Type{Tuple{}}) = true
function is_commutative(::Type{T}) where {T<:Tuple}
    return is_commutative(Base.tuple_type_head(T)) &&
           is_commutative(Base.tuple_type_tail(T))
end

"""
    name(v::AbstractVariable)::AbstractString

Returns the name of a variable.
"""
function name end

"""
    name_base_indices(v::AbstractVariable)

Returns the name of the variable (as a `String` or `Symbol`) and its indices
as a `Vector{Int}` or tuple of `Int`s.
"""
function name_base_indices end

"""
    similar_variable(p::AbstractPolynomialLike, variable::Type{Val{V}})

Creates a new variable `V` based upon the the given source polynomial.

    similar_variable(p::AbstractPolynomialLike, v::Symbol)

Creates a new variable based upon the given source polynomial and the given symbol `v`. Note
that this can lead to type instabilities.

### Examples

Calling `similar_variable(typedpoly, Val{:x})` on a polynomial created with `TypedPolynomials`
results in `TypedPolynomials.Variable{:x}`.
"""
function similar_variable end

function similar_variable(
    v::Union{AbstractVariable,Type{<:AbstractVariable}},
    s::Symbol,
)
    return similar_variable(v, Val{s})
end
function similar_variable(
    p::Union{AbstractPolynomialLike,Type{<:AbstractPolynomialLike}},
    s,
)
    return similar_variable(variable_union_type(p), s)
end

"""
    @similar_variable(p::AbstractPolynomialLike, variable)

Calls `similar_variable(p, Val{variable})` and binds the result to a variable with the same
name.

### Examples

Calling `@similar_variable typedpoly x` on a polynomial created with `TypedPolynomials`
binds `TypedPolynomials.Variable{:x}` to the variable `x`.
"""
macro similar_variable(p, name)
    return Expr(:block, _assign_new_variable(p, name))
end

function _new_variable(p, name::Symbol)
    return :(similar_variable($p, Val{$(esc(Expr(:quote, name)))}))
end
function _assign_new_variable(f, name::Symbol)
    return :($(esc(name)) = $(_new_variable(:($(esc(f))), name)))
end

function LinearAlgebra.det(M::Matrix{<:AbstractPolynomialLike})
    m = size(M)[1]
    if m > 2
        return sum(
            (-1)^(i - 1) * M[i, 1] * LinearAlgebra.det(M[1:end .!= i, 2:end])
            for i in 1:m
        )
    elseif m == 2
        return M[1, 1] * M[2, 2] - M[2, 1] * M[1, 2]
    else
        return M[1, 1]
    end
end

@testset "Non-commutative Monomial" begin
    Mod.@ncpolyvar x
    X_ = constant_monomial(typeof(x))
    @test nvariables(X_) == 0
    @test isempty(X_.vars)
    @test isempty(X_.z)
    X0 = constant_monomial(x)
    for Y in [x^0, X0]
        @test nvariables(Y) == 1
        @test variables(Y)[1] == x
        @test collect(exponents(Y)) == [0]
    end
    for X in [X_, X0]
        for Y in [monomial(x), x^1, x * X, X * x]
            @test nvariables(Y) == 1
            @test variables(Y)[1] == x
            @test collect(exponents(Y)) == [1]
        end
    end
    for X in [X_, X0]
        for Y in [x^2, X * x^2, x^2 * X]
            @test nvariables(Y) == 1
            @test variables(Y)[1] == x
            @test collect(exponents(Y)) == [2]
        end
    end
    @testset "Issue #148" begin
        Mod.@ncpolyvar x y z
        m = x * y^4 * x^2
        @test 3 == @inferred degree(m, x)
        @test 4 == @inferred degree(m, y)
        @test 0 == @inferred degree(m, z)
    end
    @testset "Issue #71 of DynamicPolynomials" begin
        Mod.@ncpolyvar x y
        @test x^0 * y == y * x^0
    end
end
@testset "Non-commutative MonomialVector" begin
    v = Mod.@ncpolyvar x y
    @test_throws ArgumentError monomials(v, -1)
    @test_throws ArgumentError monomials(v, -1:1)
    @test_throws ArgumentError monomials(v, [1, -1])
    X = empty_monomial_vector(typeof(x))
    @test iszero(nvariables(X))
    @test isempty(variables(X))
    X = empty_monomial_vector(x)
    @test nvariables(X) == 1
    @test variables(X)[1] == x
    X = monomial_vector([y, x])
    @test X[1] == y
    @test X[2] == x
    # `variables` may return `[x, y, x, y]` if the polynomial has, e.g., the monomial `x * y * x * y`.
    X = monomials([y, x, y, x, y], 0:2)
    Y = monomials([x, y], 2)
    for M in [X, Y]
        @test variables(X)[1] == x
        @test variables(X)[2] == y
        @test variables(X)[3] == x
        @test collect(exponents(X[7])) == [2, 0, 0]
        @test collect(exponents(X[6])) == [1, 1, 0]
        @test collect(exponents(X[5])) == [0, 2, 0]
        @test collect(exponents(X[4])) == [0, 1, 1]
    end
    @test collect(exponents(X[3])) == [1, 0, 0]
    @test collect(exponents(X[2])) == [0, 1, 0]
    @test collect(exponents(X[1])) == [0, 0, 0]
    X0 = [x^3, x^2 * y, x * y^2, x * y * x, y^3, y^2 * x, y * x^2, y * x * y]
    X1 = monomials([x, y], 3)
    X2 = monomial_vector(X0)
    Z = reverse([
        [3, 0, 0, 0],
        [2, 1, 0, 0],
        [1, 2, 0, 0],
        [1, 1, 1, 0],
        [0, 3, 0, 0],
        [0, 2, 1, 0],
        [0, 1, 2, 0],
        [0, 1, 1, 1],
    ])
    @test X1 isa AbstractVector{<:AbstractMonomial}
    @test X2 isa AbstractVector{<:AbstractMonomial}
    @test length(X1) == length(X2) == length(Z)
    @test issorted(X1)
    @test issorted(X2)
    @test X1 == X0
    for i in eachindex(Z)
        @test variables(X1[i])[1] == variables(X2[i])[1] == x
        @test variables(X1[i])[2] == variables(X2[i])[2] == y
        @test variables(X1[i])[3] == variables(X2[i])[3] == x
        @test variables(X1[i])[4] == variables(X2[i])[4] == y
        @test collect(exponents(X1[i])) == collect(exponents(X2[i])) == Z[i]
    end
end
@testset "is_commutative" begin
    function _is_comm_test(p)
        @test !MP.is_commutative(p)
        @test !MP.is_commutative(typeof(p))
    end
    Mod.@ncpolyvar x y[1:2]
    _is_comm_test(x)
    _is_comm_test(y)
    _is_comm_test(x^2)
    _is_comm_test(2x^2)
    _is_comm_test(sum(y))
end

import MultivariatePolynomials: pair_zip, tuple_zip

@testset "zip tests" begin
    @testset "pair_zip" begin
        Mod.@polyvar x y z

        @test @inferred(pair_zip((x, y), (1, 2))) == (x => 1, y => 2)
        @test_throws ArgumentError pair_zip((x, y, z), (1, 2))
        @test_throws ArgumentError pair_zip((x, y), (1, 2, 3))
        @test @inferred(pair_zip((1, :x, r"x"), ("w", 1.0, +))) ==
              (1 => "w", :x => 1.0, r"x" => +)
        @test @inferred(pair_zip((1, :x, r"x") => ("w", 1.0, +))) ==
              (1 => "w", :x => 1.0, r"x" => +)
    end

    @testset "tuple_zip" begin
        Mod.@polyvar x y z

        @test @inferred(tuple_zip((x, y), (1, 2))) == ((x, 1), (y, 2))
        @test_throws ArgumentError tuple_zip((x, y, z), (1, 2))
        @test_throws ArgumentError tuple_zip((x, y), (1, 2, 3))
        @test @inferred(tuple_zip((1, :x, r"x"), ("w", 1.0, +))) ==
              ((1, "w"), (:x, 1.0), (r"x", +))
    end
end

using Test
using LinearAlgebra
import MutableArithmetics as MA
using MultivariatePolynomials
const MP = MultivariatePolynomials
@testset "Polynomial" begin
    Mod.@polyvar x

    @test terms(polynomial([1, x^2, x, 2x^2])) == [1, x, 3x^2]
    @test terms(polynomial([x, 3x^4, 2], MP.UniqState())) == [2, x, 3x^4]
    @test terms(
        polynomial([-2, 2, x, x^2, -2x^2, x^2, x^3, 2x^3], MP.SortedState()),
    ) == [x, 3x^3]

    @test polynomial(1 + x) == 1 + x
    @test leading_term(1 + x) == x
    @test leading_term(x - x) == 0
    @test leading_monomial(x - x) == 1
    @test leading_coefficient(x - x) == 0
    @test one(1 + x) == one(1.0 + x) == 1
    @test zero(1 + x) == zero(1.0 + x) == 0
    @test 1 != 1 + x
    @test 2x == x + x^2 + x - x^2
    @test x + x^2 - x^2 - x != 2x
    @test x^2 + x != x^2 + x + 1
    #@inferred one(1 + x)
    @inferred zero(1 + x)
    #@inferred one(1.0 + x)
    @inferred zero(1.0 + x)

    @test polynomial(1:2, [x, x^2]) == x + 2x^2
    @test polynomial(1:2, monomials(x, 1:2)) == x + 2x^2

    @test terms(polynomial(1 + x + x^2 - x + x^2)) == [1, 2x^2]
    @test terms(CustomPoly(1 + x + x^2 - x + x^2)) == [1, 2x^2]

    @test (1.0 + x) * x == x^2 + x
    @test constant_term(1, x) * (1 - x) == 1 - x
    @test promote_type(typeof(1 - x), typeof(x)) <: AbstractPolynomial{Int}
    @test x != 1 - x

    @test term(x + x^2 - x) isa AbstractTerm
    @test term(x + x^2 - x) == x^2
    @test term(x - x) isa AbstractTerm
    @test iszero(term(x - x))
    @test_throws InexactError term(x + x^2)

    Mod.@polyvar y

    p = 3x^2 * y^4 + 2x
    @test +(p) === p
    @test *(p) === p
    @test terms(p)[1] == 2x
    @test terms(p)[end] == 3x^2 * y^4
    typetests(p)
    typetests([p, x + y])
    @test (@inferred polynomial(p)) isa AbstractPolynomial{Int}
    @test (@inferred polynomial(p, Float64)) isa AbstractPolynomial{Float64}

    @test coefficient(2x + 4y^2 + 3, y^2) == 4
    @test coefficient(2x + 4y^2 + 3, x^2) == 0

    Mod.@polyvar a b
    @test coefficient((2a + b)x^2 + 2y^2 + 3, x^2, (x, y)) == 2a + b
    @test coefficient((2a + b)x^2 + 2y^2 + 3x^2 * y, x^2, (x,)) == 2a + b + 3y

    @test (@inferred 2x^2 * y + 0.0x * y) == 2x^2 * y
    @test (@inferred 0.0x^2 * y + 3x * y) == 3x * y

    @test iszero(((x + x) - 2x) * (x * (x^2 + y^2)))

    @test Tuple(variables([x + 1, y^2])) == (x, y)
    @test Tuple(variables([y^2, x + 1])) == (x, y)

    p = x^2 - x^2
    @test maxdegree(p) == 0
    @test maxdegree(p, x) == 0
    @test maxdegree(p, y) == 0
    @test mindegree(p) == 0
    @test mindegree(p, x) == 0
    @test mindegree(p, y) == 0
    @test extdegree(p) == (0, 0)
    @test extdegree(p, x) == (0, 0)
    @test extdegree(p, y) == (0, 0)
    q = x * y + 2 + x^2 * y + x + y
    @test maxdegree(q) == 3
    @test maxdegree(q, x) == 2
    @test maxdegree(q, y) == 1
    @test mindegree(q) == 0
    @test mindegree(q, x) == 0
    @test mindegree(q, y) == 0
    @test extdegree(q) == (0, 3)
    @test extdegree(q, x) == (0, 2)
    @test extdegree(q, y) == (0, 1)
    r = x * y + x^2 * y
    @test extdegree(r, x) == (1, 2)
    @test extdegree(r, y) == (1, 1)
    @test leading_term(q) == x^2 * y
    @test nvariables(x + y - x) == 2
    @test nvariables(x + x^2) == 1
    @test mindegree([p, q, r]) == 0
    @test mindegree([p, q, r], x) == 0
    @test mindegree([p, q, r], y) == 0
    @test mindegree([p, q], y) == 0
    @test mindegree([q], y) == 0
    @test mindegree([r], y) == 1
    @test maxdegree([p, q, r]) == 3
    @test maxdegree([p, q, r], x) == 2
    @test maxdegree([p, q, r], y) == 1
    @test extdegree([p, q, r]) == (0, 3)
    @test extdegree([p, q, r], x) == (0, 2)
    @test extdegree([p, q, r], y) == (0, 1)

    @test collect(
        coefficients(
            x * y + 2 + 3x^2 * y + 4x + 6y,
            [x, x * y^2, x * y, x^2 * y, y, x^3],
        ),
    ) == [4, 0, 1, 3, 6, 0]

    # Doc examples
    @test collect(coefficients(4x^2 * y + x * y + 2x)) == [2, 1, 4]
    @test collect(coefficients(4x^2 * y + x * y + 2x + 3, [x, 1, x * y, y])) ==
          [2, 3, 1, 0]
    @test monomials(4x^2 * y + x * y + 2x + 3)[1:1] ==
          [constant_monomial(x * y)]

    for p in [polynomial([4, 9], [x, x * x]), polynomial([9, 4], [x * x, x])]
        @test collect(coefficients(p)) == [4, 9]
        @test monomials(p)[1] == x
        @test monomials(p)[2] == x^2
        @test monomials(p)[1:2][1] == x
        @test monomials(p)[1:2][2] == x^2
        @test p == dot([4, 9], [x, x * x])
    end

    @inferred polynomial(i -> float(i), [x, x * x])
    @inferred polynomial(i -> 3 - float(i), monomial_vector([x * x, x]))
    for p in [
        polynomial(i -> float(i), [x, x * x]),
        polynomial(i -> 1.0, [x * x, x, x * x]),
        polynomial(i -> float(i), monomial_vector([x * x, x])),
    ]
        @test collect(coefficients(p)) == [1.0, 2.0]
        @test collect(monomials(p)) == monomial_vector([x, x^2])
    end

    @test (x + y)' == x + y
    @test transpose(x + y) == x + y
    @test transpose([1 2; 3 4] * x) == [1 3; 2 4] * x

    p = 4x^2 * y + x * y + 2x
    @test remove_monomials(p, [x * y]) == 4x^2 * y + 2x
    @test filter_terms(OfDegree(2), 4x^2 * y + x * y + 2x) == x * y
    @test filter_terms(!OfDegree(2), 4x^2 * y + x * y + 2x) == 4x^2 * y + 2x
    @test filter_terms(iseven ∘ MP.coefficient, 4x^2 * y + x * y + 2x) ==
          4x^2 * y + 2x

    @test_throws InexactError push!([1], x + 1)

    @test polynomial([1 2; 3 4], [x^2, y]) == x^4 + 5x^2 * y + 4y^2
    @test polynomial([1 2; 3 4], [x^2, y], Float64) isa
          AbstractPolynomial{Float64}
    @test polynomial([1 2; 3 4], [y, x^2]) == y^2 + 5x^2 * y + 4x^4
    @test polynomial([1 2; 3 4], [y, x^2], Float64) isa
          AbstractPolynomial{Float64}
    @test polynomial([1 2; 3 4], monomial_vector([y, x^2])) ==
          4x^4 + 5x^2 * y + y^2
    @test polynomial([1 2; 3 4], monomial_vector([y, x^2]), Float64) isa
          AbstractPolynomial{Float64}

    @test (@inferred round(2.6x + 1.001x^2)) == 3x + 1x^2
    @test (@inferred round(3.1x * y)) == 3x * y
    @test (@inferred round(2.613x + 1.1051x^2, digits = 2)) ≈ 2.61x + 1.11x^2
    @test (@inferred round(3.145x * y, digits = 1)) ≈ 3.1x * y

    @testset "Graded Lex Order" begin
        Mod.@polyvar x y z
        p = 3 * y^2 + 2 * y * x
        @test collect(coefficients(p)) == [3, 2]
        @test collect(monomials(p)) == monomial_vector([x * y, y^2])
        # Examples from p. 59 of the 4th edition of "Ideals, Varieties, and Algorithms" of Cox, Little and O'Shea
        f = 4 * x * y^2 * z + 4 * z^2 - 5 * x^3 + 7 * x^2 * z^2
        @test collect(coefficients(f)) == [4, -5, 4, 7]
        @test collect(monomials(f)) ==
              monomial_vector([x^2 * z^2, x * y^2 * z, x^3, z^2])
        #@test ordering(f) === GradedLex #FIXME
    end

    @testset "Convertion" begin
        Mod.@polyvar x y z
        p = 2.5x + 1 - 2.5x
        @test convert(Int, p) == 1
        @test convert(typeof(p), p) === p
        @test convert(Union{Nothing,typeof(p)}, p) === p
        a = 2y
        q = polynomial([a, z, -a], [x, 1, x])
        @test convert_to_constant(q) == z
        q = polynomial([a, z], [x, 1])
        @test_throws InexactError convert_to_constant(q)
        alloc_test(() -> convert(typeof(p), p), 0)
    end

    @testset "Vector" begin
        Mod.@polyvar x y
        v = [x - 1, y + 1]
        @test nvariables(v) == 2
        @test variables(v)[1] == x
        @test variables(v)[2] == y
    end

    @testset "Effective variables" begin
        Mod.@polyvar x y z
        T = variable_union_type(x)
        @test x isa T
        @test y isa T
        @test z isa T
        @test T[x] == @inferred effective_variables(x + y - y)
        @test T[x, y] == @inferred effective_variables(z + x + y - z)
        @test T[y, z] == @inferred effective_variables(z + 0 * x + y)
        @test T[z] == @inferred effective_variables(z + 0 * x + y^0)
    end

    @testset "Complex" begin
        # See https://github.com/JuliaAlgebra/MultivariatePolynomials.jl/issues/128
        Mod.@polyvar x
        p = im * x + 2im * x^2
        @test p * p == -x^2 - 4x^4 - 4x^3
    end

    @testset "$f is a mutable copy, see issue DynamicPolynomials#62" for f in [
        zero,
        one,
    ]
        p = 2x + 1
        q = f(p)
        q = MA.add!!(q, 2y)
        @test p == 2x + 1
    end

    @testset "map_coefficients $nz" for nz in [false, true]
        p = 2x + 1
        @test map_coefficients(x -> x / 2, p, nonzero = nz) == 1.0x + 0.5
        @test map_coefficients(x -> x / 2, 3x, nonzero = nz) == 1.5x
        @test p === map_coefficients!(x -> x + 1, p, nonzero = nz)
        @test p == 3x + 2
        q = zero(p)
        @test q === map_coefficients_to!(q, x -> 2x, p, nonzero = nz)
        @test q == 6x + 4
        @test q === map_coefficients_to!(q, x -> 2x, 3x, nonzero = nz)
        @test q == 6x
        @test q === map_coefficients_to!(q, x -> 2x, x, nonzero = nz)
        @test q == 2x
        @test q === map_coefficients_to!(q, x -> 2x, x^2, nonzero = nz)
        @test q == 2x^2
    end
end

"""
    differentiate(p::AbstractPolynomialLike, v::AbstractVariable, deg::Union{Int, Val}=1)

Differentiate `deg` times the polynomial `p` by the variable `v`.


    differentiate(p::AbstractPolynomialLike, vs, deg::Union{Int, Val}=1)

Differentiate `deg` times the polynomial `p` by the variables of the vector or
tuple of variable `vs` and return an array of dimension `deg`. It is recommended
to pass `deg` as a `Val` instance when the degree is known at compile time, e.g.
`differentiate(p, v, Val{2}())` instead of `differentiate(p, x, 2)`, as this
will help the compiler infer the return type.

    differentiate(p::AbstractArray{<:AbstractPolynomialLike, N}, vs, deg::Union{Int, Val}=1) where N

Differentiate the polynomials in `p` by the variables of the vector or tuple of variable `vs` and return an array of dimension `N+deg`.
If `p` is an `AbstractVector` this returns the Jacobian of `p` where the i-th row containts the partial
derivaties of `p[i]`.

### Examples

```julia
p = 3x^2*y + x + 2y + 1
differentiate(p, x) # should return 6xy + 1
differentiate(p, x, Val{1}()) # equivalent to the above
differentiate(p, (x, y)) # should return [6xy+1, 3x^2+1]
differentiate( [x^2+y, z^2+4x], [x, y, z]) # should return [2x 1 0; 4 0 2z]
```
"""
function differentiate end

# Fallback for everything else
differentiate(α::T, v::AbstractVariable) where {T} = zero(T)
differentiate(v1::AbstractVariable, v2::AbstractVariable) = v1 == v2 ? 1 : 0
function differentiate(t::AbstractTermLike, v::AbstractVariable)
    return coefficient(t) * differentiate(monomial(t), v)
end
# The polynomial function will take care of removing the zeros
function differentiate(p::_APL, v::AbstractVariable)
    return polynomial!(differentiate.(terms(p), v), SortedState())
end
function differentiate(p::RationalPoly, v::AbstractVariable)
    return (differentiate(p.num, v) * p.den - p.num * differentiate(p.den, v)) /
           p.den^2
end

const _ARPL = Union{_APL,RationalPoly}

function differentiate(
    ps::AbstractArray{PT},
    xs::AbstractArray,
) where {PT<:_ARPL}
    return differentiate.(reshape(ps, (size(ps)..., 1)), reshape(xs, 1, :))
end

function differentiate(ps::AbstractArray{PT}, xs::Tuple) where {PT<:_ARPL}
    return differentiate(ps, collect(xs))
end

# TODO: this signature is probably too wide and creates the potential
# for stack overflows
differentiate(p::_ARPL, xs) = [differentiate(p, x) for x in xs]

# differentiate(p, [x, y]) with TypedPolynomials promote x to a Monomial
differentiate(p::_ARPL, m::AbstractMonomial) = differentiate(p, variable(m))

# The `R` argument indicates a desired result type. We use this in order
# to attempt to preserve type-stability even though the value of `deg` cannot
# be known at compile time. For scalar `p` and `x`, we set R to be the type
# of differentiate(p, x) to give a stable result type regardless of `deg`. For
# vectors p and/or x this is impossible (since differentiate may return an array),
# so we just set `R` to `Any`
function (_differentiate_recursive(p, x, deg::Int, ::Type{R})::R) where {R}
    if deg < 0
        throw(DomainError(deg, "degree is negative"))
    elseif deg == 0
        return p
    else
        return differentiate(differentiate(p, x), x, deg - 1)
    end
end

function differentiate(p, x, deg::Int)
    return _differentiate_recursive(
        p,
        x,
        deg,
        Base.promote_op(differentiate, typeof(p), typeof(x)),
    )
end
function differentiate(p::AbstractArray, x, deg::Int)
    return _differentiate_recursive(p, x, deg, Any)
end
function differentiate(p, x::Union{AbstractArray,Tuple}, deg::Int)
    return _differentiate_recursive(p, x, deg, Any)
end
function differentiate(
    p::AbstractArray,
    x::Union{AbstractArray,Tuple},
    deg::Int,
)
    return _differentiate_recursive(p, x, deg, Any)
end

# This is alternative, Val-based interface for nested differentiation.
# It has the advantage of not requiring an conversion or calls to
# Base.promote_op, while maintaining type stability for any argument
# type.
differentiate(p, x, ::Val{0}) = p
differentiate(p, x, ::Val{1}) = differentiate(p, x)

function differentiate(p, x, deg::Val{N}) where {N}
    if N < 0
        throw(DomainError(deg))
    else
        differentiate(differentiate(p, x), x, Val{N - 1}())
    end
end

function Base.hash(m::AbstractMonomial, u::UInt)
    nnz = count(!iszero, exponents(m))
    if iszero(nnz)
        hash(1, u)
    elseif isone(nnz) && isone(degree(m))
        # We want the has of `m` to match the hash of `variable(m)`
        # so we ignore the exponent one.
        hash(variable(m), u)
    else
        reduce(
            (u, power) -> iszero(power[2]) ? u : hash(power, u),
            powers(m),
            init = u,
        )
    end
end

function Base.hash(t::AbstractTerm, u::UInt)
    if iszero(t)
        hash(0, u)
    elseif isone(coefficient(t))
        # We want the has of `t` to match the hash of `monomial(t)`
        # so we ignore the coefficient one.
        hash(monomial(t), u)
    else
        hash(monomial(t), hash(coefficient(t), u))
    end
end

function Base.hash(p::AbstractPolynomial, u::UInt)
    if iszero(p)
        hash(0, u)
    else
        reduce((u, t) -> hash(t, u), terms(p); init = u)
    end
end

"""
    struct Term{CoeffType,M<:AbstractMonomial} <: AbstractTerm{CoeffType}
        coefficient::CoeffType
        monomial::M
    end

A representation of the multiplication between a `coefficient` and a `monomial`.

!!! note
    The `coefficient` does not need to be a `Number`. It can be for instance a
    multivariate polynomial. When computing a multivariate `gcd`, it is
    actually reformulated as a univariate `gcd` in one of the variable with
    coefficients being multivariate polynomials in the other variables.
    To create such a term, use [`term`](@ref) instead of `*`.
    For instance, if `p` is a polynomial and `m` is a monomial, `p * m` will
    multiply each term of `p` with `m` but `term(p, m)` will create a term
    with `p` as coefficient and `m` as monomial.
"""
struct Term{CoeffType,M<:AbstractMonomial} <: AbstractTerm{CoeffType}
    coefficient::CoeffType
    monomial::M
end

coefficient(t::Term) = t.coefficient
monomial(t::Term) = t.monomial
term_type(::Type{<:Term{C,M}}, ::Type{T}) where {C,M,T} = Term{T,M}
monomial_type(::Type{<:Term{C,M}}) where {C,M} = M

(t::Term)(s...) = substitute(Eval(), t, s)

function Base.convert(::Type{Term{T,M}}, m::AbstractMonomialLike) where {T,M}
    return Term(one(T), convert(M, m))
end
function Base.convert(::Type{Term{T,M}}, t::AbstractTerm) where {T,M}
    return Term{T,M}(convert(T, coefficient(t)), convert(M, monomial(t)))
end
function Base.convert(::Type{Term{T,M}}, t::Term{T,M}) where {T,M}
    return t
end

function convert_constant(::Type{Term{C,M} where C}, α) where {M}
    return convert(Term{typeof(α),M}, α)
end

function Base.promote_rule(
    ::Type{Term{C,M1} where {C}},
    M2::Type{<:AbstractMonomialLike},
) where {M1}
    return (Term{C,promote_type(M1, M2)} where {C})
end
function Base.promote_rule(
    M1::Type{<:AbstractMonomialLike},
    ::Type{Term{C,M2} where {C}},
) where {M2}
    return (Term{C,promote_type(M1, M2)} where {C})
end
function Base.promote_rule(
    ::Type{Term{C,M1} where {C}},
    ::Type{Term{T,M2}},
) where {T,M1,M2}
    return (Term{C,promote_type(M1, M2)} where {C})
end
function Base.promote_rule(
    ::Type{Term{T,M2}},
    ::Type{Term{C,M1} where {C}},
) where {T,M1,M2}
    return (Term{C,promote_type(M1, M2)} where {C})
end
promote_rule_constant(::Type{T}, TT::Type{Term{C,M} where C}) where {T,M} = Any

combine(t1::Term, t2::Term) = combine(promote(t1, t2)...)
function combine(t1::T, t2::T) where {T<:Term}
    return Term(t1.coefficient + t2.coefficient, t1.monomial)
end
function MA.promote_operation(
    ::typeof(combine),
    ::Type{Term{S,M1}},
    ::Type{Term{T,M2}},
) where {S,T,M1,M2}
    return Term{MA.promote_operation(+, S, T),promote_type(M1, M2)}
end

function MA.mutability(::Type{Term{C,M}}) where {C,M}
    if MA.mutability(C) isa MA.IsMutable && MA.mutability(M) isa MA.IsMutable
        return MA.IsMutable()
    else
        return MA.IsNotMutable()
    end
end

# `Base.power_by_squaring` calls `Base.copy` and we want
# `t^1` to be a mutable copy of `t` so `copy` needs to be
# the same as `mutable_copy`.
Base.copy(t::Term) = MA.mutable_copy(t)
function MA.mutable_copy(t::Term)
    return Term(
        MA.copy_if_mutable(coefficient(t)),
        MA.copy_if_mutable(monomial(t)),
    )
end

function MA.operate_to!(
    t::Term,
    ::typeof(*),
    t1::AbstractTermLike,
    t2::AbstractTermLike,
)
    MA.operate_to!(t.coefficient, *, coefficient(t1), coefficient(t2))
    MA.operate_to!(t.monomial, *, monomial(t1), monomial(t2))
    return t
end

function MA.operate!(::typeof(*), t1::Term, t2::AbstractTermLike)
    MA.operate!(*, t1.coefficient, coefficient(t2))
    MA.operate!(*, t1.monomial, monomial(t2))
    return t1
end

# Needed to resolve ambiguity with
# MA.operate!(::typeof(*), ::AbstractMonomial, ::AbstractMonomialLike)
function MA.operate!(::typeof(*), t1::Term, t2::AbstractMonomialLike)
    MA.operate!(*, t1.coefficient, coefficient(t2))
    MA.operate!(*, t1.monomial, monomial(t2))
    return t1
end

function MA.operate!(::typeof(one), t::Term)
    MA.operate!(one, t.coefficient)
    MA.operate!(constant_monomial, t.monomial)
    return t
end

module TestComparison

using Test
using MultivariatePolynomials

function _test(object, M; kws...)
    it = ExponentsIterator{M}(object; kws...)
    v = collect(Iterators.take(it, 20))
    @test issorted(v, lt = (a, b) -> cmp(M(), a, b) < 0)
    @test issorted(v, lt = M())
end

function _test(nvars::Int, M; kws...)
    _test(zeros(Int, nvars), M; inline = false, kws...)
    _test(zeros(Int, nvars), M; inline = true, kws...)
    _test(ntuple(zero, nvars), M; inline = false, kws...)
    return
end

function test_equal()
    exp = ExponentsIterator{LexOrder}([0])
    @test exp == ExponentsIterator{LexOrder}([0])
    @test exp != ExponentsIterator{LexOrder}((0,))
    @test exp != ExponentsIterator{LexOrder}([0, 0])
    @test exp != ExponentsIterator{LexOrder}([0], mindegree = 1)
    @test exp != ExponentsIterator{LexOrder}([0], maxdegree = 2)
end

function test_in()
    # Unbounded iterator (no maxdegree)
    it = ExponentsIterator{Graded{LexOrder}}([0, 0])
    @test [0, 0] in it
    @test [1, 2] in it
    @test [3] ∉ it          # wrong number of variables
    @test [0, 0, 0] ∉ it   # wrong number of variables
    # Bounded iterator
    it2 = ExponentsIterator{LexOrder}([0, 0], mindegree = 1, maxdegree = 3)
    @test [1, 0] in it2
    @test [1, 2] in it2
    @test [0, 0] ∉ it2     # degree too low
    @test [2, 2] ∉ it2     # degree too high
end

function test_errors()
    err = ArgumentError(
        "The `mindegree` of `ExponentsIterator` cannot be negative.",
    )
    @test_throws err ExponentsIterator{LexOrder}([0], mindegree = -1)
    M = Reverse{LexOrder}
    err = ArgumentError(
        "Ordering `$M` is not a valid ordering, use `Graded{$M}` instead.",
    )
    @test_throws err ExponentsIterator{M}([0], maxdegree = 2)
    exps = ExponentsIterator{LexOrder}([0])
    err = ErrorException(
        "The iterator is infinity because `maxdegree` is `nothing`.",
    )
    @test_throws err length(exps)
end

function test_exponents_iterator()
    @testset "nvariables = $nvars" for nvars in 0:3
        @testset "mindegree = $mindegree" for mindegree in 0:3
            @testset "maxdegree = $maxdegree" for maxdegree in
                                                  vcat(nothing, -1:3)
                for L in [LexOrder, InverseLexOrder]
                    @testset "M = $M" for M in
                                          [L, Graded{L}, Graded{Reverse{L}}]
                        _test(nvars, M; mindegree, maxdegree)
                    end
                end
            end
        end
    end
end

function test_compare()
    lex = LexOrder()
    grlex = Graded{LexOrder}()
    rinvlex = Reverse{InverseLexOrder}()
    grevlex = Graded{Reverse{InverseLexOrder}}()
    @test cmp(grlex, [1, 0, 1], [1, 1, 0]) == -1
    @test cmp(grlex, [1, 1, 0], [1, 0, 1]) == 1
    # [CLO13, p. 58]
    @test cmp(lex, 1:3, [3, 2, 0]) < 0
    @test cmp(grlex, 1:3, [3, 2, 0]) > 0
    @test cmp(rinvlex, 1:3, [3, 2, 0]) < 0
    @test cmp(grevlex, 1:3, [3, 2, 0]) > 0
    @test cmp(lex, [1, 2, 4], [1, 1, 5]) > 0
    @test cmp(grlex, [1, 2, 4], [1, 1, 5]) > 0
    @test cmp(rinvlex, [1, 2, 4], [1, 1, 5]) > 0
    @test cmp(grevlex, [1, 2, 4], [1, 1, 5]) > 0
    # [CLO13, p. 59]
    @test cmp(lex, (5, 1, 1), (4, 1, 2)) > 0
    @test cmp(grlex, (5, 1, 1), (4, 1, 2)) > 0
    @test cmp(rinvlex, (5, 1, 1), (4, 1, 2)) > 0
    @test cmp(grevlex, (5, 1, 1), (4, 1, 2)) > 0
    # [CLO13] Cox, D., Little, J., & OShea, D.
    # *Ideals, varieties, and algorithms: an introduction to computational algebraic geometry and commutative algebra*.
    # Springer Science & Business Media, **2013**.
end

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

end # module

TestComparison.runtests()

using Test
import MutableArithmetics as MA

function all_tests(a, b, c, d, e, f, g)
    a_copy = deepcopy(a)
    b_copy = deepcopy(b)
    c_copy = deepcopy(c)
    d_copy = deepcopy(d)
    e_copy = deepcopy(e)
    f_copy = deepcopy(f)
    g_copy = deepcopy(g)
    @testset "Scalar" begin
        MA.Test.scalar_test(a)
        MA.Test.scalar_test(b)
        MA.Test.scalar_test(c)
        MA.Test.scalar_test(d)
        MA.Test.scalar_test(e)
        MA.Test.scalar_test(f)
        MA.Test.scalar_test(g)
    end
    @test isequal(a, a_copy)
    @test isequal(b, b_copy)
    @test isequal(c, c_copy)
    @test isequal(d, d_copy)
    @test isequal(e, e_copy)
    @testset "Quadratic" begin
        MA.Test.quadratic_test(a, b, c, d)
        MA.Test.quadratic_test(b, c, d, e)
        MA.Test.quadratic_test(c, d, e, f)
        MA.Test.quadratic_test(d, e, f, g)
        MA.Test.quadratic_test(e, f, g, a)
        MA.Test.quadratic_test(f, g, a, b)
        MA.Test.quadratic_test(g, a, b, c)
    end
    @test isequal(a, a_copy)
    @test isequal(b, b_copy)
    @test isequal(c, c_copy)
    @test isequal(d, d_copy)
    @test isequal(e, e_copy)
    @testset "Sparse" begin
        MA.Test.sparse_test(a, b, [a b c; b c a; a b a])
    end
    @test isequal(a, a_copy)
    @test isequal(b, b_copy)
    @test isequal(c, c_copy)
    @test isequal(d, d_copy)
    @test isequal(e, e_copy)
    @testset "Vector" begin
        MA.Test.array_test([a, b, c])
        MA.Test.array_test([b, c, d])
        MA.Test.array_test([c, d, e])
        MA.Test.array_test([d, e, a])
        MA.Test.array_test([e, a, b])
    end
    @test isequal(a, a_copy)
    @test isequal(b, b_copy)
    @test isequal(c, c_copy)
    @test isequal(d, d_copy)
    @test isequal(e, e_copy)
    @testset "Matrix" begin
        MA.Test.array_test([a b; c d])
        MA.Test.array_test([c e; e d])
        MA.Test.array_test([a b c; b c a; a b a])
        MA.Test.array_test([d b c; d c e; e b a])
    end
    @test isequal(a, a_copy)
    @test isequal(b, b_copy)
    @test isequal(c, c_copy)
    @test isequal(d, d_copy)
    @test isequal(e, e_copy)
end

Mod.@polyvar x y

@testset "MutableArithmetics with variables" begin
    # Creating 7 different variables here gives a long compile time for TypedPolynomials
    all_tests(x, y, x, y, x, y, x)
end

@testset "MutableArithmetics with monomials" begin
    a = x^2
    b = y^2
    c = x
    d = x^2 * y
    e = x^3
    f = x^5
    g = x^4
    all_tests(a, b, c, d, e, f, g)
end

@testset "MutableArithmetics with terms in $T" for T in [Int, BigInt]
    if MA.mutability(T) isa MA.IsMutable &&
       MA.mutability(typeof(x * y)) isa MA.IsMutable
        @testset "Int" begin
            MA.Test.int_test(
                term_type(x, T),
                exclude = ["int_add", "int_add_mul", "int_zero"],
            )
        end
    end
    a = T(2) * x^2
    b = T(4) * y^2
    c = T(3) * x
    d = T(5) * x^2 * y
    e = T(5) * x^3
    f = T(1) * x^5
    g = T(2) * x^4
    all_tests(a, b, c, d, e, f, g)
end

@testset "MutableArithmetics with polynomials in $T" for T in [Int, BigInt]
    if MA.mutability(T) isa MA.IsMutable
        @testset "Int" begin
            MA.Test.int_test(polynomial_type(x, T))
        end
    end
    a = T(2) * x^2 + T(3) * x * y + T(4) * y
    b = T(4) * y^2 - T(1) * x * y + T(4) * x
    c = T(1) * x^2 + T(3) * x - T(4)
    d = T(5) * x^2 * y - T(3) * x + T(4) * y
    e = T(5) * x^3 - T(3) * x + T(4)
    f = x^5 + x^4 + x^2 + x + T(1)
    g = T(2)x^4 + x^3
    all_tests(a, b, c, d, e, f, g)
end

@testset "RationalPoly" begin
    #@test RationalPoly{true, Int, Int}(1) == 1
    #@test typeof(RationalPoly{false, Int, Int}(1)) == RationalPoly{false, Int, Int}
    #@inferred RationalPoly{true, Int, Int}(1)
    Mod.@polyvar x
    @test 1 / x isa RationalPoly
    @test 1.0 / x isa RationalPoly
    @inferred 1 / x
    @inferred 1.0 / x
    @test eltype([2.0x / x^2, (x + x) / (1 + 2x^2)]) <: RationalPoly
    @test 2 * (1 / x * (1 - x)) + (1 / x * x) * (1 / x^2 * x^2) - (1 - x) / x ==
          (1 - x) / x + 1
    @test (1 / x + 1 / x) / 2 ==
          ((1 / (x^2 - 1) + (x + 1)) - (x + 1)) * ((x^2 - 1) / x)
    @test (x / (x + 1)) / (x - 1) == (x / (x - 1)) / (x + 1)
    #@test typeof(zero(1/x)) == Term{true, Int}
    @test iszero(zero(1 / x))
    @test zero(1 / x) == 0
    @test one(1 / x) == 1
    @test oneunit(1 / x^2) == 1
    #@test typeof(zero(RationalPoly{true, Float64, Int})) == Polynomial{true, Float64}
    #@test iszero(zero(RationalPoly{true, Float64, Int}))
    #@test typeof(x / 2) == Term{true, Float64}
    #@test typeof((x + x^2) / 3.0) == Polynomial{true, Float64}
    @test nothing !== x / (x^2 + 1)
    @test (x^2 + 1) / (2x) != nothing
    @test Dict{Int,Int}() != x / (x^2 + 1)
    @test (x^2 + 1) / (2x) != Dict{Int,Int}()
    @test numerator(x / x^2) == x
    @test denominator(x / x^2) == x^2
    @test inv(x / x^2) == x
    @test x / x^2 == inv(x)
    @test isone(((x + 1) / (x - 1)) / ((x + 1) / (x - 1)))
    @test ((x + 1)^2 / (x - 1)) / ((x + 1) / (x - 1)) == x + 1
    poly = (x + 1) / (x + 2.0)
    RType = typeof(poly)
    @test RType(true) == one(RType)
    @test RType(false) == zero(RType)
    @test one(RType) isa RType
    @test zero(RType) isa RType
    @test one(poly) isa RType
    @test zero(poly) isa RType
end

@testset "Hashing" begin
    Mod.@polyvar x y z
    @test hash(x) != hash(y)
    @test hash(1x) == hash(1.0x)
    @test hash(1x + 3y) == hash(1.0x + 3.0y)
    @test hash(one(x)) == hash(x^0)
    @test hash(x * y) == hash(polynomial(x * y))
    @test hash(0.0x) == hash(0.0)
    @test hash(1.0x) == hash(x)
    @test hash(x - x) == hash(zero(x))
    @test hash(monomial_vector([z^3, z * x, y])[2:3]) ==
          hash(monomial_vector([z^3, z * x]))
    @test hash(monomial_vector([z^3, x, y])[2:2]) ==
          hash(monomial_vector([z^3, x])[1:1])
    @test hash(empty_monomial_vector(x)) == hash([])
    @test hash(1) == hash(one(x))
    @test hash(1) == hash(constant_monomial(x * y))
    @test hash(2) != hash(constant_monomial(x * y))
    @test hash(0.0) == hash(x - x)
end

using LinearAlgebra, Test
using Combinatorics

import MutableArithmetics as MA

using MultivariatePolynomials
const MP = MultivariatePolynomials

function div_number_test()
    Mod.@polyvar x
    @test div(2x, 2) == x
    @test div(6x + 9x^2, 3) == 2x + 3x^2
    @test div(6x + 9x^2, 4) == x + 2x^2
    if VERSION >= v"1.6"
        @test div(10x^3, 4, RoundUp) == 3x^3
        @test div(6x + 9x^2, 4, RoundUp) == 2x + 3x^2
    end
end

function gcd_lcm_test()
    Mod.@polyvar x y z
    @test gcd(x * y, y) == y
    @test lcm(x * y, y) == x * y
    @test gcd(x * y^2 * z, y * z^3) == y * z
    @test lcm(x * y^2 * z, y * z^3) == x * y^2 * z^3
    @test gcd(x^2 * y^7 * z^3, x^4 * y^5 * z^2) == x^2 * y^5 * z^2
    @test lcm(x^2 * y^7 * z^3, x^4 * y^5 * z^2) == x^4 * y^7 * z^3
end

# Taken from
# Ideals, Varieties, and Algorithms
# Cox, Little and O'Shea, Fourth edition
# They have been adapted to the grlex ordering
function divides_test()
    Mod.@polyvar x y z
    @test divides(leading_monomial(x + y), x) # leading_monomial(x+y) will be x^1*y^0 -> tricky test !
    @test !divides(leading_monomial(x^2 + y), x)
    @test divides(x * y, x^2 * y)
    @test divides(x * y, x * y^2)
    @test divides(y * z, x * y * z)
    @test !divides(y * z, x * z)
    @test !divides(x^2 * y, x * y^2)
end

function leading_term_test()
    Mod.@polyvar x y z
    @test @inferred(monic(2x^2 + 4y + 2)) == x^2 + 2y + 1
    # See page 60
    p = 4x * y^2 * z + 4z^2 + 7x^2 * z^2 - 5x^3
    @test leading_coefficient(p) == 7
    @test leading_monomial(p) == x^2 * z^2
    @test leading_term(p) == 7x^2 * z^2
end

function divrem_test()
    Mod.@polyvar x y
    p = x * y^2 + 1
    q = x * y + 1
    @test typeof(div(p, q)) == MA.promote_operation(div, typeof(p), typeof(q))
    @test typeof(rem(p, q)) == MA.promote_operation(rem, typeof(p), typeof(q))
    @test coefficient_type(div(p, q)) == Rational{Int}
    @test coefficient_type(rem(p, q)) == Rational{Int}
    @test (@inferred div(p, q)) == y
    @test (@inferred rem(p, q)) == -y + 1
    @test (@inferred div(x * y^2 + x, y)) == x * y
    @test (@inferred rem(x * y^2 + x, y)) == x
    @test (@inferred rem(x^4 + x^3 + (1 + 1e-10) * x^2 + 1, x^2 + x + 1)) == 1
    @test (@inferred rem(
        x^4 + x^3 + (1 + 1e-10) * x^2 + 1,
        x^2 + x + 1;
        ztol = 1e-11,
    )) ≈ -((1 + 1e-10) - 1)x + 1
end

function testdiv(p, ps)
    q, r = @inferred divrem(p, ps)
    @test p == dot(q, ps) + r
    return q, r
end

function multi_div_test()
    Mod.@polyvar x y
    # Example 1
    q, r = testdiv(x * y^2 + 1, [x * y + 1, y + 1])
    @test q == [y, -1]
    @test r == 2
    # Example 2
    q, r = testdiv(x^2 * y + x * y^2 + y^2, [x * y - 1, y^2 - 1])
    @test q == [x + y, 1]
    @test r == x + y + 1
    # Example 4
    q, r = testdiv(x^2 * y + x * y^2 + y^2, [y^2 - 1, x * y - 1])
    @test q == [x + 1, x]
    @test r == 2x + 1
    # Example 5
    q, r = testdiv(x * y^2 - x, [x * y - 1, y^2 - 1])
    @test q == [y, 0]
    @test r == -x + y
    q, r = testdiv(x * y^2 - x, [y^2 - 1, x * y - 1])
    @test q == [x, 0]
    @test r == 0

    @testset "Issue DynamicPolynomials#62" begin
        p = x^2 + x + 1
        q = rem(p, [x^2 - y])
        @test q == x + y + 1
    end

    @test (@inferred rem(
        x^2 * y + (1 + 1e-10) * x * y + 1,
        [x^2 + x, y + 1],
    )) == 1
    @test (@inferred rem(
        x^2 * y + (1 + 1e-10) * x * y + 1,
        [x^2 + x, y + 1];
        ztol = 1e-11,
    )) == -((1 + 1e-10) - 1)x + 1
end

function lcm_test()
    Mod.@polyvar x
    l = @inferred lcm(x^2 - 1, x^2 + 2x + 1)
    exp = -(x - 1) * (x + 1)^2
    @test l == exp || l == -exp
    l = @inferred lcm(x^2 + 2x + 1, x^2 - 1)
    @test l == exp || l == -exp
    @test x^2 - 1 == @inferred lcm(x^2 - 1, x - 1)
    @test x^2 - 1 == @inferred lcm(x - 1, x^2 - 1)
    @test 0 == @inferred lcm(x - x, x + 1)
    @test 0 == @inferred lcm(x + 1, x - x)
    @test 0 == @inferred lcm(x - x, x^2 - x^2)
    @test 0 == @inferred lcm(x^2 - x^2, x - x)
end

@testset "Division" begin
    @testset "div by number" begin
        div_number_test()
    end
    @testset "GCD and LCM" begin
        gcd_lcm_test()
    end
    @testset "Divides" begin
        divides_test()
    end
    @testset "Leading function" begin
        leading_term_test()
    end
    @testset "Division examples" begin
        divrem_test()
    end
    @testset "Division by multiple polynomials examples" begin
        multi_div_test()
    end
    @testset "lcm" begin
        lcm_test()
    end
end

function test_gcd_unit(expected, p1, p2, algo)
    g = @inferred gcd(p1, p2, algo)
    # it does not make sense, in general, to speak of "the" greatest common
    # divisor of u and v; there is a set of greatest common divisors, each
    # one being a unit multiple of the others [Knu14, p. 424] so `expected` and
    # `-expected` are both accepted.
    @test g == expected || g == -expected
end

function test_gcdx_unit(expected, p1, p2, algo)
    test_gcd_unit(expected, p1, p2, algo)
    if !(algo isa SubresultantAlgorithm) # FIXME not implemented yet
        a, b, g = @inferred gcdx(p1, p2, algo)
        # it does not make sense, in general, to speak of "the" greatest common
        # divisor of u and v; there is a set of greatest common divisors, each
        # one being a unit multiple of the others [Knu14, p. 424] so `expected` and
        # `-expected` are both accepted.
        @test iszero(MP.pseudo_rem(g, expected, algo))
        @test a * p1 + b * p2 == g
    end
end
function _test_gcdx_unit(expected, p1, p2, algo)
    test_gcdx_unit(expected, p1, p2, algo)
    return test_gcdx_unit(expected, p2, p1, algo)
end

function univariate_gcd_test(algo = GeneralizedEuclideanAlgorithm())
    Mod.@polyvar x
    test_gcdx_unit(x + 1, x^2 - 1, x^2 + 2x + 1, algo)
    test_gcdx_unit(x + 1, x^2 + 2x + 1, x^2 - 1, algo)
    test_gcdx_unit(x + 1, x^2 - 1, x + 1, algo)
    test_gcdx_unit(x + 1, x + 1, x^2 - 1, algo)
    test_gcdx_unit(x + 1, x - x, x + 1, algo)
    test_gcdx_unit(x + 1, x + 1, x - x, algo)
    test_gcdx_unit(x - x + 1, x + 1, x + 2, algo)
    test_gcdx_unit(x - x + 1, x + 1, 2x + 1, algo)
    test_gcdx_unit(x - x + 1, x - 1, 2x^2 - 2x - 2, algo)
    @test 0 == @inferred gcd(x - x, x^2 - x^2, algo)
    @test 0 == @inferred gcd(x^2 - x^2, x - x, algo)
end

function _mult_test(a::Number, b)
    @test iszero(maxdegree(b))
end
function _mult_test(a::Number, b::Number)
    @test iszero(rem(a, b))
    @test iszero(rem(b, a))
end
function _mult_test(a, b)
    @test iszero(rem(a, b))
    @test iszero(rem(b, a))
end

include("independent.jl")

function _gcd_test(expected, a, b, algo, expected_type)
    A = deepcopy(a)
    B = deepcopy(b)
    g = @inferred MP._simplifier(
        a,
        b,
        algo,
        MA.IsNotMutable(),
        MA.IsNotMutable(),
    )
    @test are_independent(g, a)
    @test are_independent(g, b)
    @test g isa expected_type
    return _mult_test(expected, g)
end

function mult_test(expected, a, b, algo)
    return _gcd_test(expected, a, b, algo, Base.promote_typeof(a, b))
end
function mult_test(expected, a::Number, b, algo)
    return _gcd_test(
        expected,
        a,
        b,
        algo,
        promote_type(typeof(a), MP.coefficient_type(b)),
    )
end
function mult_test(expected, a, b::Number, algo)
    return _gcd_test(
        expected,
        a,
        b,
        algo,
        promote_type(MP.coefficient_type(a), typeof(b)),
    )
end
function sym_test(a, b, g, algo)
    mult_test(g, a, b, algo)
    return mult_test(g, b, a, algo)
end
function triple_test(a, b, c, algo)
    sym_test(a * c, b * c, gcd(a, b, algo) * c, algo)
    sym_test(b * a, c * a, gcd(b, c, algo) * a, algo)
    return sym_test(c * b, a * b, gcd(c, a, algo) * b, algo)
end

function multivariate_gcd_test(
    ::Type{T},
    algo = SubresultantAlgorithm(),
) where {T}
    Mod.@polyvar x y z
    o = one(T)
    zr = zero(T)
    sym_test(o, o * x, o, algo)
    sym_test(o * x, zr * x, o * x, algo)
    sym_test(o * x + o, zr * x, o * x + o, algo)
    # Inspired from https://github.com/JuliaAlgebra/MultivariatePolynomials.jl/issues/160
    f1 = o * x * y + o * x
    f2 = o * y^2
    f3 = o * x
    sym_test(f1, f2, 1, algo)
    sym_test(f2, f3, 1, algo)
    sym_test(f3, f1, x, algo)
    triple_test(f1, f2, f3, algo)

    @testset "Issue #173" begin
        p1 = o * x * y + x
        p2 = x^2
        sym_test(p1, p2, x, algo)
    end

    p1 = o * z - z
    p2 = z
    @test gcd(p1, p2, algo) == z
    p1 = o * y - y
    p2 = z
    @test gcd(p1, p2, algo) == z
    test_relatively_prime(p1, p2, algo) = test_gcd_unit(o, p1, p2, algo)
    test_relatively_prime(2o * y * z - o, y - z, algo)
    test_relatively_prime(2o * y^2 * z - y, y - z, algo)
    test_relatively_prime(2o * y^2 * z - y, y^3 * z - y - z, algo)
    test_relatively_prime(
        2o * y^3 + 2 * y^2 * z - y,
        y^3 + y^3 * z - y - z,
        algo,
    )
    test_relatively_prime(
        z^4 + 2o * y^3 + 2 * y^2 * z - y,
        y * z^4 + y^3 + y^3 * z - y - z,
        algo,
    )
    test_relatively_prime(
        y * z^3 + z^4 + 2o * y^3 + 2 * y^2 * z - y,
        y^2 * z^3 + y * z^4 + y^3 + y^3 * z - y - z,
        algo,
    )
    if T != Int
        test_relatively_prime(
            -3o * y^2 * z^3 - 3 * y^4 + y * z^3 + z^4 + 2 * y^3 + 2 * y^2 * z -
            y,
            3o * y^3 * z^3 - 2 * y^5 + y^2 * z^3 + y * z^4 + y^3 + y^3 * z - y -
            z,
            algo,
        )
    end
    test_relatively_prime(
        -z^6 - 3o * y^2 * z^3 - 3 * y^4 +
        y * z^3 +
        z^4 +
        2 * y^3 +
        2 * y^2 * z - y,
        -y * z^6 - 3o * y^3 * z^3 - 2 * y^5 +
        y^2 * z^3 +
        y * z^4 +
        y^3 +
        y^3 * z - y - z,
        algo,
    )
    test_relatively_prime(
        -z^6 - 3o * y^2 * z^3 - 3 * y^4 +
        y * z^3 +
        z^4 +
        2 * y^3 +
        2 * y^2 * z - y,
        -y^2 * z^6 - 3o * y^4 * z^3 - 2 * y^6 +
        y^3 * z^3 +
        y^2 * z^4 +
        y^5 +
        y^4 * z - y^2 - y * z,
        algo,
    )
    a = (o * x + o * y^2) * (o * z^3 + o * y^2 + o * x)
    b = (o * x + o * y + o * z) * (o * x^2 + o * y)
    c = (o * x + o * y + o * z) * (o * z^3 + o * y^2 + o * x)
    #    if T != Int || (
    #        algo != GeneralizedEuclideanAlgorithm(false, false) &&
    #        algo != GeneralizedEuclideanAlgorithm(true, false) &&
    #        algo != GeneralizedEuclideanAlgorithm(true, true)
    #    )
    #        sym_test(a, b, 1, algo)
    #    end
    sym_test(b, c, x + y + z, algo)
    sym_test(c, a, z^3 + y^2 + x, algo)
    #    if T != Int && (
    #        T != Float64 || (
    #            algo != GeneralizedEuclideanAlgorithm(false, true) &&
    #            algo != GeneralizedEuclideanAlgorithm(true, true)
    #        )
    #    )
    #        triple_test(a, b, c, algo)
    #    end

    # https://github.com/JuliaAlgebra/MultivariatePolynomials.jl/issues/195
    return sym_test(
        x * (y^2) + 2x * y * z + x * (z^2) + x * y + x * z,
        y + z,
        y + z,
        algo,
    )
end

function deflation_test()
    Mod.@polyvar a b c
    function _test(p, eshift, edefl)
        shift, defl = MP.deflation(p)
        @test shift == eshift
        @test defl == edefl
        q = MP.deflate(p, shift, defl)
        @test p == MP.inflate(q, shift, defl)
    end
    for (x, y, z) in permutations((a, b, c))
        _test(x + x^2 + y * x, x, x * y)
        p = x^2 + x^2 * y^3 + y^6 * x^4
        _test(p, x^2, x^2 * y^3)
        @test p == MP.deflate(p, z^0, z^0)
        _test(p, x^2, x^2 * y^3)
    end
end

function extracted_variable_test()
    Mod.@polyvar x y z
    function _test(p1, p2, w1, w2)
        i1, i2, n = MP._extracted_variable(p1, p2)
        v(p, i) = iszero(i) ? nothing : variables(p)[i]
        if string(Mod) == "DynamicPolynomials"
            alloc_test(() -> MP._extracted_variable(p1, p2), 0)
        end
        @test v(p1, i1) == w1
        @test v(p2, i2) == w2
        i2, i1, n = MP._extracted_variable(p2, p1)
        if string(Mod) == "DynamicPolynomials"
            alloc_test(() -> MP._extracted_variable(p2, p1), 0)
        end
        @test v(p1, i1) == w1
        @test v(p2, i2) == w2
    end
    _test(x - x, y - y, nothing, nothing)
    _test(x + y + z, x - z, y, nothing)
    _test(x + y + z, x - y, z, nothing)
    _test(x + y + z, y - z, x, nothing)
    _test(x^4 + y^5 + z^6, x^3 + y^2 + z, z, z)
    _test(x^6 + y^5 + z^4, x + y^2 + z^3, x, x)
    _test(x^6 + y + z^4 - y, x + y + z^3 - y, x, x)
    return _test(
        x * (y^2) + 2x * y * z + x * (z^2) + x * y + x * z,
        y + z,
        y,
        y,
    )
end

@testset "GCD" begin
    univariate_gcd_test(SubresultantAlgorithm())
    @testset "Univariate gcd primitive_rem=$primitive_rem" for primitive_rem in
                                                               [false, true]
        @testset "skip_last=$skip_last" for skip_last in [false, true]
            univariate_gcd_test(
                GeneralizedEuclideanAlgorithm(primitive_rem, skip_last),
            )
        end
    end
    @testset "Multivariate gcd $T" for T in
                                       [Int, BigInt, Rational{BigInt}, Float64]
        if T != Rational{BigInt} || VERSION >= v"1.6"
            multivariate_gcd_test(T, SubresultantAlgorithm())
            # `gcd` for `Rational{BigInt}` got defined at some point between v1.0 and v1.6
            @testset "primitive_rem=$primitive_rem" for primitive_rem in
                                                        [false, true]
                @testset "skip_last=$skip_last" for skip_last in [false, true]
                    multivariate_gcd_test(
                        T,
                        GeneralizedEuclideanAlgorithm(primitive_rem, skip_last),
                    )
                end
            end
        end
    end
    if nameof(Mod) == :DynamicPolynomials
        @testset "Non-concrete polynomial GCD" begin
            Mod.@polyvar p q
            p1 = MP.polynomial(p^2 + q^2, Number)
            p2 = MP.polynomial(p * q, Number)
            g = @inferred gcd(p1, p2)
            @test isone(g)
        end
    end
    @testset "Complex coefficient GCD" begin
        Mod.@polyvar p q
        p1 = MP.polynomial(p^2 + q^2, ComplexF64)
        p2 = MP.polynomial(p * q, ComplexF64)
        g = @inferred gcd(p1, p2)
        @test isone(g)

        p1 = p - 2.5im
        p2 = 2.0p - 5.0im
        g = @inferred gcd(p1, p2)
        @test isequal(p1, g) || isequal(p2, g)
    end
end

"""
    struct Polynomial{CoeffType,T<:AbstractTerm{CoeffType},V<:AbstractVector{T}} <: AbstractPolynomial{CoeffType}
        terms::V
    end

Representation of a multivariate polynomial as a vector of nonzero terms sorted
in ascending monomial order.
"""
struct Polynomial{CoeffType,T<:AbstractTerm{CoeffType},V<:AbstractVector{T}} <:
       AbstractPolynomial{CoeffType}
    terms::V

    function Polynomial{C,T,V}(terms::AbstractVector{T}) where {C,T,V}
        return new{C,T,V}(terms)
    end
end

# It shouldn't be needed to call this. A polynomial should always be in
# canonical format so it is only called inside an internal call.
function _canonicalize!(p::Polynomial)
    sort!(p.terms)
    uniqterms!(p.terms)
    return
end

function coefficients(p::Polynomial)
    return LazyMap{coefficient_type(p)}(coefficient, terms(p))
end
function monomials(p::Polynomial)
    return LazyMap{monomial_type(p)}(monomial, terms(p))
end

const VectorPolynomial{C,T} = Polynomial{C,T,Vector{T}}

term_type(::Type{<:Polynomial{C,T}}) where {C,T} = T
terms(p::Polynomial) = p.terms
function constant_monomial(
    ::Union{Polynomial{C,TT},Type{Polynomial{C,TT}}},
) where {C,TT}
    return constant_monomial(TT)
end
function Base.convert(
    ::Type{Polynomial{C,TT,V}},
    p::Polynomial{C,TT,V},
) where {C,TT,V}
    return p
end
function Base.convert(
    PT::Type{Polynomial{C,TT,V}},
    p::AbstractPolynomialLike,
) where {C,TT,V}
    return PT(convert(V, terms(p)))
end
function Base.convert(
    ::Type{Polynomial{C}},
    p::AbstractPolynomialLike,
) where {C}
    TT = term_type(p, C)
    return convert(Polynomial{C,TT,Vector{TT}}, p)
end
function Base.convert(::Type{Polynomial}, p::AbstractPolynomialLike)
    return convert(Polynomial{coefficient_type(p)}, p)
end

_change_eltype(::Type{<:Vector}, ::Type{T}) where {T} = Vector{T}
function polynomial_type(
    ::Type{Polynomial{C,T,V}},
    ::Type{NewC},
) where {C,T,V,NewC}
    NewT = term_type(T, NewC)
    return Polynomial{NewC,NewT,_change_eltype(V, NewT)}
end

function Base.promote_rule(::Type{Polynomial}, ::Type{<:AbstractPolynomialLike})
    return Polynomial
end
function Base.promote_rule(::Type{<:AbstractPolynomialLike}, ::Type{Polynomial})
    return Polynomial
end
function promote_rule_constant(::Type{T}, ::Type{Polynomial}) where {T}
    return Any
    # `convert(Polynomial{T}, ::T)` cannot be implemented as we don't know the type of the term
    #return Polynomial{T}
end

(p::Polynomial)(s...) = substitute(Eval(), p, s)

function Base.one(::Type{P}) where {C,TT,P<:Polynomial{C,TT}}
    return convert(P, one(TT))
end
Base.one(p::Polynomial) = one(typeof(p))

Base.zero(::Type{Polynomial{C,T,A}}) where {C,T,A} = Polynomial{C,T,A}(A())
Base.zero(t::Polynomial) = zero(typeof(t))

compare_monomials(a, b) = compare(monomial(a), monomial(b))

function join_terms(
    terms1::AbstractArray{<:Term},
    terms2::AbstractArray{<:Term},
)
    return Sequences.merge_sorted(terms1, terms2, compare_monomials, combine)
end
function join_terms!(
    output::AbstractArray{<:Term},
    terms1::AbstractArray{<:Term},
    terms2::AbstractArray{<:Term},
)
    resize!(output, length(terms1) + length(terms2))
    return Sequences.merge_sorted!(
        output,
        terms1,
        terms2,
        compare_monomials,
        combine,
    )
end

function Base.:(+)(p1::Polynomial, p2::Polynomial)
    return polynomial!(join_terms(terms(p1), terms(p2)), SortedUniqState())
end
function Base.:(+)(
    p1::Polynomial,
    p2::Polynomial{<:LinearAlgebra.UniformScaling},
)
    return p1 + map_coefficients(J -> J.λ, p2, nonzero = true)
end
function Base.:(+)(
    p1::Polynomial{<:LinearAlgebra.UniformScaling},
    p2::Polynomial,
)
    return map_coefficients(J -> J.λ, p1, nonzero = true) + p2
end
function Base.:(+)(
    p1::Polynomial{<:LinearAlgebra.UniformScaling},
    p2::Polynomial{<:LinearAlgebra.UniformScaling},
)
    return map_coefficients(J -> J.λ, p1, nonzero = true) + p2
end
function MA.operate_to!(
    result::Polynomial,
    ::typeof(+),
    p1::Polynomial,
    p2::Polynomial,
)
    if result === p1 || result === p2
        error(
            "Cannot call `operate_to!(output, +, p, q)` with `output` equal to `p` or `q`, call `operate!` instead.",
        )
    end
    join_terms!(result.terms, terms(p1), terms(p2))
    return result
end
function MA.operate_to!(
    result::Polynomial,
    ::typeof(*),
    p::Polynomial,
    t::AbstractTermLike,
)
    if iszero(t)
        MA.operate!(zero, result)
    else
        resize!(result.terms, nterms(p))
        for i in eachindex(p.terms)
            # TODO could use MA.mul_to!! for indices that were presents in `result` before the `resize!`.
            result.terms[i] = p.terms[i] * t
        end
        if !multiplication_preserves_monomial_order(typeof(result))
            _canonicalize!(result)
        end
        return result
    end
end
function MA.operate_to!(
    result::Polynomial,
    ::typeof(*),
    t::AbstractTermLike,
    p::Polynomial,
)
    if iszero(t)
        MA.operate!(zero, result)
    else
        resize!(result.terms, nterms(p))
        for i in eachindex(p.terms)
            # TODO could use MA.mul_to!! for indices that were presents in `result` before the `resize!`.
            result.terms[i] = t * p.terms[i]
        end
        if !multiplication_preserves_monomial_order(typeof(result))
            _canonicalize!(result)
        end
        return result
    end
end
function Base.:(-)(p1::Polynomial, p2::Polynomial)
    return polynomial!(join_terms(terms(p1), (-).(terms(p2))))
end
function Base.:(-)(
    p1::Polynomial,
    p2::Polynomial{<:LinearAlgebra.UniformScaling},
)
    return p1 - map_coefficients(J -> J.λ, p2, nonzero = true)
end
function Base.:(-)(
    p1::Polynomial{<:LinearAlgebra.UniformScaling},
    p2::Polynomial,
)
    return map_coefficients(J -> J.λ, p1, nonzero = true) - p2
end
function Base.:(-)(
    p1::Polynomial{<:LinearAlgebra.UniformScaling},
    p2::Polynomial{<:LinearAlgebra.UniformScaling},
)
    return map_coefficients(J -> J.λ, p1, nonzero = true) - p2
end

function map_coefficients(
    f::F,
    p::Polynomial;
    nonzero = false,
) where {F<:Function}
    terms = map(p.terms) do term
        return map_coefficients(f, term)
    end
    if !nonzero
        filter!(!iszero, terms)
    end
    return polynomial!(terms)
end
function map_coefficients!(
    f::F,
    p::Polynomial;
    nonzero = false,
) where {F<:Function}
    for i in eachindex(p.terms)
        t = p.terms[i]
        p.terms[i] = Term(f(coefficient(t)), monomial(t))
    end
    if !nonzero
        filter!(!iszero, p.terms)
    end
    return p
end

function map_coefficients_to!(
    output::Polynomial,
    f::F,
    p::Polynomial;
    nonzero = false,
) where {F<:Function}
    resize!(output.terms, nterms(p))
    for i in eachindex(p.terms)
        t = p.terms[i]
        output.terms[i] = Term(f(coefficient(t)), monomial(t))
    end
    if !nonzero
        filter!(!iszero, output.terms)
    end
    return output
end
function map_coefficients_to!(
    output::Polynomial,
    f::Function,
    p::AbstractPolynomialLike;
    nonzero = false,
)
    return map_coefficients_to!(output, f, polynomial(p); nonzero = false)
end

# The polynomials can be mutated.
MA.mutability(::Type{<:VectorPolynomial}) = MA.IsMutable()

# Terms are not mutable under the MutableArithmetics API
function MA.mutable_copy(p::VectorPolynomial{C,TT}) where {C,TT}
    return VectorPolynomial{C,TT}([
        TT(MA.copy_if_mutable(coefficient(term)), monomial(term)) for
        term in terms(p)
    ])
end
Base.copy(p::VectorPolynomial) = MA.mutable_copy(p)

function __polynomial_merge!(
    op::MA.AddSubMul,
    p::Polynomial{T,TT},
    get1,
    set,
    push,
    resize,
    keep,
    q,
    t::AbstractTermLike...,
) where {T,TT}
    compare_monomials = let t = t, get1 = get1, q = q
        (tp, j) -> begin
            if tp isa Int && j isa Int
                tp = get1(tp)
            end
            compare(monomial(*(monomials(q)[j], monomial.(t)...)), monomial(tp))
        end
    end
    get2 = let t = t, q = q
        i -> begin
            tq = terms(q)[i]
            TT(
                MA.scaling_convert(
                    T,
                    MA.operate(
                        MA.add_sub_op(op),
                        *(coefficient(tq), coefficient.(t)...),
                    ),
                ),
                *(monomial(tq), monomial.(t)...),
            )
        end
    end
    combine = let t = t, p = p, q = q
        (i, j) -> begin
            if i isa Int
                p.terms[i] = Term(
                    MA.operate!!(
                        op,
                        coefficient(p.terms[i]),
                        coefficients(q)[j],
                        coefficient.(t)...,
                    ),
                    monomial(p.terms[i]),
                )
            else
                typeof(i)(
                    MA.operate!!(
                        op,
                        coefficient(i),
                        coefficients(q)[j],
                        coefficient.(t)...,
                    ),
                    monomial(i),
                )
            end
        end
    end
    polynomial_merge!(
        nterms(p),
        nterms(q),
        get1,
        get2,
        set,
        push,
        compare_monomials,
        combine,
        keep,
        resize,
    )
    return
end

function __polynomial_merge!(
    op::MA.AddSubMul,
    p::Polynomial{T,TT},
    get1,
    set,
    push,
    resize,
    keep,
    t::AbstractTermLike,
    q::Polynomial,
    buffer = nothing,
) where {T,TT}
    if !multiplication_preserves_monomial_order(typeof(p))
        # This function assumes that the monomials of `t * q` will preserve the
        # order of the terms of `q` so if it's not the case, we fallback to
        # another one.
        __polynomial_merge!(
            MA.add_sub_op(op),
            p,
            get1,
            set,
            push,
            resize,
            keep,
            t * q,
        )
        return
    end
    compare_monomials = let t = t, get1 = get1, q = q
        (tp, j) -> begin
            if tp isa Int && j isa Int
                tp = get1(tp)
            end
            compare(monomial(monomial(t) * monomials(q)[j]), monomial(tp))
        end
    end
    get2 = let t = t, q = q
        i -> begin
            tq = terms(q)[i]
            TT(
                MA.scaling_convert(
                    T,
                    MA.operate(
                        MA.add_sub_op(op),
                        coefficient(t) * coefficient(tq),
                    ),
                ),
                monomial(t) * monomial(tq),
            )
        end
    end
    combine = let t = t, p = p, q = q
        (i, j) -> begin
            if i isa Int
                p.terms[i] = Term(
                    MA.buffered_operate!!(
                        buffer,
                        op,
                        coefficient(p.terms[i]),
                        coefficient(t),
                        coefficients(q)[j],
                    ),
                    monomial(p.terms[i]),
                )
            else
                typeof(i)(
                    MA.buffered_operate!!(
                        buffer,
                        op,
                        coefficient(i),
                        coefficient(t),
                        coefficients(q)[j],
                    ),
                    monomial(i),
                )
            end
        end
    end
    polynomial_merge!(
        nterms(p),
        nterms(q),
        get1,
        get2,
        set,
        push,
        compare_monomials,
        combine,
        keep,
        resize,
    )
    return
end

function __polynomial_merge!(
    op::Union{typeof(+),typeof(-)},
    p::Polynomial{T,TT},
    get1,
    set,
    push,
    resize,
    keep,
    q::Union{Polynomial,AbstractTermLike},
) where {T,TT}
    compare_monomials = let get1 = get1, q = q
        (t, j) -> begin
            if t isa Int && j isa Int
                t = get1(t)
            end
            compare(monomials(q)[j], monomial(t))
        end
    end
    get2 = let q = q
        i -> begin
            t = terms(q)[i]
            # `operate` makes sure we make a copy of the term as it may be stored directly in `p`
            TT(
                MA.scaling_convert(T, MA.operate(op, coefficient(t))),
                monomial(t),
            )
        end
    end
    combine = let p = p, q = q
        (i, j) -> begin
            if i isa Int
                p.terms[i] = Term(
                    MA.operate!!(
                        op,
                        coefficient(p.terms[i]),
                        coefficients(q)[j],
                    ),
                    monomial(p.terms[i]),
                )
            else
                typeof(i)(
                    MA.operate!!(op, coefficient(i), coefficients(q)[j]),
                    monomial(i),
                )
            end
        end
    end
    polynomial_merge!(
        nterms(p),
        nterms(q),
        get1,
        get2,
        set,
        push,
        compare_monomials,
        combine,
        keep,
        resize,
    )
    return
end

function _polynomial_merge!(
    op::Union{typeof(+),typeof(-),MA.AddSubMul},
    p::Polynomial{T,TT},
    args...,
) where {T,TT}
    get1 = let p = p
        i -> p.terms[i]
    end
    set = let p = p
        (i, t) -> begin
            p.terms[i] = t
        end
    end
    push = let p = p
        t -> push!(p.terms, t)
    end
    resize = let p = p
        (n) -> resize!(p.terms, n)
    end
    # We can modify the coefficient since it's the result of `combine`.
    keep = let p = p
        i -> begin
            if i isa Int
                !MA.iszero!!(coefficient(p.terms[i]))
            else
                !MA.iszero!!(coefficient(i))
            end
        end
    end
    __polynomial_merge!(op, p, get1, set, push, resize, keep, args...)
    return p
end

function MA.operate!(
    op::Union{typeof(+),typeof(-)},
    p::Polynomial,
    q::Union{AbstractTermLike,Polynomial},
)
    return _polynomial_merge!(op, p, q)
end

function MA.operate!(
    op::MA.AddSubMul,
    p::Polynomial,
    q::Polynomial,
    args::AbstractTermLike...,
)
    return _polynomial_merge!(op, p, q, args...)
end

function MA.operate!(
    op::MA.AddSubMul,
    p::Polynomial,
    t::AbstractTermLike,
    q::Polynomial,
)
    return _polynomial_merge!(op, p, t, q)
end

function MA.buffer_for(
    op::MA.AddSubMul,
    ::Type{<:Polynomial{S}},
    ::Type{<:AbstractTermLike{T}},
    ::Type{<:Polynomial{U}},
) where {S,T,U}
    return MA.buffer_for(op, S, T, U)
end
function MA.buffered_operate!(
    buffer,
    op::MA.AddSubMul,
    p::Polynomial,
    t::AbstractTermLike,
    q::Polynomial,
)
    return _polynomial_merge!(op, p, t, q, buffer)
end

function MA.operate_to!(
    output::Polynomial,
    ::typeof(*),
    p::Polynomial,
    q::Polynomial,
)
    empty!(output.terms)
    mul_to_terms!(output.terms, p, q)
    _canonicalize!(output)
    return output
end
function MA.operate!(::typeof(*), p::Polynomial, q::Polynomial)
    if iszero(q)
        return MA.operate!(zero, p)
    elseif nterms(q) == 1
        return MA.operate!(*, p, leading_term(q))
    else
        return MA.operate_to!(p, *, MA.mutable_copy(p), q)
    end
end
function MA.operate!(::typeof(*), p::Polynomial, t::AbstractTermLike)
    for i in eachindex(p.terms)
        p.terms[i] = MA.operate!!(*, p.terms[i], t)
    end
    if !multiplication_preserves_monomial_order(typeof(p))
        _canonicalize!(p)
    end
    return p
end
function map_exponents!(f, p::Polynomial, m::AbstractMonomialLike)
    for i in eachindex(p.terms)
        t = p.terms[i]
        p.terms[i] = term(coefficient(t), map_exponents(f, monomial(t), m))
    end
    return p
end
function map_exponents(f, p::Polynomial, m::AbstractMonomialLike)
    P = MA.promote_operation(*, typeof(p), typeof(m))
    return map_exponents!(f, MA.mutable_copy(convert(P, p)), m)
end

function MA.operate!(::typeof(zero), p::Polynomial)
    empty!(p.terms)
    return p
end
function MA.operate!(::typeof(one), p::Polynomial{T}) where {T}
    if isempty(p.terms)
        push!(p.terms, constant_term(one(T), p))
    else
        t = p.terms[1]
        p.terms[1] = Term(MA.one!!(coefficient(t)), constant_monomial(t))
        resize!(p.terms, 1)
    end
    return p
end

function MA.operate!(::typeof(remove_leading_term), p::Polynomial)
    pop!(p.terms)
    return p
end

function MA.operate!(
    ::typeof(unsafe_restore_leading_term),
    p::Polynomial,
    t::AbstractTermLike,
)
    # We don't need to copy the coefficient of `t`, this is why this function is called `unsafe`
    push!(p.terms, t)
    return p
end

Base.iszero(v::AbstractVariable) = false
Base.iszero(m::AbstractMonomial) = false
Base.iszero(t::AbstractTerm) = iszero(coefficient(t))
Base.iszero(t::AbstractPolynomial) = iszero(nterms(t))

Base.isone(v::AbstractVariable) = false
Base.isone(m::AbstractMonomial) = isconstant(m)
Base.isone(t::AbstractTerm) = isone(coefficient(t)) && isconstant(monomial(t))
function Base.isone(p::AbstractPolynomial)
    return isone(nterms(p)) && isone(first(terms(p)))
end

# See https://github.com/blegat/MultivariatePolynomials.jl/issues/22
# avoids the call to be transfered to left_constant_eq
Base.:(==)(α::Nothing, x::_APL) = false
Base.:(==)(x::_APL, α::Nothing) = false
Base.:(==)(α::Dict, x::_APL) = false
Base.:(==)(x::_APL, α::Dict) = false
Base.:(==)(α::Nothing, x::RationalPoly) = false
Base.:(==)(x::RationalPoly, α::Nothing) = false
Base.:(==)(α::Dict, x::RationalPoly) = false
Base.:(==)(x::RationalPoly, α::Dict) = false

function right_term_eq(p::AbstractPolynomial, t; comp = (==))
    if iszero(p)
        iszero(t)
    else
        # terms/nterms ignore zero terms
        nterms(p) == 1 && comp(leading_term(p), t)
    end
end
right_term_eq(p::_APL, t; comp = (==)) = right_term_eq(polynomial(p), t; comp)

left_constant_eq(α, v::AbstractVariable; comp = (==)) = false
right_constant_eq(v::AbstractVariable, α; comp = (==)) = false
function _term_constant_eq(t::AbstractTermLike, α; comp = (==))
    if iszero(t)
        iszero(α)
    else
        comp(α, coefficient(t)) && isconstant(t)
    end
end
function left_constant_eq(α, t::AbstractTermLike; comp = (==))
    return _term_constant_eq(t, α; comp)
end
function right_constant_eq(t::AbstractTermLike, α; comp = (==))
    return _term_constant_eq(t, α; comp)
end
left_constant_eq(α, p::_APL; comp = (==)) = right_term_eq(p, α; comp)
right_constant_eq(p::_APL, α; comp = (==)) = right_term_eq(p, α; comp)

function Base.:(==)(mono::AbstractMonomial, v::AbstractVariable)
    return isone(degree(mono)) && variable(mono) == v
end
function Base.:(==)(v::AbstractVariable, mono::AbstractMonomial)
    return isone(degree(mono)) && v == variable(mono)
end
function Base.:(==)(t::AbstractTerm, mono::AbstractMonomialLike)
    return isone(coefficient(t)) && monomial(t) == mono
end
function Base.:(==)(mono::AbstractMonomialLike, t::AbstractTerm)
    return isone(coefficient(t)) && mono == monomial(t)
end

function _compare_term(t1::AbstractTerm, t2::AbstractTerm, comp)
    c1 = coefficient(t1)
    c2 = coefficient(t2)
    if iszero(c1)
        iszero(c2)
    else
        comp(c1, c2) && comp(monomial(t1), monomial(t2))
    end
end

Base.:(==)(t1::AbstractTerm, t2::AbstractTerm) = _compare_term(t1, t2, ==)
Base.:(==)(p::AbstractPolynomial, t::AbstractTerm) = right_term_eq(p, t)
Base.:(==)(t::AbstractTerm, p::AbstractPolynomial) = right_term_eq(p, t)
function Base.isequal(t1::AbstractTerm, t2::AbstractTerm)
    return _compare_term(t1, t2, isequal)
end
function Base.isequal(p::AbstractPolynomial, t::AbstractTerm)
    return right_term_eq(p, t; comp = isequal)
end
function Base.isequal(t::AbstractTerm, p::AbstractPolynomial)
    return right_term_eq(p, t; comp = isequal)
end

function compare_terms(p1::AbstractPolynomial, p2::AbstractPolynomial, isz, op)
    i1 = 1
    i2 = 1
    t1 = terms(p1)
    t2 = terms(p2)
    while true
        while i1 <= length(t1) && isz(coefficient(t1[i1]))
            i1 += 1
        end
        while i2 <= length(t2) && isz(coefficient(t2[i2]))
            i2 += 1
        end
        if i1 > length(t1) && i2 > length(t2)
            return true
        end
        if i1 > length(t1) || i2 > length(t2)
            return false
        end
        if !op(t1[i1], t2[i2])
            return false
        end
        i1 += 1
        i2 += 1
    end
end

# Can there be zero term in TypedPolynomials ?
#function (==)(p1::AbstractPolynomial, p2::AbstractPolynomial)
#    nterms(p1) != nterms(p2) && return false
#    for (t1, t2) in zip(terms(p1), terms(p2))
#        @assert !iszero(t1) && !iszero(t2) # There should be no zero term
#        if t1 != t2
#            return false
#        end
#    end
#    return true
#end
function Base.:(==)(p1::AbstractPolynomial, p2::AbstractPolynomial)
    return compare_terms(p1, p2, iszero, ==)
end
function Base.isequal(p1::AbstractPolynomial, p2::AbstractPolynomial)
    return compare_terms(p1, p2, iszero, isequal)
end

Base.:(==)(p::RationalPoly, q::RationalPoly) = p.num * q.den == q.num * p.den
# Solve ambiguity with (::PolyType, ::Any)
Base.:(==)(p::_APL, q::RationalPoly) = p * q.den == q.num
Base.:(==)(q::RationalPoly, p::_APL) = p == q
Base.:(==)(α, q::RationalPoly) = α * q.den == q.num
Base.:(==)(q::RationalPoly, α) = α == q
function Base.isequal(p::RationalPoly, q::RationalPoly)
    return isequal(p.num * q.den, q.num * p.den)
end
# Solve ambiguity with (::PolyType, ::Any)
Base.isequal(p::_APL, q::RationalPoly) = isequal(p * q.den, q.num)
Base.isequal(q::RationalPoly, p::_APL) = isequal(p, q)
Base.isequal(α, q::RationalPoly) = isequal(α * q.den, q.num)
Base.isequal(q::RationalPoly, α) = isequal(α, q)

# α could be a JuMP affine expression
isapproxzero(α; ztol::Real = 0.0) = false
function isapproxzero(α::Number; ztol::Real = Base.rtoldefault(α, α, 0))
    return abs(α) <= ztol
end

isapproxzero(m::AbstractMonomialLike; kwargs...) = false
function isapproxzero(t::AbstractTermLike; kwargs...)
    return isapproxzero(coefficient(t); kwargs...)
end
function isapproxzero(p::_APL; kwargs...)
    return all(term -> isapproxzero(term; kwargs...), terms(p))
end
isapproxzero(p::RationalPoly; kwargs...) = isapproxzero(p.num; kwargs...)

function Base.isapprox(t1::AbstractTerm, t2::AbstractTerm; kwargs...)
    return isapprox(coefficient(t1), coefficient(t2); kwargs...) &&
           monomial(t1) == monomial(t2)
end
function Base.isapprox(
    p1::AbstractPolynomial{S},
    p2::AbstractPolynomial{T};
    atol = 0,
    ztol::Real = iszero(atol) ? Base.rtoldefault(S, T, 0) : atol,
    kwargs...,
) where {S,T}
    return compare_terms(
        p1,
        p2,
        t -> isapproxzero(t; ztol = ztol),
        (x, y) -> isapprox(x, y; atol = atol, kwargs...),
    )
end

function Base.isapprox(p::RationalPoly, q::RationalPoly; kwargs...)
    return isapprox(p.num * q.den, q.num * p.den; kwargs...)
end
function Base.isapprox(p::RationalPoly, q::_APL; kwargs...)
    return isapprox(p.num, q * p.den; kwargs...)
end
function Base.isapprox(p::_APL, q::RationalPoly; kwargs...)
    return isapprox(p * q.den, q.num; kwargs...)
end
function Base.isapprox(q::RationalPoly{C}, α; kwargs...) where {C}
    return isapprox(q, constant_term(α, q.den); kwargs...)
end
function Base.isapprox(α, q::RationalPoly{C}; kwargs...) where {C}
    return isapprox(constant_term(α, q.den), q; kwargs...)
end

# TODO refer to the parallel with `mstructure(p)(e1, e2)` which gives the result
#      of multiplying the monomials corresponding to the exponent vectors `e1`
#      and `e2`.
"""
    abstract type AbstractMonomialOrdering end

Abstract type for monomial ordering as defined in [CLO13, Definition 2.2.1, p. 55]

Given an ordering `ordering::AbstractMonomialOrdering` and vector of exponents `e1`
and `e2`, `cmp(ordering, e1, e2)` returns a negative number if `e1` is before `e2`
in the ordering, a positive number if `e2` is before `e1` and 0 if they are equal.
For convenience, `ordering(e1, e2)` returns a `Bool` indicating whether
`cmp(ordering, e1, e2)` is negative.

[CLO13] Cox, D., Little, J., & OShea, D.
*Ideals, varieties, and algorithms: an introduction to computational algebraic geometry and commutative algebra*.
Springer Science & Business Media, **2013**.
"""
abstract type AbstractMonomialOrdering end

# We can't write this with a type instead of an instance so this motivates
# why we work with instances and not types even if they don't have any data
# that's not already in the type.
# This is also to be consistent with `StarAlgebras.MultiplicativeStructure`
(ordering::AbstractMonomialOrdering)(i, j) = cmp(ordering, i, j) < 0

"""
    struct LexOrder <: AbstractMonomialOrdering end

Lexicographic (Lex for short) Order often abbreviated as *lex* order as defined in [CLO13, Definition 2.2.3, p. 56]

The [`Graded`](@ref) version is often abbreviated as *grlex* order and is defined in [CLO13, Definition 2.2.5, p. 58]

[CLO13] Cox, D., Little, J., & OShea, D.
*Ideals, varieties, and algorithms: an introduction to computational algebraic geometry and commutative algebra*.
Springer Science & Business Media, **2013**.
"""
struct LexOrder <: AbstractMonomialOrdering end

const _TupleOrVector = Union{Tuple,AbstractVector}

function Base.cmp(::LexOrder, exp1::_TupleOrVector, exp2::_TupleOrVector)
    return cmp(exp1, exp2)
end

"""
    struct InverseLexOrder <: AbstractMonomialOrdering end

Inverse Lex Order defined in [CLO13, Exercise 2.2.6, p. 61] where it is abbreviated as *invlex*.
It corresponds to [`LexOrder`](@ref) but with the variables in reverse order.

The [`Graded`](@ref) version can be abbreviated as *grinvlex* order.
It is defined in [BDD13, Definition 2.1] where it is called *Graded xel order*.

[CLO13] Cox, D., Little, J., & OShea, D.
*Ideals, varieties, and algorithms: an introduction to computational algebraic geometry and commutative algebra*.
Springer Science & Business Media, **2013**.
[BDD13] Batselier, K., Dreesen, P., & De Moor, B.
*The geometry of multivariate polynomial division and elimination*.
SIAM Journal on Matrix Analysis and Applications, 34(1), 102-125, *2013*.
"""
struct InverseLexOrder <: AbstractMonomialOrdering end

# We can't use `Iterators.Reverse` because it's not an `AbstractVector`
# so not `cmp` methods is defined for it.
_rev(v::AbstractVector) = view(v, lastindex(v):-1:firstindex(v))
_rev(t::Tuple) = reverse(t)
function Base.cmp(::InverseLexOrder, exp1::_TupleOrVector, exp2::_TupleOrVector)
    return cmp(_rev(exp1), _rev(exp2))
end

"""
    struct Graded{O<:AbstractMonomialOrdering} <: AbstractMonomialOrdering
        same_degree_ordering::O
    end

Monomial ordering defined by:
* `degree(a) == degree(b)` then the ordering is determined by `same_degree_ordering`,
* otherwise, it is the ordering between the integers `degree(a)` and `degree(b)`.
"""
struct Graded{O<:AbstractMonomialOrdering} <: AbstractMonomialOrdering
    same_degree_ordering::O
end
Graded{O}() where {O<:AbstractMonomialOrdering} = Graded{O}(O())

function Base.cmp(ordering::Graded, a::_TupleOrVector, b::_TupleOrVector)
    deg_a = sum(a)
    deg_b = sum(b)
    if deg_a == deg_b
        return cmp(ordering.same_degree_ordering, a, b)
    else
        return deg_a - deg_b
    end
end

"""
    struct Reverse{O<:AbstractMonomialOrdering} <: AbstractMonomialOrdering
        reverse_order::O
    end

Monomial ordering defined by
`cmp(o::Reverse, a, b) where {O} = cmp(o.reverse_order, b, a)`.

Reverse Lex Order defined in [CLO13, Exercise 2.2.9, p. 61] where it is abbreviated as *rinvlex*.
can be obtained as `Reverse{InverseLexOrder}`.

The Graded Reverse Lex Order often abbreviated as *grevlex* order defined in [CLO13, Definition 2.2.6, p. 58]
can be obtained as `Graded{Reverse{InverseLexOrder}}`.

[CLO13] Cox, D., Little, J., & OShea, D.
*Ideals, varieties, and algorithms: an introduction to computational algebraic geometry and commutative algebra*.
Springer Science & Business Media, **2013**.
"""
struct Reverse{O<:AbstractMonomialOrdering} <: AbstractMonomialOrdering
    reverse_ordering::O
end
Reverse{O}() where {O<:AbstractMonomialOrdering} = Reverse{O}(O())

function Base.cmp(ordering::Reverse, a::_TupleOrVector, b::_TupleOrVector)
    return cmp(ordering.reverse_ordering, b, a)
end

#TODO(breaking) Return an instance, not a type
"""
    ordering(p::AbstractPolynomialLike)::Type{<:AbstractMonomialOrdering}

Returns the [`AbstractMonomialOrdering`](@ref) type to be used to compare
exponent vectors for the monomials of `p`.
"""
function ordering end

ordering(::Type{<:AbstractMonomial}) = Graded{LexOrder}
ordering(::Type{P}) where {P} = ordering(monomial_type(P))
ordering(p::AbstractPolynomialLike) = ordering(typeof(p))
# Useful for instance to ask ordering given the list
# of variables
ordering(::AbstractVector{T}) where {T} = ordering(T)
ordering(t::Tuple) = ordering(first(t))

# We reverse the order of comparisons here so that the result
# of x < y is equal to the result of Monomial(x) < Monomial(y)
# Without `Base.@pure`, TypedPolynomials allocates on Julia v1.6
# with `promote(x * y, x)`
Base.@pure function Base.cmp(v1::AbstractVariable, v2::AbstractVariable)
    return -cmp(name(v1), name(v2))
end

function Base.cmp(m1::AbstractMonomial, m2::AbstractMonomial)
    s1, s2 = promote_variables(m1, m2)
    return cmp(ordering(m1)(), exponents(s1), exponents(s2))
end

function compare(
    m1::AbstractMonomial,
    m2::AbstractMonomial,
    ::Type{O},
) where {O<:AbstractMonomialOrdering}
    s1, s2 = promote_variables(m1, m2)
    return cmp(O(), exponents(s1), exponents(s2))
end

# Implement this to make coefficients be compared with terms.
function _cmp_coefficient(a::Real, b::Real)
    return cmp(a, b)
end
function _cmp_coefficient(a::Number, b::Number)
    return cmp(abs(a), abs(b))
end
# By default, coefficients are not comparable so `a` is not strictly
# less than `b`, they are considered sort of equal.
_cmp_coefficient(a, b) = 0

function Base.cmp(t1::AbstractTermLike, t2::AbstractTermLike)
    Δ = cmp(monomial(t1), monomial(t2))
    if iszero(Δ)
        return _cmp_coefficient(coefficient(t1), coefficient(t2))
    end
    return Δ
end

Base.isless(t1::AbstractTermLike, t2::AbstractTermLike) = compare(t1, t2) < 0

"""
    struct ExponentsIterator{M}(
        object;
        mindegree::Int = 0,
        maxdegree::Union{Nothing,Int} = nothing,
        inline::Bool = false,
    )

An iterator for generating monomial exponents for monomial
ordering `M`. The type of the vector of exponents is the type of
`object` and is length (i.e., the number of variables) is `length(object)`.

Note that `object` does not have to be zero, it just needs to implement
`copy` and `setindex!` methods (except for `Tuple` which we handle with a
special case).

See also [`monomials`](@ref).

### Examples

The following example shows how to generate all exponents of
monomials of 2 variables up to degree 2.
```jldoctest
julia> collect(ExponentsIterator{Graded{LexOrder}}((0, 0), maxdegree = 2))
6-element Vector{Tuple{Int64, Int64}}:
 (0, 0)
 (0, 1)
 (1, 0)
 (0, 2)
 (1, 1)
 (2, 0)
```
Note that you can easily generate the tuple of exponents
of arbitrary length using `ntuple` as follows:
```jldoctest
julia> collect(ExponentsIterator{Graded{LexOrder}}(ntuple(zero, 3), mindegree = 2, maxdegree = 2))
6-element Vector{Tuple{Int64, Int64, Int64}}:
 (0, 0, 2)
 (0, 1, 1)
 (0, 2, 0)
 (1, 0, 1)
 (1, 1, 0)
 (2, 0, 0)
```
You can also change the monomial ordering and use `Vector` instead of `Tuple` as follows:
```jldoctest
julia> collect(ExponentsIterator{LexOrder}(zeros(Int, 2), mindegree = 2, maxdegree = 3))
7-element Vector{Vector{Int64}}:
 [0, 2]
 [0, 3]
 [1, 1]
 [1, 2]
 [2, 0]
 [2, 1]
 [3, 0]
```
"""
struct ExponentsIterator{M,D<:Union{Nothing,Int},O}
    object::O # Used to get number of variables and get new zero elements
    mindegree::Int
    maxdegree::D
    inline::Bool

    function ExponentsIterator{M}(
        object;
        mindegree::Int = 0,
        maxdegree::Union{Nothing,Int} = nothing,
        inline::Bool = false,
    ) where {M}
        if mindegree < 0
            throw(
                ArgumentError(
                    "The `mindegree` of `ExponentsIterator` cannot be negative.",
                ),
            )
        end
        if M <: Reverse
            throw(
                ArgumentError(
                    "Ordering `$M` is not a valid ordering, use `Graded{$M}` instead.",
                ),
            )
        end
        return new{M,typeof(maxdegree),typeof(object)}(
            object,
            mindegree,
            maxdegree,
            inline,
        )
    end
end

Base.eltype(::Type{ExponentsIterator{M,D,O}}) where {M,D,O} = O
# `IteratorSize` may actually be finite if the list of variables is empty.
# The same issue happens for `Iterators.Cycle`:
# https://github.com/JuliaLang/julia/pull/54187
# With `Base.IsInfinite`, some tests fail but with `Base.SizeUnknown`, all
# tests pass.
function Base.IteratorSize(::Type{<:ExponentsIterator{M,Nothing}}) where {M}
    return Base.SizeUnknown()
end
function Base.IteratorSize(::Type{<:ExponentsIterator{M,Int}}) where {M}
    return Base.HasLength()
end

function Base.:(==)(a::ExponentsIterator, b::ExponentsIterator)
    return typeof(a.object) == typeof(b.object) &&
           length(a.object) == length(b.object) &&
           a.mindegree == b.mindegree &&
           a.maxdegree == b.maxdegree
end

function _length(it::ExponentsIterator, maxdegree)
    if maxdegree < it.mindegree
        return 0
    end
    len = binomial(nvariables(it) + maxdegree, nvariables(it))
    if it.mindegree > 0
        len -= binomial(nvariables(it) + it.mindegree - 1, nvariables(it))
    end
    return len
end

function Base.length(it::ExponentsIterator{M,Int}) where {M}
    return _length(it, it.maxdegree)
end

function Base.length(it::ExponentsIterator{M,Nothing}) where {M}
    if isempty(it.object)
        return _length(it, it.mindegree)
    else
        error("The iterator is infinity because `maxdegree` is `nothing`.")
    end
end

nvariables(it::ExponentsIterator) = length(it.object)

function Base.in(x, it::ExponentsIterator)
    if length(x) != nvariables(it)
        return false
    end
    if any(xi -> xi < 0, x)
        return false
    end
    deg = sum(x)
    if deg < it.mindegree
        return false
    end
    if it.maxdegree !== nothing && deg > it.maxdegree
        return false
    end
    return true
end

_last_lex_index(n, ::Type{LexOrder}) = n
_prev_lex_index(i, ::Type{LexOrder}) = i - 1
_not_first_indices(n, ::Type{LexOrder}) = n:-1:2
_last_lex_index(_, ::Type{InverseLexOrder}) = 1
_prev_lex_index(i, ::Type{InverseLexOrder}) = i + 1
_not_first_indices(n, ::Type{InverseLexOrder}) = 1:(n-1)
_last_lex_index(n, ::Type{Reverse{LexOrder}}) = 1
_prev_lex_index(i, ::Type{Reverse{LexOrder}}) = i + 1
_not_first_indices(n, ::Type{Reverse{LexOrder}}) = (n-1):-1:1
_last_lex_index(n, ::Type{Reverse{InverseLexOrder}}) = n
_prev_lex_index(i, ::Type{Reverse{InverseLexOrder}}) = i - 1
_not_first_indices(n, ::Type{Reverse{InverseLexOrder}}) = 2:n
_last_lex_index(n, ::Type{Graded{M}}) where {M} = _last_lex_index(n, M)
_prev_lex_index(i, ::Type{Graded{M}}) where {M} = _prev_lex_index(i, M)
_not_first_indices(n, ::Type{Graded{M}}) where {M} = _not_first_indices(n, M)

_increase_degree(it::ExponentsIterator{<:Graded,Nothing}, _) = false
_increase_degree(it::ExponentsIterator{<:Graded,Int}, _) = false
_increase_degree(it::ExponentsIterator{M,Nothing}, _) where {M} = true
function _increase_degree(it::ExponentsIterator{M,Int}, deg) where {M}
    return deg < it.maxdegree
end

# We just changed the degree by removing `Δ`,
# In graded ordering, we just add `Δ` to maintain the same degree
_adjust_degree(::ExponentsIterator{<:Graded}, _, Δ) = Δ
# Otherwise, we just need the degree to stay above `it.mindegree`,
# so we need to add `it.mindegree - deg`
_adjust_degree(it::ExponentsIterator, deg, _) = max(0, it.mindegree - deg)

# Same as `BangBang.setindex!!`
_setindex!(x, v, i) = Base.setindex!(x, v, i)
_setindex!(x::Tuple, v, i) = Base.setindex(x, v, i)
_increment!(x, Δ, i) = _setindex!(x, x[i] + Δ, i)

_zero(x) = zero(x)
_zero(x::Tuple) = zero.(x)

_zero!(x) = fill!(x, 0)
_zero!(x::Tuple) = _zero(x)

_copy(x) = copy(x)
_copy(x::Tuple) = x

function __iterate!(
    it::ExponentsIterator{Graded{Reverse{M}}},
    z,
    i,
    deg,
) where {M}
    z = _increment!(z, -1, i)
    k = _last_lex_index(nvariables(it), M)
    Δ = z[k] + 1
    z = _setindex!(z, 0, k)
    z = _setindex!(z, Δ, _prev_lex_index(i, Reverse{M}))
    return z, deg
end

function __iterate!(it::ExponentsIterator{M}, z, i, deg) where {M}
    Δ = z[i] - 1
    z = _setindex!(z, 0, i)
    deg -= Δ
    Δ = _adjust_degree(it, deg, Δ)
    deg += Δ
    z = _setindex!(z, Δ, _last_lex_index(nvariables(it), M))
    z = _increment!(z, 1, _prev_lex_index(i, M))
    return z, deg
end

function _iterate!(it::ExponentsIterator{M}, z, deg) where {M}
    if _increase_degree(it, deg)
        z = _increment!(z, 1, _last_lex_index(nvariables(it), M))
        return z, deg + 1
    end
    I = _not_first_indices(nvariables(it), M)
    i = findfirst(i -> !iszero(z[i]), I)
    if isnothing(i)
        if !isnothing(it.maxdegree) && deg == it.maxdegree
            return
        end
        z = _zero!(z)
        z = _setindex!(z, deg + 1, _last_lex_index(nvariables(it), M))
        return z, deg + 1
    end
    return __iterate!(it, z, I[i], deg)
end

function Base.iterate(it::ExponentsIterator{M}) where {M}
    z = _zero(it.object)
    if !isnothing(it.maxdegree) && it.maxdegree < it.mindegree
        return
    end
    if it.mindegree > 0
        if nvariables(it) == 0
            return
        end
        z = _setindex!(z, it.mindegree, _last_lex_index(nvariables(it), M))
    end
    return z, (z, it.mindegree)
end

function Base.iterate(it::ExponentsIterator, state)
    if nvariables(it) == 0
        return # There cannot be more than 1 element
    end
    z, deg = state
    if !it.inline
        z = _copy(z)
    end
    state = _iterate!(it, z, deg)
    if isnothing(state)
        return
    end
    return state[1], state
end

# TODO Backward compat, remove the following in next breaking release
"""
    compare(a, b, order::Type{<:AbstractMonomialOrdering})

Returns a negative number if `a < b`, a positive number if `a > b` and zero if `a == b`.
The comparison is done according to `order`.

**Warning** This is deprecated, use `cmp(order(), a, b)` instead.
"""
function compare end

function compare(t1::AbstractTermLike, t2::AbstractTermLike)
    return compare(t1, t2, ordering(t1))
end

function compare(
    e1::_TupleOrVector,
    e2::_TupleOrVector,
    ::Type{O},
) where {O<:AbstractMonomialOrdering}
    return cmp(O(), e1, e2)
end

function compare(
    t1::AbstractTermLike,
    t2::AbstractTermLike,
    ::Type{O},
) where {O<:AbstractMonomialOrdering}
    Δ = compare(monomial(t1), monomial(t2), O)
    if iszero(Δ)
        return _cmp_coefficient(coefficient(t1), coefficient(t2))
    end
    return Δ
end

function compare(
    a::AbstractMonomial,
    b::AbstractMonomial,
    ::Type{Graded{O}},
) where {O}
    deg_a = degree(a)
    deg_b = degree(b)
    if deg_a == deg_b
        return compare(a, b, O)
    else
        return deg_a - deg_b
    end
end

function compare(
    a::AbstractMonomial,
    b::AbstractMonomial,
    ::Type{Reverse{O}},
) where {O}
    return compare(b, a, O)
end

Base.isless(v1::AbstractVariable, v2::AbstractVariable) = cmp(v1, v2) < 0

@testset "Product with non-commutative monomials and variables" begin
    Mod.@ncpolyvar x y z
    m1 = x * (y * x)
    @test variables(m1)[1] == x
    @test variables(m1)[2] == y
    @test variables(m1)[3] == x
    @test all(exponents(m1) .== 1)
    m2 = y * (y * x)
    @test variables(m2)[1] == y
    @test variables(m2)[2] == x
    @test collect(exponents(m2)) == [2, 1]
    for m3 in [
        (x * x) * (y^2 * x),
        (x * x * y) * (y * x),
        x * (x * y^2 * x),
        (x^2 * y^2) * x,
    ]
        @test variables(m3)[1] == x
        @test variables(m3)[2] == y
        @test variables(m3)[3] == x
        @test collect(exponents(m3)) == [2, 2, 1]
    end
    mv = monomial_vector([x, y, x * y])
    @test x * mv == [x^2, x * y, x^2 * y]
    @test mv * x == [x^2, y * x, x * y * x]
    @test y^2 * mv == [y^2 * x, y^3, y^2 * x * y]
    @test mv * y^2 == [x * y^2, y^3, x * y^3]
    m4 = y * x^2
    @test variables(m4)[1] == y
    @test variables(m4)[2] == x
    @test collect(exponents(m4)) == [1, 2]

    @test (x * y) * (3x^2 + 2x * y + 4y^2) ==
          3x * y * x^2 + 2x * y * x * y + 4x * y^3

    P = [
        2 3 4
        3 4 5
        4 5 6
    ]
    Q = [
        4 3 5
        3 2 4
        5 4 6
    ]
    p = @inferred polynomial(P, [x * y, x^2, y^2])
    @test coefficients(p) == reverse([4, 3, 5, 4, 3, 2, 6, 5, 4])
    @test monomials(p) == reverse([
        x^4,
        x^3 * y,
        x^2 * y^2,
        x * y^3,
        x * y * x^2,
        x * y * x * y,
        y^4,
        y^2 * x^2,
        y^2 * x * y,
    ])
    p = @inferred polynomial(
        Q[3:-1:1, 3:-1:1],
        monomial_vector([x * y, x^2, y^2]),
    )
    @test coefficients(p) == reverse([4, 3, 5, 4, 3, 2, 6, 5, 4])
    @test monomials(p) == reverse([
        x^4,
        x^3 * y,
        x^2 * y^2,
        x * y^3,
        x * y * x^2,
        x * y * x * y,
        y^4,
        y^2 * x^2,
        y^2 * x * y,
    ])
    q = @inferred polynomial(zeros(Float64, 0, 0), empty_monomial_vector(x))
    @test q isa AbstractPolynomialLike{Float64}
    @test q == 0
end
@testset "Noncommutative quadratic" begin
    Mod.@ncpolyvar x[1:2]
    Q = Hermitian([4 2-3im; 2+3im 1])
    p = 1x[1]^2 + (2 + 3im) * x[1] * x[2] + (2 - 3im) * x[2] * x[1] + 4x[2]^2
    @test polynomial(Q[2:-1:1, 2:-1:1], x) == p
    @test polynomial(Q, monomial_vector(x)) == p
end

function monomials(v::AbstractVariable, degree, args...)
    return monomials(variables(v), degree, args...)
end

"""
    empty_monomial_vector(p::AbstractPolynomialLike)

Returns an empty collection of the type of `monomials(p)`.
"""
empty_monomial_vector(p) = monomial_type(p)[]

"""
    monomial_vector(X::AbstractVector{MT}) where {MT<:AbstractMonomialLike}

Returns the vector of monomials `X` in increasing order and without any duplicates.

### Examples

Calling `monomial_vector` on ``[xy, x, xy, x^2y, x]`` should return ``[x^2y, xy, x]``.
"""
function monomial_vector(X::AbstractVector{MT}) where {MT<:AbstractMonomial}
    Y = sort(X)
    dups = findall(i -> Y[i] == Y[i-1], 2:length(Y))
    deleteat!(Y, dups)
    return Y
end
function monomial_vector(X::AbstractVector{TT}) where {TT<:AbstractTermLike}
    return monomial_vector(AbstractVector{monomial_type(TT)}(X))
end

"""
    monomial_vector(a, X::AbstractVector{MT}) where {MT<:AbstractMonomialLike}

Returns `b, Y` where `Y` is the vector of monomials of `X` in increasing order
and without any duplicates and `b` is the vector of corresponding coefficients
in `a`, where coefficients of duplicate entries are summed together.

### Examples

Calling `monomial_vector` on ``[2, 1, 4, 3, -1], [xy, x, xy, x^2y, x]`` should return
``[3, 6, 0], [x^2y, xy, x]``.
"""
function monomial_vector(a, x)
    if length(a) != length(x)
        throw(
            ArgumentError("There should be as many coefficient than monomials"),
        )
    end
    σ, X = sort_monomial_vector(x)
    b = a[σ]
    if length(x) > length(X)
        rev = Dict(X[j] => j for j in eachindex(σ))
        for i in eachindex(x)
            j = rev[x[i]]
            if i != σ[j]
                b[j] += a[i]
            end
        end
    end
    return b, X
end

"""
    monomial_vector_type(X::AbstractVector{MT}) where {MT<:AbstractMonomialLike}

Returns the return type of `monomial_vector`.
"""
function monomial_vector_type(
    ::Union{AbstractVector{PT},Type{<:AbstractVector{PT}}},
) where {PT<:_APL}
    return monomial_vector_type(PT)
end
function monomial_vector_type(::Union{PT,Type{PT}}) where {PT<:_APL}
    return Vector{monomial_type(PT)}
end

# If there are duplicates in X, the coefficients should be summed for a polynomial and they should be equal for a measure.
"""
    sort_monomial_vector(X::AbstractVector{MT}) where {MT<:AbstractMonomialLike}

Returns `σ`, the orders in which one must take the monomials in `X` to make them sorted and without any duplicate and the sorted vector of monomials, i.e. it returns `(σ, X[σ])`.

### Examples

Calling `sort_monomial_vector` on ``[xy, x, xy, x^2y, x]`` should return ``([4, 1, 2], [x^2y, xy, x])``.
"""
function sort_monomial_vector(
    X::AbstractVector{MT},
) where {MT<:AbstractMonomial}
    σ = sortperm(X)
    dups = findall(i -> X[σ[i]] == X[σ[i-1]], 2:length(σ))
    deleteat!(σ, dups)
    return σ, X[σ]
end
function sort_monomial_vector(
    X::AbstractVector{TT},
) where {TT<:AbstractTermLike}
    return sort_monomial_vector(AbstractVector{monomial_type(TT)}(X))
end
sort_monomial_vector(X::Tuple) = sort_monomial_vector(vec(X))

"""
    merge_monomial_vectors{MT<:AbstractMonomialLike, MVT<:AbstractVector{MT}}(X::AbstractVector{MVT}}

Returns the vector of monomials in the entries of `X` in increasing order and without any duplicates, i.e. `monomial_vector(vcat(X...))`

### Examples

Calling `merge_monomial_vectors` on ``[[xy, x, xy], [x^2y, x]]`` should return ``[x^2y, xy, x]``.
"""
merge_monomial_vectors(X) = monomial_vector(reduce(vcat, X))

function error_for_negative_degree(deg)
    if deg < 0
        throw(
            ArgumentError(
                "The degree should be a nonnegative number but the provided degree `$deg` is negative.",
            ),
        )
    end
end

"""
    term(coef, mono::AbstractMonomialLike)

Returns a term with coefficient `coef` and monomial `mono`. There are two key
difference between this and `coef * mono`:

* `term(coef, mono)` does not copy `coef` and `mono` so modifying this term
  with MutableArithmetics may modifying the input of this function.
  To avoid this, call `term(MA.copy_if_mutable(coef), MA.copy_if_mutable(mono))`
  where `MA = MutableArithmetics`.
* Suppose that `coef = (x + 1)` and `mono = x^2`, `coef * mono` gives the polynomial
  with integer coefficients `x^3 + x^2` which `term(x + 1, x^2)` gives a term
  with polynomial coefficient `x + 1`.

    term(p::AbstractPolynomialLike)

Converts the polynomial `p` to a term.
When applied on a polynomial, it throws an `InexactError` if it has more than one term.
When applied to a term, it is the identity and does not copy it.
When applied to a monomial, it create a term of type `AbstractTerm{Int}`.
"""
function term end
term(coef, var::AbstractVariable) = term(coef, monomial(var))
function term(coef, mono::AbstractMonomialLike)
    return term_type(mono, typeof(coef))(coef, mono)
end
term(p::_APL) = convert(term_type(typeof(p)), p)

"""
    term_type(p::AbstractPolynomialLike)

Returns the type of the terms of `p`.

    term_type(::Type{PT}) where PT<:AbstractPolynomialLike

Returns the type of the terms of a polynomial of type `PT`.

    term_type(p::AbstractPolynomialLike, ::Type{T}) where T

Returns the type of the terms of `p` but with coefficient type `T`.

    term_type(::Type{PT}, ::Type{T}) where {PT<:AbstractPolynomialLike, T}

Returns the type of the terms of a polynomial of type `PT` but with coefficient type `T`.
"""
term_type(::Type{T}) where {T<:AbstractTerm} = T
term_type(p::Type{<:_APL}, ::Type{T}) where {T} = term_type(term_type(p), T)
term_type(::Type{M}) where {M<:AbstractMonomialLike} = term_type(M, Int)
term_type(v::Type{<:AbstractVariable}) = term_type(monomial_type(v))
function term_type(v::Type{<:AbstractVariable}, ::Type{T}) where {T}
    return term_type(monomial_type(v), T)
end
term_type(p::_APL, ::Type{T}) where {T} = term_type(typeof(p), T)
term_type(p::_APL) = term_type(typeof(p))
function term_type(
    ::Union{AbstractVector{PT},Type{<:AbstractVector{PT}}},
) where {PT<:_APL}
    return term_type(PT)
end
function term_type(
    ::Union{AbstractVector{PT},Type{<:AbstractVector{PT}}},
    ::Type{T},
) where {PT<:_APL,T}
    return term_type(PT, T)
end

"""
    coefficient(t::AbstractTermLike)

Returns the coefficient of the term `t`.

    coefficient(p::AbstractPolynomialLike, m::AbstractMonomialLike)

Returns the coefficient of the monomial `m` in `p`.

### Examples

Calling `coefficient` on ``4x^2y`` should return ``4``.
Calling `coefficient(2x + 4y^2 + 3, y^2)` should return ``4``.
Calling `coefficient(2x + 4y^2 + 3, x^2)` should return ``0``.
"""
function coefficient end
coefficient(t::AbstractTerm) = t.coefficient # by convention, the field should be `coefficient`
coefficient(m::AbstractMonomialLike) = 1
function coefficient(
    p::AbstractPolynomialLike{T},
    m::AbstractMonomialLike,
) where {T}
    for t in terms(p)
        if monomial(t) == m
            return coefficient(t)
        end
    end
    return zero(T)
end

"""
    coefficient(p::AbstractPolynomialLike, m::AbstractMonomialLike, vars)::AbstractPolynomialLike

Returns the coefficient of the monomial `m` of the polynomial `p` considered as a polynomial in variables
`vars`.

### Example
Calling `coefficient((a+b)x^2+2x+y*x^2, x^2, [x,y])` should return `a+b`.
Calling `coefficient((a+b)x^2+2x+y*x^2, x^2, [x])` should return `a+b+y`.
"""
function coefficient(f::_APL, m::AbstractMonomialLike, vars)
    coeff = zero(f)
    for t in terms(f)
        match = true
        for v in vars
            if degree(t, v) != degree(m, v)
                match = false
                break
            end
        end
        match || continue

        coeff += term(coefficient(t), div_multiple(monomial(t), m))
    end
    return coeff
end

"""
    coefficient_type(p::AbstractPolynomialLike)

Returns the coefficient type of `p`.

    coefficient_type(::Type{PT}) where PT

Returns the coefficient type of a polynomial of type `PT`.

### Examples

Calling `coefficient_type` on ``(4//5)x^2y`` should return `Rational{Int}`,
calling `coefficient_type` on ``1.0x^2y + 2.0x`` should return `Float64` and
calling `coefficient_type` on ``xy`` should return `Int`.
"""
function coefficient_type(
    ::Union{PT,Type{PT},AbstractVector{PT},Type{<:AbstractVector{PT}}},
) where {T,PT<:_APL{T}}
    return T
end
#coefficient_type(::{T, Type{T}}) where {T} = T

"""
    monomial(t::AbstractTermLike)

Returns the monomial of the term `t`.

### Examples

Calling `monomial` on ``4x^2y`` should return ``x^2y``.

    monomial(variables, exponents)

Returns the monomial corresponding to `prod(variables .^ exponents)`

### Examples

In order to create `x^2 * y`,

* with DynamicPolynomials, use `monomial([x, y], [2, 1])`,
* with TypedPolynomials, use `monomial((x, y), (2, 1))`.
"""
function monomial end
monomial(t::AbstractTerm) = t.monomial # by convention, the field should be `monomial`.
monomial(m::AbstractMonomial) = m

"""
    constant_term(α, p::AbstractPolynomialLike)

Creates a constant term with coefficient α and the same variables as p.

    constant_term(α, ::Type{PT} where {PT<:AbstractPolynomialLike}

Creates a constant term of the term type of a polynomial of type `PT`.
"""
constant_term(α, p) = term(α, constant_monomial(p))

# zero should return a polynomial since it is often used to keep the result of a summation of terms.
# For example, Base.vecdot(x::Vector{<:AbstractTerm}, y:Vector{Int}) starts with `s = zero(dot(first(x), first(y)))` and then adds terms.
# We want `s` to start as a polynomial for this operation to be efficient.
#Base.zero(::Type{TT}) where {T, TT<:AbstractTermLike{T}} = zero(T) * constant_monomial(TT)
#Base.zero(t::AbstractTermLike{T}) where {T} = zero(T) * constant_monomial(t)
"""
    zero_term(p::AbstractPolynomialLike{T}) where T

Equivalent to `constant_term(zero(T), p)`.

    zero_term(α, ::Type{PT} where {T, PT<:AbstractPolynomialLike{T}}

Equivalent to `constant_term(zero(T), PT)`.
"""
zero_term(::Type{PT}) where {T,PT<:_APL{T}} = constant_term(zero(T), PT)
zero_term(p::_APL{T}) where {T} = constant_term(zero(T), p)

function Base.zero(::Type{TT}) where {T,TT<:AbstractTermLike{T}}
    return zero(polynomial_type(TT))
end
Base.zero(t::AbstractTermLike{T}) where {T} = zero(polynomial_type(t))
function MA.promote_operation(::typeof(zero), PT::Type{<:AbstractTermLike})
    return polynomial_type(PT)
end
function Base.one(::Type{TT}) where {T,TT<:AbstractTermLike{T}}
    return term(one(T), constant_monomial(TT))
end
Base.one(t::AbstractTermLike{T}) where {T} = term(one(T), constant_monomial(t))
function MA.promote_operation(::typeof(one), TT::Type{<:AbstractTermLike})
    return term_type(TT)
end
function MA.promote_operation(::typeof(one), PT::Type{<:AbstractPolynomialLike})
    return polynomial_type(PT)
end

function Base.round(p::_APL; args...)
    # round(0.1) is zero so we cannot use `nonzero=true`
    return map_coefficients(p) do term
        return round(term; args...)
    end
end

function Base.div(p::_APL, α::Number, args...)
    return map_coefficients(p) do term
        return div(term, α, args...)
    end
end

"""
    divides(t1::AbstractTermLike, t2::AbstractTermLike)

Returns whether the monomial of t1 divides the monomial of t2.

### Examples

Calling `divides(2x^2y, 3xy)` should return false because `x^2y` does not divide `xy` since `x` has a degree 2 in `x^2y` which is greater than the degree of `x` on `xy`.
However, calling `divides(3xy, 2x^2y)` should return true.
"""
function divides(t1::AbstractTermLike, t2::AbstractTermLike)
    return divides(monomial(t1), monomial(t2))
end
divides(t1::AbstractVariable, t2::AbstractVariable) = t1 == t2

"""
    gcd(m1::AbstractMonomialLike, m2::AbstractMonomialLike)

Return the largest monomial `m` such that both `divides(m, m1)`
and `divides(m, m2)` are `true`.

```@example
julia> @polyvar x y z;

julia> gcd(x^2*y^7*z^3, x^4*y^5*z^2)
x²y⁵z²
```
"""
function Base.gcd(m1::AbstractMonomialLike, m2::AbstractMonomialLike)
    return map_exponents(min, m1, m2)
end

"""
    lcm(m1::AbstractMonomialLike, m2::AbstractMonomialLike)

Return the smallest monomial `m` such that both `divides(m1, m)`
and `divides(m2, m)` are `true`.

```@example
julia> @polyvar x y z;

julia> lcm(x^2*y^7*z^3, x^4*y^5*z^2)
x^4*y^7*z^3
```
"""
function Base.lcm(m1::AbstractMonomialLike, m2::AbstractMonomialLike)
    return map_exponents(max, m1, m2)
end

struct Field end
struct UniqueFactorizationDomain end
const UFD = UniqueFactorizationDomain

"""
    promote_to_field(::Type{T})

Promote the type `T` to a field. For instance, `promote_to_field(T)` returns
`Rational{T}` if `T` is an integer and `promote_to_field(T)` returns `RationalPoly{T}`
if `T` is a polynomial.
"""
function promote_to_field end

function promote_to_field(::Type{T}) where {T<:Integer}
    return Rational{T}
end
function promote_to_field(::Type{T}) where {T<:_APL}
    return RationalPoly{T,T}
end
promote_to_field(::Type{T}) where {T} = T

algebraic_structure(::Type{<:Integer}) = UFD()
algebraic_structure(::Type{<:_APL}) = UFD()
# `Rational`, `AbstractFloat`, JuMP expressions, etc... are fields
algebraic_structure(::Type) = Field()
_field_absorb(::UFD, ::UFD) = UFD()
_field_absorb(::UFD, ::Field) = Field()
_field_absorb(::Field, ::UFD) = Field()
_field_absorb(::Field, ::Field) = Field()

"""
    div_multiple(a, b, ma::MA.MutableTrait)

Return the division of `a` by `b` assuming that `a` is a multiple of `b`.
If `a` is not a multiple of `b` then this function may return anything.
"""
div_multiple(::Field, a, b, ma::MA.MutableTrait) = a / b
div_multiple(::UFD, a, b, ma::MA.IsMutable) = MA.operate!!(div, a, b)
div_multiple(::UFD, a, b, ma::MA.IsNotMutable) = div(a, b)
function div_multiple(a, b, ma::MA.MutableTrait = MA.IsNotMutable())
    return div_multiple(
        algebraic_structure(promote_type(typeof(a), typeof(b))),
        a,
        b,
        ma,
    )
end
function div_multiple(
    m1::AbstractMonomialLike,
    m2::AbstractMonomialLike,
    ::MA.MutableTrait = MA.IsNotMutable(),
)
    return map_exponents(-, m1, m2)
end
function div_multiple(
    t::AbstractTerm,
    m::AbstractMonomial,
    mt::MA.MutableTrait = MA.IsNotMutable(),
)
    return term(_copy(coefficient(t), mt), div_multiple(monomial(t), m))
end
function div_multiple(
    t1::AbstractTermLike,
    t2::AbstractTermLike,
    m1::MA.MutableTrait = MA.IsNotMutable(),
)
    return term(
        div_multiple(coefficient(t1), coefficient(t2), m1),
        div_multiple(monomial(t1), monomial(t2)),
    )
end
function right_constant_div_multiple(
    f::_APL,
    g,
    mf::MA.MutableTrait = MA.IsNotMutable(),
)
    if isone(g)
        return _copy(f, mf)
    end
    return map_coefficients(
        coef -> div_multiple(coef, g, mf),
        f,
        mf;
        nonzero = true,
    )
end
function div_multiple(
    f::_APL,
    g::AbstractMonomialLike,
    mf::MA.MutableTrait = MA.IsNotMutable(),
)
    if isconstant(g)
        return _copy(f, mf)
    end
    return map_exponents(-, f, g, mf)
end
function div_multiple(
    f::_APL,
    g::AbstractTermLike,
    mf::MA.MutableTrait = MA.IsNotMutable(),
)
    f = right_constant_div_multiple(f, coefficient(g), mf)
    return div_multiple(f, monomial(g), MA.IsMutable())
end
function div_multiple(f::_APL, g::_APL, mf::MA.MutableTrait = MA.IsNotMutable())
    lt = leading_term(g)
    if nterms(g) == 1
        return div_multiple(f, lt, mf)
    end
    rf = _copy(f, mf)
    rg = remove_leading_term(g)
    q = zero(rf)
    while !iszero(rf)
        ltf = leading_term(rf)
        if !divides(lt, ltf)
            # In floating point arithmetics, it may happen
            # that `rf` is not zero even if it cannot be reduced further.
            # As `div_multiple` assumes that `g` divides `f`, we know that
            # `rf` is approximately zero anyway.
            break
        end
        qt = div_multiple(ltf, lt)
        q = MA.add!!(q, qt)
        rf = MA.operate!!(remove_leading_term, rf)
        rf = MA.operate!!(MA.sub_mul, rf, qt, rg)
    end
    return q
end

function Base.div(f::_APL, g::Union{_APL,AbstractVector{<:_APL}}; kwargs...)
    return divrem(f, g; kwargs...)[1]
end
function Base.rem(f::_APL, g::Union{_APL,AbstractVector{<:_APL}}; kwargs...)
    return divrem(f, g; kwargs...)[2]
end

"""
    pseudo_divrem(f::_APL{S}, g::_APL{T}, algo) where {S,T}

Return the pseudo divisor and remainder of `f` modulo `g` as defined in [Knu14, Algorithm R, p. 425].

When the coefficient type is not a field, it is not always possible to carry a
division. For instance, the division of `f = 3x + 1` by `g = 2x + 1` cannot be done over
integers. On the other hand, one can write `2f = 3g - 1`.
In general, the *pseudo* division of `f` by `g` is:
```math
l f(x) = q(x) g(x) + r(x)
```
where `l` is a power of the leading coefficient of `g` some constant.

See also [`pseudo_rem`](@ref).

[Knu14] Knuth, D.E., 2014.
*Art of computer programming, volume 2: Seminumerical algorithms.*
Addison-Wesley Professional. Third edition.
"""
function pseudo_divrem(f::_APL{S}, g::_APL{T}, algo) where {S,T}
    return _pseudo_divrem(
        algebraic_structure(MA.promote_operation(-, S, T)),
        f,
        g,
        algo,
    )
end

function _pseudo_divrem(::Field, f::_APL, g::_APL, algo)
    q, r = divrem(f, g)
    return one(q), q, r
end

function _pseudo_divrem(::UFD, f::_APL, g::_APL, algo)
    ltg = leading_term(g)
    rg = remove_leading_term(g)
    ltf = leading_term(f)
    if iszero(f) || !divides(monomial(ltg), ltf)
        return one(f), zero(f), zero(f)
    else
        st = constant_term(coefficient(ltg), f)
        new_f = st * remove_leading_term(f)
        qt = term(coefficient(ltf), div_multiple(monomial(ltf), monomial(ltg)))
        new_g = qt * rg
        # Check with `::` that we don't have any type unstability on this variable.
        return convert(typeof(f), st),
        convert(typeof(f), qt),
        (new_f - new_g)::typeof(f)
    end
end

"""
    pseudo_rem(f::_APL, g::_APL, algo)

Return the pseudo remainder of `f` modulo `g` as defined in [Knu14, Algorithm R, p. 425].

See [`pseudo_divrem`](@ref) for more details.

[Knu14] Knuth, D.E., 2014.
*Art of computer programming, volume 2: Seminumerical algorithms.*
Addison-Wesley Professional. Third edition.
"""
function pseudo_rem(f::_APL, g::_APL, algo)
    return MA.operate!!(pseudo_rem, MA.mutable_copy(f), g, algo)
end

function MA.promote_operation(
    ::typeof(pseudo_rem),
    ::Type{P},
    ::Type{Q},
    ::Type{A},
) where {T,S,P<:_APL{T},Q<:_APL{S},A}
    U1 = MA.promote_operation(*, S, T)
    U2 = MA.promote_operation(*, T, S)
    # `promote_type(P, Q)` is needed for TypedPolynomials in case they use different variables
    return polynomial_type(promote_type(P, Q), MA.promote_operation(-, U1, U2))
end

function MA.buffer_for(::typeof(pseudo_rem), F::Type, G::Type, ::Type)
    return MA.buffer_for(MA.sub_mul, F, term_type(F), G)
end

function _prepare_s_poly!(::typeof(pseudo_rem), f, ltf, ltg)
    MA.operate!(right_constant_mult, f, coefficient(ltg))
    return term(coefficient(ltf), div_multiple(monomial(ltf), monomial(ltg)))
end

function _prepare_s_poly!(::typeof(rem), ::_APL, ltf, ltg)
    return div_multiple(ltf, ltg)
end

function MA.operate!(
    op::Union{typeof(rem),typeof(pseudo_rem)},
    f::_APL,
    g::_APL,
    algo,
)
    return MA.buffered_operate!(nothing, op, f, g, algo)
end

# TODO As suggested in [Knu14, Algorithm R, p. 426] (univariate case only), if
#      `deg(f) = n` and `deg(g) = m`, during the first `n - m - t` steps, the
#      coefficient of the `t`th power will simply be multiplied by the leading
#      coefficient of `g` so we could speed up by multiplying this coefficient
#      to the power `n - m - t` using `Base.power_by_squaring`.
#      However, since there might be missing terms, so we don't know in advance
#      the needed power but we could keep track of it.
function MA.buffered_operate!(
    buffer,
    op::Union{typeof(rem),typeof(pseudo_rem)},
    f::_APL,
    g::_APL,
    algo,
)
    ltg = leading_term(g)
    ltf = leading_term(f)
    # This only makes sense in the univariate case but it's only used for univariate gcd anyway
    skipped_divisions = maxdegree(f) - maxdegree(g) + 1
    MA.operate!(remove_leading_term, g)
    while !iszero(f)
        if isapproxzero(ltf) # TODO `, kwargs...)`
            MA.operate!(remove_leading_term, f)
        elseif !divides(monomial(ltg), ltf)
            # Since the monomials are sorted in decreasing order,
            # lm is larger than all of them hence it cannot divide any of them
            # This is always the case for univariate.
            # TODO We could also do early termination for Lex order even if `>` returns `false` here
            if monomial(ltg) > monomial(ltf)
                break
            end
            MA.operate!(remove_leading_term, f)
        else
            MA.operate!(remove_leading_term, f)
            t = _prepare_s_poly!(op, f, ltf, ltg)
            skipped_divisions -= 1
            MA.buffered_operate!(buffer, MA.sub_mul, f, t, g)
        end
        if op === pseudo_rem && _primitive_rem(algo)
            f = primitive_part(f, algo, MA.IsMutable())::typeof(f)
        end
        if _skip_last(algo) && maxdegree(f) == maxdegree(g)
            break
        end
        ltf = leading_term(f)
    end
    # Add it back as we cannot modify `g`
    MA.operate!(unsafe_restore_leading_term, g, ltg)
    _set_skipped_divisions!(algo, skipped_divisions)
    return f
end

"""
    rem_or_pseudo_rem(f::_APL, g::_APL, algo)

If the coefficient type is a field, return `rem`, otherwise, return [`pseudo_rem`](@ref).
"""
function rem_or_pseudo_rem(f::_APL, g::_APL, algo)
    return MA.operate!!(rem_or_pseudo_rem, MA.mutable_copy(f), g, algo)
end

_op(::Field) = rem
_op(::UFD) = pseudo_rem

function MA.operate!(
    ::typeof(rem_or_pseudo_rem),
    f::_APL{S},
    g::_APL{T},
    algo,
) where {S,T}
    return MA.operate!(
        _op(algebraic_structure(MA.promote_operation(-, S, T))),
        f,
        g,
        algo,
    )
end

function MA.buffered_operate!(
    buffer,
    ::typeof(rem_or_pseudo_rem),
    f::_APL{S},
    g::_APL{T},
    algo,
) where {S,T}
    return MA.buffered_operate!(
        buffer,
        _op(algebraic_structure(MA.promote_operation(-, S, T))),
        f,
        g,
        algo,
    )
end

function MA.buffer_for(
    ::typeof(rem_or_pseudo_rem),
    F::Type{<:_APL{S}},
    G::Type{<:_APL{T}},
    A::Type,
) where {S,T}
    return MA.buffer_for(
        _op(algebraic_structure(MA.promote_operation(-, S, T))),
        F,
        G,
        A,
    )
end

function MA.promote_operation(
    ::typeof(rem_or_pseudo_rem),
    ::Type{P},
    ::Type{Q},
    ::Type{A},
) where {T,S,P<:_APL{T},Q<:_APL{S},A}
    return _promote_operation_rem_or_pseudo_rem(
        algebraic_structure(MA.promote_operation(-, S, T)),
        P,
        Q,
        A,
    )
end
function _promote_operation_rem_or_pseudo_rem(
    ::Field,
    ::Type{P},
    ::Type{Q},
    ::Type{A},
) where {P<:_APL,Q<:_APL,A}
    return MA.promote_operation(rem, P, Q)
end
function _promote_operation_rem_or_pseudo_rem(
    ::UFD,
    ::Type{P},
    ::Type{Q},
    ::Type{A},
) where {P<:_APL,Q<:_APL,A}
    return MA.promote_operation(pseudo_rem, P, Q, A)
end

function MA.promote_operation(
    ::typeof(rem),
    ::Type{P},
    ::Type{Q},
    ::Type{A},
) where {P<:_APL,Q<:_APL,A}
    return MA.promote_operation(rem, P, Q)
end
function MA.promote_operation(
    ::Union{typeof(div),typeof(rem)},
    ::Type{P},
    ::Type{Q},
) where {T,S,P<:_APL{T},Q<:_APL{S}}
    U = MA.promote_operation(/, promote_to_field(T), promote_to_field(S))
    # `promote_type(P, Q)` is needed for TypedPolynomials in case they use different variables
    return polynomial_type(promote_type(P, Q), MA.promote_operation(-, U, U))
end
function Base.divrem(f::_APL{T}, g::_APL{S}; kwargs...) where {T,S}
    rf = convert(
        MA.promote_operation(div, typeof(f), typeof(g)),
        MA.copy_if_mutable(f),
    )
    q = zero(rf)
    r = zero(rf)
    lt = leading_term(g)
    rg = remove_leading_term(g)
    lm = monomial(lt)
    while !iszero(rf)
        ltf = leading_term(rf)
        if isapproxzero(ltf; kwargs...)
            rf = MA.operate!!(remove_leading_term, rf)
        elseif divides(lm, ltf)
            qt = div_multiple(ltf, lt)
            q = MA.add!!(q, qt)
            rf = MA.operate!!(remove_leading_term, rf)
            rf = MA.operate!!(MA.sub_mul, rf, qt, rg)
        elseif lm > monomial(ltf)
            # Since the monomials are sorted in decreasing order,
            # lm is larger than all of them hence it cannot divide any of them
            r = MA.add!!(r, rf)
            break
        else
            r = MA.add!!(r, ltf)
            rf = MA.operate!!(remove_leading_term, rf)
        end
    end
    return q, r
end
function Base.divrem(
    f::_APL{T},
    g::AbstractVector{<:_APL{S}};
    kwargs...,
) where {T,S}
    rf = convert(
        MA.promote_operation(div, typeof(f), eltype(g)),
        MA.copy_if_mutable(f),
    )
    r = zero(rf)
    q = similar(g, typeof(rf))
    for i in eachindex(q)
        q[i] = zero(rf)
    end
    lt = leading_term.(g)
    rg = remove_leading_term.(g)
    lm = monomial.(lt)
    useful = BitSet(eachindex(g))
    while !iszero(rf)
        ltf = leading_term(rf)
        if isapproxzero(ltf; kwargs...)
            rf = MA.operate!!(remove_leading_term, rf)
            continue
        end
        divisionoccured = false
        for i in useful
            if divides(lm[i], ltf)
                qt = div_multiple(ltf, lt[i])
                q[i] = MA.add!!(q[i], qt)
                rf = MA.operate!!(remove_leading_term, rf)
                rf = MA.operate!!(MA.sub_mul, rf, qt, rg[i])
                divisionoccured = true
                break
            elseif lm[i] > monomial(ltf)
                # Since the monomials are sorted in decreasing order,
                # lm is larger than all of them hence it cannot divide any of them
                delete!(useful, i)
            end
        end
        if !divisionoccured
            if isempty(useful)
                r = MA.add!!(r, rf)
                break
            else
                r = MA.add!!(r, ltf)
                rf = MA.operate!!(remove_leading_term, rf)
            end
        end
    end
    return q, r
end

function LinearAlgebra.norm(p::AbstractPolynomialLike, r::Int = 2)
    return LinearAlgebra.norm(coefficients(p), r)
end

function similar_type(::Type{TT}, ::Type{T}) where {TT<:AbstractTermLike,T}
    return term_type(TT, T)
end
function similar_type(::Type{PT}, ::Type{T}) where {PT<:AbstractPolynomial,T}
    return polynomial_type(PT, T)
end

function Base.similar(p::PT, ::Type{T}) where {PT<:_APL,T}
    return convert(similar_type(PT, T), p)
end

abstract type ListState end
abstract type UnsortedState <: ListState end
struct MessyState <: UnsortedState end
# No duplicates or zeros
struct UniqState <: UnsortedState end
sortstate(::MessyState) = SortedState()
sortstate(::UniqState) = SortedUniqState()
struct SortedState <: ListState end
struct SortedUniqState <: ListState end

"""
    polynomial(p::AbstractPolynomialLike)

Converts `p` to a value with polynomial type.

    polynomial(p::AbstractPolynomialLike, ::Type{T}) where T

Converts `p` to a value with polynomial type with coefficient type `T`.

    polynomial(a::AbstractVector, mv::AbstractVector{<:AbstractMonomialLike})

Creates a polynomial equal to `dot(a, mv)`.

    polynomial(terms::AbstractVector{<:AbstractTerm}, s::ListState=MessyState())

Creates a polynomial equal to `sum(terms)` where `terms` are guaranteed to be in state `s`.

    polynomial(f::Function, mv::AbstractVector{<:AbstractMonomialLike})

Creates a polynomial equal to `sum(f(i) * mv[i] for i in 1:length(mv))`.

### Examples

Calling `polynomial([2, 4, 1], [x, x^2*y, x*y])` should return ``4x^2y + xy + 2x``.
"""
function polynomial end
function polynomial(p::_APL, args::Vararg{Type,N}) where {N}
    return polynomial!(copy(p), args...)
end
function polynomial(Q::AbstractMatrix, mv::AbstractVector)
    return LinearAlgebra.dot(mv, Q * mv)
end
function polynomial(Q::AbstractMatrix, mv::AbstractVector, ::Type{T}) where {T}
    return polynomial(polynomial(Q, mv), T)
end

function polynomial(
    f::F,
    mv::AbstractVector{<:AbstractMonomialLike},
) where {F<:Function}
    return polynomial!([term(f(i), mv[i]) for i in 1:length(mv)])
end

function polynomial(
    a::AbstractVector,
    x::AbstractVector,
    s::ListState = MessyState(),
)
    # If `x` is e.g. `[v, 1]` then it will contains terms that are convertible to monomials.
    return polynomial(
        [term(α, convert(monomial_type(m), m)) for (α, m) in zip(a, x)],
        s,
    )
end

polynomial(ts::AbstractVector, s::ListState = MessyState()) = sum(ts)

function polynomial!(p::_APL, args::Vararg{Any,N}) where {N}
    return convert(polynomial_type(p, args...), p)
end

polynomial!(ts::AbstractVector, s::ListState = MessyState()) = sum(ts)

function polynomial!(
    ts::AbstractVector{TT},
    s::SortedUniqState,
) where {TT<:AbstractTerm}
    return polynomial_type(TT)(ts)
end

function polynomial!(ts::AbstractVector{<:AbstractTerm}, s::SortedState)
    return polynomial!(uniqterms!(ts), SortedUniqState())
end
function polynomial!(
    ts::AbstractVector{<:AbstractTerm},
    s::UnsortedState = MessyState(),
)
    return polynomial!(sort!(ts, lt = (<)), sortstate(s))
end

_collect(v::Vector) = v
_collect(v::AbstractVector) = collect(v)
function polynomial(
    ts::AbstractVector{<:AbstractTerm},
    args::Vararg{ListState,N},
) where {N}
    return polynomial!(MA.mutable_copy(_collect(ts)), args...)
end

"""
    polynomial_type(p::AbstractPolynomialLike)

Returns the type that `p` would have if it was converted into a polynomial.

    polynomial_type(::Type{PT}) where PT<:AbstractPolynomialLike

Returns the same as `polynomial_type(::PT)`.

    polynomial_type(p::AbstractPolynomialLike, ::Type{T}) where T

Returns the type that `p` would have if it was converted into a polynomial of coefficient type `T`.

    polynomial_type(::Type{PT}, ::Type{T}) where {PT<:AbstractPolynomialLike, T}

Returns the same as `polynomial_type(::PT, ::Type{T})`.
"""
function polynomial_type end
function polynomial_type(::Type{T}) where {T<:AbstractTerm}
    return error("`polynomial_type` not implemented for $T")
end
function polynomial_type(::Union{P,Type{P}}) where {P<:_APL}
    return polynomial_type(term_type(P))
end
polynomial_type(::Union{P,Type{P}}) where {P<:AbstractPolynomial} = P
function polynomial_type(::Union{M,Type{M}}) where {M<:AbstractMonomialLike}
    return polynomial_type(term_type(M))
end
function polynomial_type(
    ::Union{M,Type{M}},
    ::Type{T},
) where {M<:AbstractMonomialLike,T}
    return polynomial_type(term_type(M, T))
end
function polynomial_type(::Union{P,Type{P}}, ::Type{T}) where {P<:_APL,T}
    return polynomial_type(polynomial_type(P), T)
end
function polynomial_type(
    ::Union{AbstractVector{PT},Type{<:AbstractVector{PT}}},
) where {PT<:_APL}
    return polynomial_type(PT)
end
function polynomial_type(
    ::Union{AbstractVector{PT},Type{<:AbstractVector{PT}}},
    ::Type{T},
) where {PT<:_APL,T}
    return polynomial_type(PT, T)
end

function uniqterms!(ts::AbstractVector{<:AbstractTerm})
    i = firstindex(ts)
    for j in Iterators.drop(eachindex(ts), 1)
        if !iszero(ts[j])
            if monomial(ts[i]) == monomial(ts[j])
                ts[i] = term(
                    MA.add!!(coefficient(ts[i]), coefficient(ts[j])),
                    monomial(ts[i]),
                )
            else
                if !iszero(ts[i])
                    i += 1
                end
                ts[i] = MA.copy_if_mutable(ts[j])
            end
        end
    end
    if i < length(ts)
        if iszero(ts[i])
            i -= 1
        end
        resize!(ts, i)
    end
    return ts
end

"""
    terms(p::AbstractPolynomialLike)

Returns an iterator over the nonzero terms of the polynomial `p` sorted in the decreasing monomial order.

### Examples

Calling `terms` on ``4x^2y + xy + 2x`` should return an iterator of ``[4x^2y, xy, 2x]``.
"""
terms(t::AbstractTermLike) = OneOrZeroElementVector(iszero(t), term(t))
terms(p::AbstractPolynomialLike) = terms(polynomial(p))

"""
    nterms(p::AbstractPolynomialLike)

Returns the number of nonzero terms in `p`, i.e. `length(terms(p))`.

### Examples

Calling `nterms` on ``4x^2y + xy + 2x`` should return 3.
"""
function nterms end

nterms(t::AbstractTermLike) = iszero(t) ? 0 : 1
nterms(p::AbstractPolynomialLike) = length(terms(p))

"""
    coefficients(p::AbstractPolynomialLike)

Returns an iterator over the coefficients of `p` of the nonzero terms of the polynomial sorted in the decreasing monomial order.

    coefficients(p::AbstractPolynomialLike, X::AbstractVector)

Returns an iterator over the coefficients of the monomials of `X` in `p` where `X` is a monomial vector not necessarily sorted but with no duplicate entry.

### Examples

Calling `coefficients` on ``4x^2y + xy + 2x`` should return an iterator of ``[4, 1, 2]``.
Calling `coefficients(4x^2*y + x*y + 2x + 3, [x, 1, x*y, y])` should return an iterator of ``[2, 3, 1, 0]``.
"""
coefficients(p::_APL{T}) where {T} = LazyMap{T}(coefficient, terms(p))
function coefficients(p::_APL{T}, X::AbstractVector) where {T}
    σ, mv = sort_monomial_vector(X)
    @assert length(mv) == length(X) # no duplicate in X
    c = zeros(T, length(mv))
    i = 1
    for t in terms(p)
        m = monomial(t)
        while i <= length(mv) && mv[i] < m
            c[σ[i]] = zero(T)
            i += 1
        end
        if i <= length(mv) && mv[i] == m
            c[σ[i]] = coefficient(t)
            i += 1
        end
    end
    return c
end

"""
    monomials(p::AbstractPolynomialLike)

Returns an iterator over the monomials of `p` of the nonzero terms of the polynomial sorted in the decreasing order.

    monomials(vars::Union{Vector{<:AbstractVariable},Tuple}, degs::AbstractVector{Int}, filter::Function = m -> true)

Builds the vector of all the monomial_vector `m` with variables `vars` such that the degree `degree(m)` is in `degs` and `filter(m)` is `true`.

See also [`ExponentsIterator`](@ref).

### Examples

Calling `monomials` on ``4x^2y + xy + 2x`` should return an iterator of ``[x^2y, xy, x]``.

Calling `monomials((x, y), [1, 3], m -> degree(m, y) != 1)` should return `[x^3, x*y^2, y^3, x]` where `x^2*y` and `y` have been excluded by the filter.
"""
monomials(p::_APL) = monomial_vector(monomial.(terms(p)))
monomials(t::AbstractTermLike) = OneOrZeroElementVector(iszero(t), monomial(t))

function isconstant(p::_APL)
    n = nterms(p)
    return iszero(n) || (isone(n) && isconstant(first(terms(p))))
end

#$(SIGNATURES)
"""
    mindegree(p::Union{AbstractPolynomialLike, AbstractVector{<:AbstractPolynomialLike}})

Returns the minimal total degree of the monomials of `p`, i.e. `minimum(degree, terms(p))`.

    mindegree(p::Union{AbstractPolynomialLike, AbstractVector{<:AbstractPolynomialLike}}, v::AbstractVariable)

Returns the minimal degree of the monomials of `p` in the variable `v`, i.e. `minimum(degree.(terms(p), v))`.

### Examples
Calling `mindegree` on on ``4x^2y + xy + 2x`` should return 1, `mindegree(4x^2y + xy + 2x, x)` should return 1 and  `mindegree(4x^2y + xy + 2x, y)` should return 0.
"""
function mindegree(
    X::AbstractVector{<:AbstractPolynomialLike},
    args::Vararg{Any,N},
) where {N}
    return isempty(X) ? 0 : minimum(t -> mindegree(t, args...), X)
end
function mindegree(p::AbstractPolynomialLike, args::Vararg{Any,N}) where {N}
    return mindegree(terms(p), args...)
end
function mindegree(t::AbstractTermLike, args::Vararg{Any,N}) where {N}
    return degree(t, args...)
end

#$(SIGNATURES)
"""
    maxdegree(p::Union{AbstractPolynomialLike, AbstractVector{<:AbstractTermLike}})

Returns the maximal total degree of the monomials of `p`, i.e. `maximum(degree, terms(p))`.

    maxdegree(p::Union{AbstractPolynomialLike, AbstractVector{<:AbstractTermLike}}, v::AbstractVariable)

Returns the maximal degree of the monomials of `p` in the variable `v`, i.e. `maximum(degree.(terms(p), v))`.

### Examples
Calling `maxdegree` on ``4x^2y + xy + 2x`` should return 3, `maxdegree(4x^2y + xy + 2x, x)` should return 2 and  `maxdegree(4x^2y + xy + 2x, y)` should return 1.
"""
function maxdegree(
    X::AbstractVector{<:AbstractPolynomialLike},
    args::Vararg{Any,N},
) where {N}
    return mapreduce(t -> maxdegree(t, args...), max, X, init = 0)
end
function maxdegree(p::AbstractPolynomialLike, args::Vararg{Any,N}) where {N}
    return maxdegree(terms(p), args...)
end
function maxdegree(t::AbstractTermLike, args::Vararg{Any,N}) where {N}
    return degree(t, args...)
end

#$(SIGNATURES)
"""
    extdegree(p::Union{AbstractPolynomialLike, AbstractVector{<:AbstractPolynomialLike}})

Returns the extremal total degrees of the monomials of `p`, i.e. `(mindegree(p), maxdegree(p))`.

    extdegree(p::Union{AbstractPolynomialLike, AbstractVector{<:AbstractPolynomialLike}}, v::AbstractVariable)

Returns the extremal degrees of the monomials of `p` in the variable `v`, i.e. `(mindegree(p, v), maxdegree(p, v))`.

### Examples
Calling `extdegree` on ``4x^2y + xy + 2x`` should return `(1, 3)`, `extdegree(4x^2y + xy + 2x, x)` should return `(1, 2)` and  `maxdegree(4x^2y + xy + 2x, y)` should return `(0, 1)`.
"""
function extdegree(
    p::Union{AbstractPolynomialLike,AbstractVector{<:AbstractPolynomialLike}},
    args...,
)
    return (mindegree(p, args...), maxdegree(p, args...))
end

"""
    effective_variables(p::AbstractPolynomialLike)

Return a vector of `eltype` `variable_union_type(p)` (see [`variable_union_type`](@ref)),
containing all the variables that has nonzero degree in at least one term.
That is, return all the variables `v` such that `maxdegree(p, v)` is not zero.
The returned vector is sorted in decreasing order.
"""
function effective_variables(p::AbstractPolynomialLike)
    VT = variable_union_type(p)
    return VT[v for v in variables(p) if !iszero(maxdegree(p, v))]
end

"""
    leading_term(p::AbstractPolynomialLike)

Returns the leading term, i.e. `last(terms(p))`.

### Examples

Calling `leading_term` on ``4x^2y + xy + 2x`` should return ``4x^2y``.
"""
function leading_term(p::AbstractPolynomialLike)
    if iszero(p)
        zero_term(p)
    else
        last(terms(p))
    end
end
leading_term(t::AbstractTermLike) = term(t)

#$(SIGNATURES)
"""
    leading_coefficient(p::AbstractPolynomialLike)

Returns the coefficient of the leading term of `p`, i.e. `coefficient(leading_term(p))`.

### Examples

Calling `leading_coefficient` on ``4x^2y + xy + 2x`` should return ``4`` and calling it on ``0`` should return ``0``.
"""
function leading_coefficient(p::AbstractPolynomialLike{T}) where {T}
    if iszero(p)
        zero(T)
    else
        last(coefficients(p))
    end
end
leading_coefficient(t::AbstractTermLike) = coefficient(t)

#$(SIGNATURES)
"""
    leading_monomial(p::AbstractPolynomialLike)

Returns the monomial of the leading term of `p`, i.e. `monomial(leading_term(p))` or `last(monomials(p))`.

### Examples

Calling `leading_monomial` on ``4x^2y + xy + 2x`` should return ``x^2y``.
"""
function leading_monomial(p::AbstractPolynomialLike)
    if iszero(p)
        constant_monomial(p)
    else
        last(monomials(p))
    end
end
leading_monomial(t::AbstractTermLike) = monomial(t)

#$(SIGNATURES)
"""
    remove_leading_term(p::AbstractPolynomialLike)

Returns a polynomial with the leading term removed in the polynomial `p`.

### Examples

Calling `remove_leading_term` on ``4x^2y + xy + 2x`` should return ``xy + 2x``.
"""
function remove_leading_term(p::AbstractPolynomialLike)
    # Iterators.drop returns an Interators.Drop which is not an AbstractVector
    return polynomial(terms(p)[1:(end-1)], SortedUniqState())
end
function MA.promote_operation(
    ::typeof(remove_leading_term),
    ::Type{PT},
) where {PT<:AbstractPolynomial}
    return PT
end
function MA.operate(::typeof(remove_leading_term), t::AbstractTermLike)
    return remove_leading_term(t)
end
remove_leading_term(t::AbstractTermLike) = zero(t)

function unsafe_restore_leading_term end
function MA.operate!(
    ::typeof(unsafe_restore_leading_term),
    p::AbstractPolynomial,
    t::AbstractTermLike,
)
    # `MA.add!` will copy the coefficient of `t` so `Polynomial` redefines this
    return MA.add!!(p, t)
end

#$(SIGNATURES)
"""

Returns a polynomial with the terms having their monomial in the monomial vector `mv` removed in the polynomial `p`.

### Examples

Calling `remove_monomials(4x^2*y + x*y + 2x, [x*y])` should return ``4x^2*y + 2x``.
"""
function remove_monomials(
    p::AbstractPolynomialLike,
    mv::AbstractVector{MT},
) where {MT<:AbstractMonomialLike}
    smv = monomial_vector(mv) # Make sure it is sorted
    i = 1
    q = zero(p)
    for t in terms(p)
        m = monomial(t)
        while i <= length(smv) && smv[i] < m
            i += 1
        end
        if i > length(smv) || smv[i] != m
            q += t
        end
    end
    return q
end

"""
    function filter_terms(f::Function, p::AbstractPolynomialLike)

Filter the polynomial `p` by only keep the terms `t` such that `f(p)` is
`true`.

See also [`OfDegree`](@ref).

### Examples

```julia
julia> p = 1 - 2x + x * y - 3y^2 + x^2 * y
1 - 2x - 3y² + xy + x²y

julia> filter_terms(OfDegree(2), p)
-3y² + xy

julia> filter_terms(!OfDegree(2), p)
1 - 2x + x²y

julia> filter_terms(!OfDegree(0:2), p)
x²y

julia> filter_terms(iseven ∘ coefficient, p)
-2x
```
"""
function filter_terms(f::F, p::AbstractPolynomialLike) where {F<:Function}
    return polynomial(filter(f, terms(p)), SortedUniqState())
end

"""
    struct OfDegree{D} <: Function
        degree::D
    end

A function `d::OfDegree` is such that `d(t)` returns
`degree(t) == d.degree`. Note that `!d` creates the negation.
See also [`filter_terms`](@ref).
"""
struct OfDegree{D} <: Function
    degree::D
end

(d::OfDegree)(mono::AbstractTermLike) = in(degree(mono), d.degree)

"""
    monic(p::AbstractPolynomialLike)

Returns `p / leading_coefficient(p)` where the leading coefficient of the returned polynomials is made sure to be exactly one to avoid rounding error.
"""
function monic(p::_APL)
    α = leading_coefficient(p)
    return polynomial!(_div_to_one.(terms(p), α))
end
monic(m::AbstractMonomialLike) = m
monic(t::AbstractTermLike{T}) where {T} = term(one(T), monomial(t))

function _div_to_one(t::AbstractTermLike{T}, α::S) where {T,S}
    U = Base.promote_op(/, T, S)
    β = coefficient(t)
    if β == α
        term(one(U), monomial(t))
    else
        term((β / α), monomial(t))
    end
end

"""
    map_coefficients(f::Function, p::AbstractPolynomialLike, nonzero = false)

Returns a polynomial with the same monomials as `p` but each coefficient `α` is replaced by `f(α)`.
The function may return zero in which case the term is dropped.
If the function is known to never return zero for a nonzero input, `nonzero`
can be set to `true` to get a small speedup.

See also [`map_coefficients!`](@ref) and [`map_coefficients_to!`](@ref).

### Examples

Calling `map_coefficients(α -> mod(3α, 6), 2x*y + 3x + 1)` should return `3x + 3`.
"""
function map_coefficients end
function map_coefficients(
    f::F,
    p::AbstractPolynomialLike;
    nonzero = false,
) where {F<:Function} # Not used by either TypedPolynomials or DynamicPolynomials but used by CustomPoly in tests. FIXME Remove in a breaking release
    # Invariant: p has only nonzero coefficient
    # therefore f(α) will be nonzero for every coefficient α of p
    # hence we can use Uniq
    return polynomial!(
        map_coefficients.(f, terms(p)),
        nonzero ? SortedUniqState() : SortedState(),
    )
end
function map_coefficients(
    f::F,
    t::AbstractTermLike;
    nonzero = false,
) where {F<:Function}
    return term(f(coefficient(t)), monomial(t))
end

"""
    map_coefficients!(f::Function, p::AbstractPolynomialLike, nonzero = false)

Mutate `p` by replacing each coefficient `α` by `f(α)`.
The function may return zero in which case the term is dropped.
If the function is known to never return zero for a nonzero input, `nonzero`
can be set to `true` to get a small speedup.
The function returns `p`, which is identically equal to the second argument.

See also [`map_coefficients`](@ref) and [`map_coefficients_to!`](@ref).

### Examples

Let `p = 2x*y + 3x + 1`, after `map_coefficients!(α -> mod(3α, 6), p)`, `p` is
equal to `3x + 3`.
"""
function map_coefficients! end

function map_coefficients(
    f::F,
    p::_APL,
    ::MA.IsNotMutable;
    nonzero = false,
) where {F<:Function}
    return map_coefficients(f, p; nonzero = nonzero)
end
function map_coefficients(
    f::F,
    p::_APL,
    ::MA.IsMutable;
    nonzero = false,
) where {F<:Function}
    return map_coefficients!(f, p; nonzero = nonzero)
end

"""
    map_coefficients_to!(output::AbstractPolynomialLike, f::Function, p::AbstractPolynomialLike, nonzero = false)

Mutate `output` by replacing each coefficient `α` of `p` by `f(α)`.
The function may return zero in which case the term is dropped.
If the function is known to never returns zero for a nonzero input, `nonzero`
can be set to `true` to get a small speedup.
The function returns `output`, which is identically equal to the first argument.

See also [`map_coefficients!`](@ref) and [`map_coefficients`](@ref).
"""
function map_coefficients_to! end

"""
    deg_num_leading_terms(p::AbstractPolynomialLike, var)

Return `deg, num` where `deg = maxdegree(p, var)` and `num` is the number of
terms `t` such that `degree(t, var) == deg`.
"""
function deg_num_leading_terms(p::AbstractPolynomialLike, var)
    deg = 0
    num = 0
    for mono in monomials(p)
        d = degree(mono, var)
        if d > deg
            deg = d
            num = 1
        elseif d == deg
            num += 1
        end
    end
    return deg, num
end

"""
    multiplication_preserves_monomial_order(P::Type{<:AbstractPolynomialLike})

Returns a `Bool` indicating whether the order is preserved in the
multiplication of monomials of type `monomial_type(P)`.
That is, if `a < b` then `a * c < b * c` for any monomial `c`.
This returns `true` by default.
This is used by [`Polynomial`](@ref) so a monomial type for which the
multiplication does not preserve the monomial order can still be used with
[`Polynomial`](@ref) if it implements a method for this function that
returns `false`.
"""
function multiplication_preserves_monomial_order(
    ::Type{P},
) where {P<:AbstractPolynomialLike}
    return multiplication_preserves_monomial_order(monomial_type(P))
end
function multiplication_preserves_monomial_order(
    ::Type{M},
) where {M<:AbstractMonomial}
    return true
end

Base.ndims(::Union{Type{<:AbstractPolynomialLike},AbstractPolynomialLike}) = 0
Base.broadcastable(p::AbstractPolynomialLike) = Ref(p)

@testset "Algebra" begin
    Mod.@polyvar x y
    @test 2 .- ((1 .+ (-x)) .* 4) ./ 2 == x .^ 2 .* (1 ./ x) .* 2
    @test dot(0, x^2 - 2 * x^2) == dot((x^2 - x)', x^2 - x^2)
    @test dot(x + 1, 2) == 2x + 2
    @test 2 .* x .+ 2 == (x + 3) .+ (x .- 1)
    @test ((x + y) .- y) ./ y == x / y
    @test (-2) * x == -(2 * x)
    @test x * x == x^2
    @test 4x == 2.0(2x)
    @test x * (2x) == 2x^2
    @inferred 2 * (2x)
    @inferred 2.0 * (2x)
    #@test eltype(2.0 * (2x)) == Float64
    t = @inferred 1.5 * (2x)
    @test t isa AbstractTerm{Float64}
    @test t == 3x

    p = @inferred y^2 * (2.0x^2 + 3y)
    @test p == 2x^2 * y^2 + 3y^3
    @test p isa AbstractPolynomial{Float64}

    p = @inferred (2x^2 + 3.0y) * y^2
    @test p == 2x^2 * y^2 + 3y^3
    @test p isa AbstractPolynomial{Float64}

    p = @inferred (2.0y^2) * (2x^2 + 3y)
    @test p == 4x^2 * y^2 + 6y^3
    @test p isa AbstractPolynomial{Float64}

    p = @inferred (2x^2 + 3y) * (2.0y^2)
    @test p == 4x^2 * y^2 + 6y^3
    @test p isa AbstractPolynomial{Float64}

    p = @inferred (y^2 + 2.0) * (2x + y)
    @test p == 2x * y^2 + y^3 + 4x + 2y
    @test p isa AbstractPolynomial{Float64}

    p = @inferred CustomPoly(x + 2y) * CustomTerms(x^2 + 1.0)
    @test p == x^3 + 2x^2 * y + x + 2y
    @test p isa AbstractPolynomial{Float64}

    p = @inferred CustomPoly(x + 2y) + 1
    @test p == x + 2y + 1
    @test p isa AbstractPolynomial{Int}

    p = @inferred CustomPoly(x + 2y) + 1.0
    @test p == x + 2y + 1
    @test p isa AbstractPolynomial{Float64}

    @testset "Inference" begin
        @inferred x^2
        @inferred x^2 - 2x
        @inferred x + 2x
        @inferred -2x + 2
        @inferred x^2 - 2x + 2
        @inferred x^2 - 2x
        @inferred 2x + 2
        @inferred (1 + x)^0
        @inferred (1 + x)^1
        @inferred (1 + x)^2
        @inferred (1 + x)^3
        @inferred (x^2)^0
        @inferred (x^2)^1
        @inferred (x^2)^2
        @inferred (x^2)^3
        @inferred (2x) * (3x)
        @inferred (2x)^0
        @inferred (2x)^1
        @inferred (2x)^2
        @inferred (2x)^3
    end

    @test iszero((x + x - 2 * x) * (x * (x^2 + y^2)))
    @test iszero((0 * x) * (x * y * (x^2 + y^2)))

    @testset "Scalar - Array" begin
        Mod.@polyvar x y
        @test x + [x^2+y y; y x*y] == [x+x^2+y x+y; x+y x+x*y]
        @test [x^2+y y; y x*y] + x == [x^2+x+y y+x; y+x x*y+x]

        @test x * [1 + y y] == [x * (1 + y) x * y]
        @test [1 + y y] * x == [(1 + y) * x y * x]
        @test [1 + y y] / x == [(1 + y) / x y / x]
    end
end

"""
pair_zip((a, b), (c, d)) gives (a=>c, b=>d)

This function was written by Fengyang Wang and shared on the Julia discourse
forum: https://discourse.julialang.org/t/type-stable-zip-to-pairs/3390/2
"""
pair_zip(::Tuple{}, ::Tuple{}) = ()
function pair_zip(::Tuple{}, ::Tuple)
    throw(ArgumentError("args must be equal in length"))
end
function pair_zip(::Tuple, ::Tuple{})
    throw(ArgumentError("args must be equal in length"))
end
function pair_zip(t::Tuple, u::Tuple)
    return (t[1] => u[1], pair_zip(Base.tail(t), Base.tail(u))...)
end
pair_zip(p::Pair{<:Tuple,<:Tuple}) = pair_zip(p.first, p.second)
# inefficient but convenient method to allow subs(p, (x, y)=>[1, 2])
pair_zip(p::Pair) = pair_zip(Tuple(p.first), Tuple(p.second))

tuple_zip(::Tuple{}, ::Tuple{}) = ()
function tuple_zip(::Tuple{}, ::Tuple)
    throw(ArgumentError("args must be equal in length"))
end
function tuple_zip(::Tuple, ::Tuple{})
    throw(ArgumentError("args must be equal in length"))
end
function tuple_zip(t::Tuple, u::Tuple)
    return ((t[1], u[1]), tuple_zip(Base.tail(t), Base.tail(u))...)
end

_zip(t::Tuple, u::Tuple) = tuple_zip(t, u)
# `tuple_zip` would be type unstable
_zip(t::Vector, u::Vector) = zip(t, u)

using LinearAlgebra, Test
using ChainRulesCore

function test_chain_rule(dot, op, args, Δin, Δout)
    output = op(args...)
    foutput, fΔout = ChainRulesCore.frule((NoTangent(), Δin...), op, args...)
    @test output == foutput
    routput, pullback = ChainRulesCore.rrule(op, args...)
    @test output == routput
    rΔin = pullback(Δout)
    @test rΔin[1] == NoTangent()
    @test dot(Δin, rΔin[2:end]) ≈ dot(fΔout, Δout)
end

@testset "ChainRulesCore" begin
    Mod.@polyvar x y
    p = 1.1x + y
    q = (-0.1 + im) * x - y

    output, pullback = ChainRulesCore.rrule(+, q)
    @test output == q
    @test pullback(2) == (NoTangent(), 2)
    @test pullback(x + 3) == (NoTangent(), x + 3)

    output, pullback = ChainRulesCore.rrule(-, q)
    @test output ≈ -q
    @test pullback(2) == (NoTangent(), -2)
    @test pullback(x + 3im) == (NoTangent(), -x - 3im)

    output, pullback = ChainRulesCore.rrule(+, p, q)
    @test output == (1.0 + im)x
    @test pullback(2) == (NoTangent(), 2, 2)
    @test pullback(x + 3) == (NoTangent(), x + 3, x + 3)

    output, pullback = ChainRulesCore.rrule(-, p, q)
    @test output ≈ (1.2 - im) * x + 2y
    @test pullback(2) == (NoTangent(), 2, -2)
    @test pullback(im * x + 3) == (NoTangent(), im * x + 3, -im * x - 3)

    output, pullback = ChainRulesCore.rrule(differentiate, p, x)
    @test output == 1.1
    @test pullback(q) == (NoTangent(), (-0.2 + 2im) * x^2 - x * y, NoTangent())
    @test pullback(1x) == (NoTangent(), 2x^2, NoTangent())

    test_chain_rule(dot, +, (p,), (q,), p)
    test_chain_rule(dot, +, (q,), (p,), q)

    test_chain_rule(dot, -, (p,), (q,), p)
    test_chain_rule(dot, -, (p,), (p,), q)

    test_chain_rule(dot, +, (p, q), (q, p), p)
    test_chain_rule(dot, +, (p, q), (p, q), q)

    test_chain_rule(dot, -, (p, q), (q, p), p)
    test_chain_rule(dot, -, (p, q), (p, q), q)

    test_chain_rule(dot, *, (p, q), (q, p), p * q)
    test_chain_rule(dot, *, (p, q), (p, q), q * q)
    test_chain_rule(dot, *, (q, p), (p, q), q * q)
    test_chain_rule(dot, *, (p, q), (q, p), q * q)

    function _dot(p, q)
        monos = monomials(p + q)
        return dot(coefficient.(p, monos), coefficient.(q, monos))
    end
    function _dot(
        px::Tuple{<:AbstractPolynomial,NoTangent},
        qx::Tuple{<:AbstractPolynomial,NoTangent},
    )
        return _dot(px[1], qx[1])
    end
    test_chain_rule(_dot, differentiate, (p, x), (q, NoTangent()), p)
    test_chain_rule(
        _dot,
        differentiate,
        (p, x),
        (q, NoTangent()),
        differentiate(p, x),
    )
    test_chain_rule(
        _dot,
        differentiate,
        (p, x),
        (q, NoTangent()),
        differentiate(q, x),
    )
    test_chain_rule(_dot, differentiate, (p, x), (p * q, NoTangent()), p)
end

# Allows `terms(::AbstractTerm)` to not allocate and be type stable
struct OneOrZeroElementVector{T} <: AbstractVector{T}
    empty::Bool
    el::T
end

Base.size(it::OneOrZeroElementVector) = (length(it),)

Base.length(it::OneOrZeroElementVector) = Int(!it.empty)

function Base.iterate(it::OneOrZeroElementVector)
    if it.empty
        return nothing
    else
        return it.el, nothing
    end
end
Base.iterate(::OneOrZeroElementVector, ::Nothing) = nothing

Base.getindex(it::OneOrZeroElementVector, i::Integer) = it.el

Iterators.reverse(it::OneOrZeroElementVector) = it

# Copied from MathOptInterface
"""
    struct LazyMap{T, VT}
        f::Function
        data::VT
    end

Iterator over the elements of `data` mapped by `f`. This is similar to
`Base.Generator(f, data)` except that the `eltype` of a `LazyMap` is given at
construction while the `eltype` of `Base.Generator(f, data)` is `Any`.
"""
struct LazyMap{T,VT<:AbstractVector,F} <: AbstractVector{T}
    f::F
    data::VT
end

function LazyMap{T}(f, data) where {T}
    return LazyMap{T,typeof(data),typeof(f)}(f, data)
end

Base.size(it::LazyMap) = size(it.data)

Base.length(it::LazyMap) = length(it.data)

function Base.iterate(it::LazyMap, args...)
    elem_state = iterate(it.data, args...)
    if elem_state === nothing
        return
    else
        return it.f(elem_state[1]), elem_state[2]
    end
end

Base.IteratorSize(it::LazyMap) = Base.IteratorSize(it.data)

Base.eltype(::LazyMap{T}) where {T} = T

Base.getindex(it::LazyMap, i::Integer) = it.f(getindex(it.data, i))
function Base.getindex(it::LazyMap{T}, I::AbstractVector) where {T}
    return LazyMap{T}(it.f, getindex(it.data, I))
end

Base.eachindex(it::LazyMap) = Base.eachindex(it.data)
Base.lastindex(it::LazyMap) = Base.lastindex(it.data)

function Iterators.reverse(it::LazyMap{T}) where {T}
    return LazyMap{T}(it.f, Iterators.reverse(it.data))
end

@deprecate constantmonomial constant_monomial
@deprecate convertconstant convert_constant
@deprecate termtype term_type
@deprecate polynomialtype polynomial_type
@deprecate jointerms join_terms
@deprecate jointerms! join_terms!
@deprecate mapcoefficients map_coefficients
@deprecate mapcoefficients! map_coefficients!
@deprecate mapexponents map_exponents
@deprecate mapexponents! map_exponents!
@deprecate monomialtype monomial_type
@deprecate monovectype monomial_vector_type
@deprecate emptymonovec empty_monomial_vector
@deprecate sortmonovec sort_monomial_vector
@deprecate mergemonovec merge_monomial_vectors
@deprecate monovec monomial_vector
@deprecate leading_term leadingterm
@deprecate leading_monomial leading_monomial
@deprecate leading_coefficient leading_coefficient
@deprecate removeleadingterm remove_leading_term
@deprecate removemonomials remove_monomials
@deprecate coefficienttype coefficient_type
@deprecate constantterm constant_term
@deprecate zeroterm zero_term
@deprecate similarvariable similar_variable
@deprecate pairzip pair_zip
@deprecate tuplezip tuple_zip

function changecoefficienttype(::Type{P}, ::Type{T}) where {P,T}
    Base.depwarn(
        "`changecoefficienttype(P::Type, T::Type)` is deprecated, use `similar_type(P, T)` instead",
        :changecoefficienttype,
    )
    return similar_type(P, T)
end

function changecoefficienttype(poly::_APL, ::Type{T}) where {T}
    Base.depwarn(
        "`changecoefficienttype(poly, T::Type)` is deprecated, use `similar(poly, T)` instead",
        :changecoefficienttype,
    )
    return similar(poly, T)
end

function mapcoefficientsnz(f::F, p::_APL) where {F<:Function}
    Base.depwarn(
        "`mapcoefficientsnz(f, p)` is deprecated, use `map_coefficients(f, p, nonzero = true)` instead",
        :map_coefficientsnz,
    )
    return map_coefficients(f, p, nonzero = true)
end

function mapcoefficientsnz_to!(output::_APL, f::F, p::_APL) where {F<:Function}
    Base.depwarn(
        "`mapcoefficientsnz_to!(output, f, p)` is deprecated, use `map_coefficients_to!(output, f, p, nonzero = true)` instead",
        :map_coefficientsnz_to!,
    )
    return map_coefficients_to!(output, f, p, nonzero = true)
end

@testset "Monomial Vector" begin
    Mod.@polyvar x y
    @test x > y
    @test x^2 > y^2
    X = [y^2, x * y, x^2]
    @test isempty(@inferred monomials((x, y), 1:0))
    monoss = [monomials((x, y), 2), monomials((x, y), 2:2)]
    # TypedPolynomials is allowed to error on `monomials((y, x), 2)`
    # because it would make `monomials` type unstable to sort the tuple of variables
    # of different types
    if typeof(x) === typeof(y)
        push!(monoss, monomials((y, x), 2))
        push!(monoss, monomials((y, x), 2:2))
    end
    for monos in monoss
        for (i, m) in enumerate(monos)
            @test m == X[i]
        end
    end
    X = [y^2, x^2]
    for (i, m) in enumerate(monomials((x, y), 2, m -> m != x * y))
        @test m == X[i]
    end
    @test (@inferred monomial_vector_type([1, x])) <:
          AbstractArray{<:AbstractMonomial}
    @test (@inferred monomial_vector_type([x])) <:
          AbstractArray{<:AbstractMonomial}
    @test (@inferred monomial_vector([1, x])) isa monomial_vector_type([1, x])
    @test (@inferred monomial_vector([x])) isa monomial_vector_type([x])
    @test (@inferred monomial_vector([1, 2], [1, x]))[2] isa
          AbstractArray{<:AbstractMonomial}
    @test (@inferred monomial_vector([1], [x]))[2] isa
          AbstractArray{<:AbstractMonomial}
    @test length(monomial_vector([y, x])) == 2
    X = monomial_vector([x, 1, x * y])
    @test X == collect(X)
    @test nvariables(X) == 2
    @test variables(X)[1] == x
    @test variables(X)[2] == y
    @test X[2:3][1] == x
    @test X[2:3][2] == x * y
    @test monomial_vector(X[[3, 2]])[1] == x
    @test monomial_vector(X[[3, 2]])[2] == x * y
    # Documentation examples
    @test monomial_vector([x * y, x, x * y, x^2 * y, x]) == [x, x * y, x^2 * y]
    @test monomial_vector_type([x * y, x, 1, x^2 * y, x]) <:
          AbstractVector{typeof(x * y)}
    @test monomial_vector_type([x * y, x, x * y, x^2 * y, x]) <: AbstractVector
    σ, smv = sort_monomial_vector([x * y, x, x * y, x^2 * y, x])
    @test smv == [x, x * y, x^2 * y]
    @test σ[3] == 4
    @test σ[2] in (1, 3)
    @test σ[1] in (2, 5)
    @test merge_monomial_vectors([[x * y, x, x * y], [x^2 * y, x]]) ==
          [x, x * y, x^2 * y]
    @test_throws ArgumentError monomial_vector([1, 2], [x^2])
    σ, X = sort_monomial_vector((x, y))
    @test σ == [2, 1]
    @test X == [y, x]
    @test monomial_type([x, y]) <: AbstractMonomial
    @test monomial_type([x^2, 1]) <: AbstractMonomial
    @test monomial_type([x * y, x + y]) <: AbstractMonomial

    @test monomial_vector([x, x^2]) != monomial_vector([x * y, x^2 * y])
    @test monomials(x, 1:3) == monomial_vector([x^3, x, x^2])
    @test monomials((x, y), 2) != monomials((x, y), 1)

    # See https://github.com/JuliaAlgebra/DynamicPolynomials.jl/issues/111
    @testset "Indexing with vector of boolean" begin
        vars = Mod.@polyvar x y
        X = monomials(vars, 2)
        @test X[[true, false, true]] == monomial_vector([x^2, y^2])
        X = monomials(vars, 0:1)
        @test filter(mono -> degree(mono) == 1, X) == monomial_vector([x, y])
        @test filter(mono -> degree(mono) == 0, X) == monomial_vector([x^0])
    end

    @testset "monomials" begin
        Mod.@polyvar v[1:3]
        @test monomials(v, 0:3) == [
            v[1]^0,
            v[3],
            v[2],
            v[1],
            v[3]^2,
            v[2] * v[3],
            v[2]^2,
            v[1] * v[3],
            v[1] * v[2],
            v[1]^2,
            v[3]^3,
            v[2] * v[3]^2,
            v[2]^2 * v[3],
            v[2]^3,
            v[1] * v[3]^2,
            v[1] * v[2] * v[3],
            v[1] * v[2]^2,
            v[1]^2 * v[3],
            v[1]^2 * v[2],
            v[1]^3,
        ]
    end

    @testset "Negative degree" begin
        Mod.@polyvar x[1:3]
        @test_throws ArgumentError monomials(x, -1)
        @test_throws ArgumentError monomials(x, -1:1)
        @test_throws ArgumentError monomials(x, [1, -1])
    end
end

for file in readdir(joinpath(@__DIR__, "commutative"))
    if file == "independent.jl"
        # It's included by `gcd.jl`
        continue
    end
    if file == "complex.jl" && !isdefined(Mod, Symbol("@complex_polyvar"))
        continue
    end
    include(joinpath(@__DIR__, "commutative", file))
end

import MultivariatePolynomials:
    AbstractVariable, similar_variable, @similar_variable

@testset "Variable" begin
    @testset "is_commutative" begin
        function _is_comm_test(p)
            @test MP.is_commutative(p)
            @test MP.is_commutative(typeof(p))
        end
        Mod.@polyvar x y[1:2]
        _is_comm_test(x)
        _is_comm_test(y)
        _is_comm_test(x^2)
        _is_comm_test(2x^2)
        _is_comm_test(sum(y))
        # Test that `is_commutative` is constant-folded for variable types,
        # so that branches on it are eliminated at compile time.
        _comm_branch(::Type{V}) where {V} = MP.is_commutative(V) ? Int : String
        @test @inferred(_comm_branch(typeof(variables(x * y[1])))) === Int
    end
    @testset "polyvar macro index set" begin
        Mod.@polyvar x y z
        Mod.@polyvar x[1:3] y z[1:2]
        @test length(x) == 3
        @test length(z) == 2
        @test x[1] > x[2] > x[3] > y > z[1] > z[2]
    end
    @testset "Variable" begin
        Mod.@polyvar x
        alloc_test(() -> convert(typeof(x), x), 0)
        alloc_test(() -> convert(variable_union_type(x), x), 0)
        @test 1 != x
        @test x != 0
        @test copy(x) == x
        @test nvariables(x) == 1
        @test !isapproxzero(x)
        @test !iszero(x)
        @test zero(x) == 0
        @test iszero(zero(x))
        @test zero(x) isa AbstractPolynomial{Int}
        @inferred zero(x)

        typetests(x)
        @test (@inferred polynomial(x)) isa AbstractPolynomial{Int}
        @test (@inferred polynomial(x, Float64)) isa AbstractPolynomial{Float64}

        @test nterms(x) == 1
        @test @inferred(terms(x)) == [x]

        Mod.@polyvar y
        @test degree(x, x) == 1
        @test degree(x, y) == 0
        @test length(exponents(x)) == 1
        @test first(exponents(x)) == 1
        @test isconstant(x) == false

        @test divides(x, x) == true
        @test divides(x, y) == false

        @testset "Issue #82" begin
            for v in (x, typeof(x))
                for fun in (oneunit, one)
                    @test fun(v) == 1
                    @test 1 == fun(v)
                    #@test isone(fun(v)) # Enable when Julia v0.6 is dropped
                    @test fun(v) isa AbstractMonomial
                    @inferred fun(v)
                end
            end
        end

        @testset "Effective variables" begin
            @test [x] == @inferred effective_variables(x)
            @test [y] == @inferred effective_variables(y)
        end
    end
    @testset "Create similar variable" begin
        Mod.@polyvar x y
        f = x^2 + y

        z = similar_variable(f, Val{:z})
        @test z isa AbstractVariable

        z = similar_variable(typeof(f), Val{:z})
        @test z isa AbstractVariable

        @inferred similar_variable(f, Val{:z})
        @inferred similar_variable(typeof(f), Val{:z})

        w = similar_variable(f, :w)
        @test w isa AbstractVariable

        @similar_variable f o
        @test o isa AbstractVariable

        m = @similar_variable f u
        @test m isa AbstractVariable
    end
end

"""
    promote_variables(p::AbstractPolynomialLike, q::AbstractPolynomialLike)

Return two polynomials over the same variables.
"""
function promote_variables end

# MonomialLike
Base.promote_rule(::Type{M}, ::Type{M}) where {M<:AbstractMonomialLike} = M
function Base.promote_rule(
    M1::Type{<:AbstractMonomialLike},
    M2::Type{<:AbstractMonomialLike},
)
    return promote_type(monomial_type(M1), monomial_type(M2))
end

# TermLike
Base.promote_rule(::Type{T}, ::Type{T}) where {T<:AbstractTermLike} = T
function Base.promote_rule(
    TS::Type{<:AbstractTermLike{S}},
    TT::Type{<:AbstractTermLike{T}},
) where {S,T}
    U = promote_type(S, T)
    M = promote_type(monomial_type(TS), monomial_type(TT))
    return term_type(M, U)
end
function promote_rule_constant(
    ::Type{S},
    TT::Type{<:AbstractTermLike{T}},
) where {S,T}
    return term_type(TT, promote_type(S, T))
end

# PolynomialLike
Base.promote_rule(::Type{PT}, ::Type{PT}) where {PT<:_APL} = PT
function Base.promote_rule(PS::Type{<:_APL}, PT::Type{<:_APL})
    return polynomial_type(promote_type(term_type(PS), term_type(PT)))
end

function promote_rule_constant(::Type{S}, PT::Type{<:_APL{T}}) where {S,T}
    return polynomial_type(PT, promote_type(S, T))
end
function Base.promote_rule(::Type{PT}, ::Type{T}) where {T,PT<:_APL}
    return promote_rule_constant(T, PT)
end

# We don't have any information on the MultivariatePolynomials implementation,
# so we won't be able to convert the constant to `_APL`.
promote_rule_constant(::Type, PT::Type{AbstractMonomialLike}) = Any
promote_rule_constant(::Type, PT::Type{AbstractTermLike{T}}) where {T} = Any
promote_rule_constant(::Type, PT::Type{AbstractTermLike}) = Any
promote_rule_constant(::Type, PT::Type{_APL{T}}) where {T} = Any
promote_rule_constant(::Type, PT::Type{_APL}) = Any

# AbstractMonomialLike{T}
function Base.promote_rule(
    ::Type{AbstractMonomialLike},
    ::Type{<:AbstractMonomialLike},
)
    return AbstractMonomialLike
end
function Base.promote_rule(
    ::Type{<:AbstractMonomialLike},
    ::Type{AbstractMonomialLike},
)
    return AbstractMonomialLike
end
function Base.promote_rule(
    ::Type{AbstractMonomialLike},
    ::Type{<:AbstractTermLike{T}},
) where {T}
    return _atl(Int, T)
end
function Base.promote_rule(
    ::Type{<:AbstractTermLike{T}},
    ::Type{AbstractMonomialLike},
) where {T}
    return _atl(Int, T)
end
function Base.promote_rule(
    ::Type{AbstractMonomialLike},
    ::Type{AbstractTermLike{T}},
) where {T}
    return _atl(Int, T)
end
function Base.promote_rule(
    ::Type{AbstractTermLike{T}},
    ::Type{AbstractMonomialLike},
) where {T}
    return _atl(Int, T)
end
function Base.promote_rule(
    ::Type{AbstractMonomialLike},
    ::Type{<:_APL{T}},
) where {T}
    return _apl(Int, T)
end
function Base.promote_rule(
    ::Type{<:_APL{T}},
    ::Type{AbstractMonomialLike},
) where {T}
    return _apl(Int, T)
end
function Base.promote_rule(
    ::Type{AbstractMonomialLike},
    ::Type{_APL{T}},
) where {T}
    return _apl(Int, T)
end
function Base.promote_rule(
    ::Type{_APL{T}},
    ::Type{AbstractMonomialLike},
) where {T}
    return _apl(Int, T)
end

# AbstractTermLike{T}
_atl(::Type{T}, ::Type{T}) where {T} = AbstractTermLike{T}
_atl(::Type, ::Type) = AbstractTermLike
__atl(::Type{T}, ::Type{<:AbstractTermLike{S}}) where {S,T} = _atl(T, S)
__atl(::Type{T}, ::Type{<:_APL{S}}) where {S,T} = _apl(T, S)
function Base.promote_rule(
    ::Type{AbstractTermLike{T}},
    P::Type{<:AbstractTermLike{S}},
) where {S,T}
    return _atl(T, S)
end
function Base.promote_rule(
    P::Type{<:AbstractTermLike{S}},
    ::Type{AbstractTermLike{T}},
) where {S,T}
    return _atl(T, S)
end
function Base.promote_rule(
    ::Type{AbstractTermLike{T}},
    P::Type{<:_APL{S}},
) where {S,T}
    return _apl(T, S)
end
function Base.promote_rule(
    P::Type{<:_APL{S}},
    ::Type{AbstractTermLike{T}},
) where {S,T}
    return _apl(T, S)
end
function Base.promote_rule(
    ::Type{AbstractTermLike{T}},
    P::Type{_APL{S}},
) where {S,T}
    return _apl(T, S)
end
function Base.promote_rule(
    P::Type{_APL{S}},
    ::Type{AbstractTermLike{T}},
) where {S,T}
    return _apl(T, S)
end

# AbstractTermLike
function Base.promote_rule(::Type{AbstractTermLike}, ::Type{<:AbstractTermLike})
    return AbstractTermLike
end
function Base.promote_rule(::Type{<:AbstractTermLike}, ::Type{AbstractTermLike})
    return AbstractTermLike
end
Base.promote_rule(::Type{AbstractTermLike}, ::Type{<:_APL}) = _APL
Base.promote_rule(::Type{<:_APL}, ::Type{AbstractTermLike}) = _APL
Base.promote_rule(::Type{AbstractTermLike}, ::Type{_APL}) = _APL
Base.promote_rule(::Type{_APL}, ::Type{AbstractTermLike}) = _APL

# _APL{T}
_apl(::Type{T}, ::Type{T}) where {T} = _APL{T}
_apl(::Type, ::Type) = _APL
Base.promote_rule(::Type{_APL{T}}, ::Type{<:_APL{S}}) where {S,T} = _apl(S, T)
Base.promote_rule(::Type{<:_APL{S}}, ::Type{_APL{T}}) where {S,T} = _apl(S, T)

# _APL
Base.promote_rule(::Type{_APL}, ::Type{<:_APL}) = _APL
Base.promote_rule(::Type{<:_APL}, ::Type{_APL}) = _APL

# Rational
function promote_rule_constant(
    ::Type{T},
    ::Type{RationalPoly{NT,DT}},
) where {T,NT,DT}
    return RationalPoly{promote_type(T, NT),promote_type(DT, term_type(DT))}
end

function Base.promote_rule(::Type{RT}, ::Type{T}) where {T,RT<:RationalPoly}
    return promote_rule_constant(T, RT)
end

function promote_rule_rational(
    ::Type{PT},
    ::Type{RationalPoly{S,T}},
) where {PT<:_APL,S,T}
    return RationalPoly{promote_type(PT, S),promote_type(T, term_type(T))}
end
function promote_rule_rational(
    ::Type{RationalPoly{S,T}},
    ::Type{RationalPoly{U,V}},
) where {S,T,U,V}
    return RationalPoly{promote_type(S, U),promote_type(T, V)}
end

function Base.promote_rule(
    ::Type{RS},
    ::Type{RT},
) where {RS<:RationalPoly,RT<:RationalPoly}
    return promote_rule_rational(RS, RT)
end
function Base.promote_rule(
    ::Type{PT},
    ::Type{RT},
) where {PT<:_APL,RT<:RationalPoly}
    return promote_rule_rational(PT, RT)
end
function Base.promote_rule(
    ::Type{RT},
    ::Type{PT},
) where {PT<:_APL,RT<:RationalPoly}
    return promote_rule_rational(PT, RT)
end

# MutableArithmetics
function MA.promote_operation(
    op::Union{typeof(+),typeof(-)},
    PT::Type{<:_APL{S}},
    QT::Type{<:_APL{T}},
) where {S,T}
    U = MA.promote_operation(op, S, T)
    return polynomial_type(
        promote_type(monomial_type(PT), monomial_type(QT)),
        U,
    )
end
function MA.promote_operation(
    ::typeof(*),
    MT1::Type{<:AbstractMonomialLike},
    MT2::Type{<:AbstractMonomialLike},
)
    return promote_type(monomial_type(MT1), monomial_type(MT2))
end
function MA.promote_operation(
    ::typeof(*),
    TT::Type{<:AbstractTermLike{S}},
    ST::Type{<:AbstractTermLike{T}},
) where {S,T}
    UT = MA.promote_operation(*, monomial_type(TT), monomial_type(ST))
    U = MA.promote_operation(*, S, T)
    return promote_operation_left_constant(*, U, UT)
end
function MA.promote_operation(
    ::typeof(*),
    PT::Type{<:_APL{S}},
    QT::Type{<:_APL{T}},
) where {S,T}
    UP = MA.promote_operation(*, monomial_type(PT), monomial_type(QT))
    U = MA.promote_sum_mul(S, T)
    return polynomial_type(promote_operation_left_constant(*, U, UP))
end

function promote_operation_left_constant(
    ::typeof(*),
    ::Type{T},
    ::Type{M},
) where {T,M<:AbstractMonomialLike}
    return term_type(M, T)
end

function promote_operation_right_constant(
    ::typeof(*),
    ::Type{M},
    ::Type{T},
) where {T,M<:AbstractMonomialLike}
    return term_type(M, T)
end

function promote_operation_left_constant(
    ::typeof(*),
    ::Type{T},
    ::Type{P},
) where {T,U,P<:_APL{U}}
    return similar_type(P, MA.promote_operation(*, T, U))
end

function promote_operation_right_constant(
    ::typeof(*),
    ::Type{P},
    ::Type{T},
) where {T,U,P<:_APL{U}}
    return similar_type(P, MA.promote_operation(*, U, T))
end

function MA.promote_operation(
    ::typeof(*),
    ::Type{T},
    ::Type{P},
) where {T,P<:_APL}
    return promote_operation_left_constant(*, T, P)
end

function MA.promote_operation(
    ::typeof(*),
    ::Type{P},
    ::Type{T},
) where {T,P<:_APL}
    return promote_operation_right_constant(*, P, T)
end

function MA.promote_operation(
    ::typeof(*),
    ::Type{P},
    ::Type{RationalPoly{NT,DT}},
) where {P<:_APL,NT,DT}
    return RationalPoly{MA.promote_operation(*, P, NT),DT}
end

function MA.promote_operation(
    ::typeof(*),
    ::Type{RationalPoly{NT,DT}},
    ::Type{P},
) where {P<:_APL,NT,DT}
    return RationalPoly{MA.promote_operation(*, NT, P),DT}
end

function MA.promote_operation(
    ::typeof(*),
    ::Type{RationalPoly{NS,DS}},
    ::Type{RationalPoly{NT,DT}},
) where {NS,DS,NT,DT}
    return RationalPoly{
        MA.promote_operation(*, NS, NT),
        MA.promote_operation(*, DS, DT),
    }
end

function _search_sorted_first(haystack::AbstractVector, needle; kws...)
    return searchsortedfirst(haystack, needle; kws...)
end
function _search_sorted_first(haystack::Tuple, needle; kws...)
    return findfirst(isequal(needle), haystack)
end

_idx(needle, haystack) = _search_sorted_first(haystack, needle, rev = true)

struct ExponentMap{I,L} <: Function
    indices::I
    length::L
end

function (map::ExponentMap{Vector{Int}})(exp::Vector{Int})
    new_exp = zeros(Int, map.length)
    for (i, e) in zip(map.indices, exp)
        new_exp[i] = e
    end
    return new_exp
end

function (map::ExponentMap{NTuple{N,Int}})(exp::NTuple{N,Int}) where {N}
    return ntuple(map.length::Val) do i
        # This does not have the best complexity since `findfirst`
        # search through the whole list each time but since we're using
        # tuples, we're probably not having a large list if indices anyway
        j = findfirst(isequal(i), map.indices)
        if isnothing(j)
            return 0
        else
            return exp[j]
        end
    end
end

_length(x::AbstractVector) = length(x)
_length(::NTuple{N,Any}) where {N} = Val(N)

function _map(needles, haystack)
    if length(needles) == length(haystack)
        return nothing
    end
    return ExponentMap(
        map(Base.Fix2(_idx, haystack), needles),
        _length(haystack),
    )
end

"""
    promote_variables_with_maps(a, b)

Given two sorted variable collections `a` and `b`, return
`((all_vars, map_a), (all_vars, map_b))` where `all_vars` is the merged
sorted variable set and `map_a` (resp. `map_b`) is an `ExponentMap`
that maps exponents from `a` (resp. `b`) to exponents in `all_vars`,
or `nothing` if no mapping is needed.
"""
function promote_variables_with_maps(a, b)
    if a == b
        return (a, nothing), (b, nothing)
    end
    all_vars = SA.merge_sorted(
        a,
        b;
        lt = isless,
        combine = SA.first_of,
        filter = _ -> true,
        rev = true,
    )
    return (all_vars, _map(a, all_vars)), (all_vars, _map(b, all_vars))
end

function SA.promote_with_map(t::AbstractTerm, all_vars, map::ExponentMap)
    mono, _ = SA.promote_with_map(monomial(t), all_vars, map)
    return term(coefficient(t), mono), map
end

function SA.promote_with_map(p::AbstractPolynomial, all_vars, map::ExponentMap)
    new_terms = [
        term(
            coefficient(t),
            first(SA.promote_with_map(monomial(t), all_vars, map)),
        ) for t in terms(p)
    ]
    return polynomial(new_terms, SortedUniqState()), map
end

function SA.promote_bases_with_maps(p::_APL, q::_APL)
    _p, _q = promote_variables_with_maps(variables(p), variables(q))
    return SA.maybe_promote(p, _p...), SA.maybe_promote(q, _q...)
end

# Base on the TypedPolynomials/abstract/substition.jl written by Robin Deits

# TODO Vararg{<:...} -> Vararg{...}
const Substitution = Pair{<:AbstractVariable}
const MultiSubstitution{N} =
    Pair{<:Tuple{Vararg{AbstractVariable,N}},<:Tuple{Vararg{Any,N}}}
const MultiVectorSubstitution =
    Pair{<:Tuple{Vararg{AbstractVariable}},<:AbstractVector}

# When the variables are promoted to be in the same vector they could be promoted into a monomial
const VectorMultiSubstitution =
    Pair{<:AbstractVector{<:AbstractMonomialLike},<:Tuple}
const VectorMultiVectorSubstitution =
    Pair{<:AbstractVector{<:AbstractMonomialLike},<:AbstractVector}
function _monomial_vector_to_variable_tuple(
    s::Pair{<:AbstractVector{<:AbstractMonomial}},
)
    return variable.(Tuple(s.first)) => s.second
end
_monomial_vector_to_variable_tuple(s) = s

const AbstractMultiSubstitution = Union{
    MultiSubstitution,
    MultiVectorSubstitution,
    VectorMultiVectorSubstitution,
    VectorMultiSubstitution,
}
const AbstractSubstitution = Union{Substitution,AbstractMultiSubstitution}
const Substitutions = Tuple{Vararg{AbstractSubstitution}}

abstract type AbstractSubstitutionType end
struct Subs <: AbstractSubstitutionType end
struct Eval <: AbstractSubstitutionType end
const _AST = AbstractSubstitutionType

"""
    subs(polynomial, (x, y)=>(1, 2))

is equivalent to:

    subs(polynomial, (x=>1, y=>2))
"""
function substitute(st::_AST, p::_APL, s::AbstractMultiSubstitution)
    return substitute(st, p, _flatten_subs(s))
end

## Variables
function substitute(st::_AST, v::AbstractVariable, s::Substitutions)
    return substitute(st, v, s...)
end

## Monomials
function powersubstitute(
    st::_AST,
    s::Substitutions,
    p::Tuple{AbstractVariable,Integer},
)
    return substitute(st, p[1], s...)^p[2]
end
function powersubstitute(
    st::_AST,
    s::Substitutions,
    p::Tuple{AbstractVariable,Integer},
    p2...,
)
    return powersubstitute(st, s, p) * powersubstitute(st, s, p2...)
end

function _promote_subs(
    S,
    ::Type{V},
    s::Substitution,
) where {V<:AbstractVariable}
    return MA.promote_operation(substitute, S, V, typeof(s))
end

function _flatten_subs(s::AbstractMultiSubstitution)
    return pair_zip(_monomial_vector_to_variable_tuple(s))
end

function _flatten_subs(s::Substitution)
    return (s,)
end

# Turn a tuple of `AbstractSubstitution` into a `Tuple` if `Substitution`
function _flatten_subs(
    s::AbstractSubstitution,
    tail::Vararg{AbstractSubstitution,N},
) where {N}
    return (_flatten_subs(s)..., _flatten_subs(tail...)...)
end

function power_promote(
    S,
    ::Type{V},
    s::Substitutions,
) where {V<:AbstractVariable}
    T = MA.promote_operation(substitute, S, V, typeof.(_flatten_subs(s...))...)
    return MA.promote_operation(*, T, T)
end

function power_promote(
    S,
    ::Vector{V},
    s::Substitutions,
) where {V<:AbstractVariable}
    return power_promote(S, V, s)
end

function power_promote(
    S,
    ::Tuple{V},
    s::Substitutions,
) where {V<:AbstractVariable}
    return power_promote(S, V, s)
end

function power_promote(
    S,
    vars::Tuple{V,Vararg{AbstractVariable,N}},
    s::Substitutions,
) where {V<:AbstractVariable,N}
    return MA.promote_operation(
        *,
        power_promote(S, V, s),
        power_promote(S, Base.tail(vars), s),
    )
end

function substitute(st::_AST, m::AbstractMonomial, s::Substitutions)
    if isconstant(m)
        return one(power_promote(typeof(st), variables(m), s))
    else
        return powersubstitute(st, s, powers(m)...)
    end
end

## Terms
function substitute(st::_AST, t::AbstractTerm, s::Substitutions)
    return coefficient(t) * substitute(st, monomial(t), s)
end

function MA.promote_operation(
    ::typeof(substitute),
    ::Type{Eval},
    ::Type{M},
    ::Type{Pair{V,T}},
) where {M<:AbstractMonomial,V<:AbstractVariable,T}
    return MA.promote_operation(*, T, T)
end

function MA.promote_operation(
    ::typeof(substitute),
    ::Type{S},
    ::Type{T},
    args::Vararg{Type,N},
) where {S<:AbstractSubstitutionType,T<:AbstractTerm,N}
    M = MA.promote_operation(substitute, S, monomial_type(T), args...)
    U = coefficient_type(T)
    return MA.promote_operation(*, U, M)
end

## Polynomials
_polynomial(α) = α
_polynomial(p::_APL) = polynomial(p)
function substitute(st::_AST, p::AbstractPolynomial, s::Substitutions)
    if iszero(p)
        _polynomial(substitute(st, zero_term(p), s))
    else
        ts = terms(p)
        r1 = substitute(st, ts[1], s)
        R = MA.promote_operation(+, typeof(r1), typeof(r1))
        result::R = convert(R, r1)
        for i in 2:length(ts)
            result += substitute(st, ts[i], s)
        end
        result
    end
end

function MA.promote_operation(
    ::typeof(substitute),
    ::Type{S},
    ::Type{P},
    args::Vararg{Type,N},
) where {S<:AbstractSubstitutionType,P<:AbstractPolynomial,N}
    T = MA.promote_operation(substitute, S, term_type(P), args...)
    return MA.promote_operation(+, T, T)
end

## Fallbacks
function substitute(st::_AST, p::_APL, s::Substitutions)
    return substitute(st, polynomial(p), s)
end
function substitute(st::_AST, q::RationalPoly, s::Substitutions)
    return substitute(st, q.num, s) / substitute(st, q.den, s)
end

# subs(x, x=>x+y, y=>2) would call substitute(Subs(), x+y, y=>2)
#substitute(st::_AST, p::Union{_APL, RationalPoly}, s::AbstractSubstitution...) = substitute(st, p, s)

# Substitute Arrays
function substitute(st::_AST, A::AbstractArray{<:_APL}, s::Substitutions)
    return map(p -> substitute(st, p, s), A)
end
## Everything else
substitute(::_AST, x, s::Substitutions) = x
# subs(x, x=>1, y=>2) would call substitute(Subs(), 1, y=>2)
#substitute(::_AST, x, s::AbstractSubstitution...) = x

"""
    subs(p, s::AbstractSubstitution...)

Apply the substitutions `s` to `p`.
Use `p(s...)` if we are sure that all the variables are substited in `s`.

The allowed substutions are:

* `v => p` where `v` is a variable and `p` a polynomial, e.g. `x => 1` or `x => x^2*y + x + y`.
* `V => P` where `V` is a tuple or vector of variables and `P` a tuple or vector of polynomials, e.g. `(x, y) => (y, x)` or `(y, x) => (2, 1)`.

The order of the variables is lexicographic with the name with TypedPolynomials and by order of creation with DynamicPolynomials.
Since there is no guarantee on the order of the variables, substitution directly with a tuple or a vector is not allowed.
You can use `p(variables(p) => (1, 2))` instead if you are sure of the order of the variables (e.g. the name order matches the creation order).

### Examples

```julia
p = 3x^2*y + x + 2y + 1
p(x => 2, y => 1) # Return type is Int
subs(p, x => 2, y => 1) # Return type is Int in TypedPolynomials but is a polynomial of Int coefficients in DynamicPolynomials
subs(p, y => x*y^2 + 1)
p(y => 2) # Do not do that, this works fine with TypedPolynomials but it will not return a correct result with DynamicPolynomials since it thinks that the return type is `Int`.
```

"""
subs(p, s::AbstractSubstitution...) = substitute(Subs(), p, s)

(p::RationalPoly)(s::AbstractSubstitution...) = p.num(s...) / p.den(s...)

export isrealpart,
    isimagpart,
    isconj,
    ordinary_variable,
    degree_complex,
    halfdegree,
    mindegree_complex,
    minhalfdegree,
    maxdegree_complex,
    maxhalfdegree,
    extdegree_complex,
    exthalfdegree

"""
    isreal(x::AbstractVariable)

Return whether a given variable was declared as a real-valued or complex-valued variable (also their conjugates are complex,
but their real and imaginary parts are not).
By default, all variables are real-valued.
"""
Base.isreal(::AbstractVariable) = true

"""
    isrealpart(x::AbstractVariable)

Return whether the given variable is the real part of a complex-valued variable.

See also [`isreal`](@ref), [`isimagpart`](@ref), [`isconj`](@ref).
"""
isrealpart(::AbstractVariable) = false

"""
    isimagpart(x::AbstractVariable)

Return whether the given variable is the imaginary part of a complex-valued variable.

See also [`isreal`](@ref), [`isrealpart`](@ref), [`isconj`](@ref).
"""
isimagpart(::AbstractVariable) = false

"""
    isconj(x::AbstractVariable)

Return whether the given variable is obtained by conjugating a user-defined complex-valued variable.

See also [`isreal`](@ref), [`isrealpart`](@ref), [`isimagpart`](@ref).
"""
isconj(::AbstractVariable) = false

"""
    ordinary_variable(x::Union{AbstractVariable, AbstractVector{<:AbstractVariable}})

Given some (complex-valued) variable that was transformed by conjugation, taking its real part, or taking its
imaginary part, return the original variable as it was defined by the user.

See also [`conj`](@ref), [`real`](@ref), [`imag`](@ref).
"""
ordinary_variable(x::AbstractVariable) = MA.copy_if_mutable(x)

"""
    conj(x::AbstractVariable)

Return the complex conjugate of a given variable if it was declared as a complex variable; else return the
variable unchanged.

See also [`isreal`](@ref), [`isconj`](@ref).
"""
Base.conj(x::AbstractVariable) = MA.copy_if_mutable(x)
@doc """
    conj(x::AbstractPolynomialLike)

Return the complex conjugate of `x` by applying conjugation to all coefficients and variables.
""" conj(::_APL)
@doc """
    conj(x::AbstractVector{<:AbstractMonomial})

Return the complex conjugate of `x` by applying conjugation to monomials.
""" conj(::AbstractVector{<:AbstractMonomial})

"""
    real(x::AbstractVariable)

Return the real part of a given variable if it was declared as a complex variable; else return the variable
unchanged.

See also [`imag`](@ref).
"""
Base.real(x::AbstractVariable) = MA.copy_if_mutable(x)
@doc """
    real(x::AbstractPolynomialLike)

Return the real part of `x` by applying [`real`](@ref) to all coefficients and variables; for this purpose, every
complex-valued variable is decomposed into its real- and imaginary parts.

See also [`imag`](@ref).
""" real(::_APL)
@doc """
    real(x::AbstractVector{<:AbstractMonomial})

Return the real part of `x` by applying [`real`](@ref) to all monomials; for this purpose, every complex-valued variable is
decomposed into its real- and imaginary parts. Note that the result will no longer be a monomial vector.

See also [`imag`](@ref).
""" real(::AbstractVector{<:AbstractMonomial})

"""
    imag(x::AbstractVariable)

Return the imaginary part of a given variable if it was declared as a complex variable; else return zero.

See also [`isreal`](@ref), [`isimagpart`](@ref), [`real`](@ref).
"""
Base.imag(::AbstractVariable) = MA.Zero()
@doc """
    imag(x::AbstractPolynomialLike)

Return the imaginary part of `x` by applying [`imag`](@ref) to all coefficients and variables; for this purpose, every
complex-valued variable is decomposed into its real- and imaginary parts.

See also [`real`](@ref).
""" imag(::_APL)
@doc """
    imag(x::AbstractVector{<:AbstractMonomial})

Return the imaginary part of `x` by applying [`imag`](@ref) to all monomials; for this purpose, every complex-valued variable
is decomposed into its real- and imaginary parts. Note that the result will no longer be a monomial vector.

See also [`real`](@ref).
""" imag(::AbstractVector{<:AbstractMonomial})

# extend to higher-level elements. We make all those type-stable (but we need convert, as the construction method may
# deliver simpler types than the inputs if they were deliberately casted, e.g., term to monomial)
"""
    isreal(p::AbstractPolynomialLike)

Returns `true` if and only if no single variable in `p` was declared as a complex variable (in the sense that [`isreal`](@ref)
applied on them would be `true`) and no coefficient is complex-valued.
"""
function Base.isreal(p::_APL)
    for v in variables(p)
        if !isreal(v) && !iszero(maxdegree(p, v))
            return false
        end
    end
    return all(isreal, coefficients(p))
end
"""
    isreal(p::AbstractVector{<:AbstractMonomial})

Returns `true` if and only if every single monomial in `p` would is real-valued.
"""
Base.isreal(p::AbstractVector{<:AbstractMonomial}) = all(isreal, p)

function Base.conj(x::M) where {M<:AbstractMonomial}
    return isreal(x) ? x :
           convert(
        M,
        reduce(
            *,
            conj(var)^exp for (var, exp) in powers(x);
            init = constant_monomial(x),
        ),
    )
end
function Base.conj(x::V) where {V<:AbstractVector{<:AbstractMonomial}}
    return isreal(x) ? MA.copy_if_mutable(x) : monomial_vector(conj.(x))
end
function Base.conj(x::T) where {T<:AbstractTerm}
    return isreal(x) ? MA.copy_if_mutable(x) :
           convert(T, conj(coefficient(x)) * conj(monomial(x)))
end
function Base.conj(x::P) where {P<:AbstractPolynomial}
    return iszero(x) || isreal(x) ? MA.copy_if_mutable(x) :
           convert(P, polynomial([conj(t) for t in terms(x)]))
end

# Real and imaginary parts are harder to realize. The real part of a monomial can easily be a polynomial.
for fun in [:real, :imag]
    eval(
        quote
            function Base.$fun(x::_APL)
                # Note: x may also be a polynomial; we could handle this case separately by performing the replacement in each
                # individual term, then adding them all up. This could potentially lower the overall memory requirement (in case
                # the expansions of the individual terms simplify) at the expense of not being able to exploit optimizations that
                # subst can do by knowing the full polynomial.
                iszero(x) &&
                    return zero(polynomial_type(x, real(coefficient_type(x))))
                # We replace every complex variable by its decomposition into real and imaginary part
                subst_vars = unique(
                    ordinary_variable(v) for v in variables(x) if !isreal(v)
                )
                # To avoid a stack overflow on promote_type, we'll handle the empty case separately
                full_version =
                    isempty(subst_vars) ? polynomial(x) :
                    subs(
                        x,
                        subst_vars =>
                            [real(var) + 1im * imag(var) for var in subst_vars],
                    )
                # Now everything that is imaginary can be recognized by its coefficient
                return convert(
                    polynomial_type(
                        full_version,
                        real(coefficient_type(full_version)),
                    ),
                    map_coefficients!($fun, full_version),
                )
            end
            function Base.$fun(x::AbstractVector{<:AbstractMonomial})
                return map(Base.$fun, x)
            end
        end,
    )
end

# Also give complex-valued degree definitions. We choose not to overwrite degree, as this will lead to issues in monovecs
# and their sorting. So now there are two ways to calculate degrees: strictly by considering all variables independently,
# and also by looking at their complex structure.
for fn in (:degree_complex, :halfdegree)
    @eval function $fn(t::AbstractTermLike)
        realdeg = 0
        cpdeg = 0
        conjdeg = 0
        for (var, exp) in powers(t)
            if isreal(var)
                realdeg += exp
                (isrealpart(var) || isimagpart(var)) && error(
                    "Cannot calculate complex degrees when real or imaginary parts are present",
                )
            else
                if isconj(var)
                    conjdeg += exp
                else
                    cpdeg += exp
                end
            end
        end
        return $(
            fn === :degree_complex ? :(realdeg) : :(div(realdeg, 2, RoundUp))
        ) + max(cpdeg, conjdeg)
    end
end

"""
    degree_complex(t::AbstractTermLike)

Return the _total complex degree_ of the monomial of the term `t`, i.e., the maximum of the total degree of the declared
variables in `t` and the total degree of the conjugate variables in `t`.
To be well-defined, the monomial must not contain real parts or imaginary parts of variables.
If `x₁` and `x₂` are real-valued variables and `z₁` and `z₂` are complex-valued,
- `degree_complex(x₁^2 * x₂^3) = 5`
- `degree_complex(z₁^3 * conj(z₁)^4) = max(3, 4) = 4` and `degree_complex(z₁^4 * conj(z₁)^3) = max(4, 3) = 4`
- `degree_complex(z₁^3 * z₂ * conj(z₁)^2 * conj(z₂)^4) = max(4, 6) = 6` and
  `degree_complex(z₁^4 * z₂ * conj(z₁) * conj(z₂)^3) = max(5, 4) = 5`
- `degree_complex(x₁^2 * x₂^3 * z₁^3 * z₂ * conj(z₁)^2 * conj(z₂)^4) = 5 + max(4, 6) = 11`
"""
degree_complex(t::AbstractTermLike)

"""
    halfdegree(t::AbstractTermLike)

Return the equivalent of `ceil(degree(t)/2)`` for real-valued terms or `degree_complex(t)` for terms with only complex
variables; however, respect any mixing between complex and real-valued variables.
To be well-defined, the monomial must not contain real parts or imaginary parts of variables.
If `x₁` and `x₂` are real-valued variables and `z₁` and `z₂` are complex-valued,
- `halfdegree(x₁^2 * x₂^3) = ⌈5/2⌉ = 3`
- `halfdegree(z₁^3 * conj(z₁)^4) = max(3, 4) = 4` and `halfdegree(z₁^4 * conj(z₁)^3) = max(4, 3) = 4`
- `halfdegree(z₁^3 * z₂ * conj(z₁)^2 * conj(z₂)^4) = max(4, 6) = 6` and
  `halfdegree(z₁^4 * z₂ * conj(z₁) * conj(z₂)^3) = max(5, 4) = 5`
- `halfdegree(x₁^2 * x₂^3 * z₁^3 * z₂ * conj(z₁)^2 * conj(z₂)^4) = ⌈5/2⌉ + max(4, 6) = 9`
"""
halfdegree(t::AbstractTermLike)

"""
    degree_complex(t::AbstractTermLike, v::AbstractVariable)

Returns the exponent of the variable `v` or its conjugate in the monomial of the term `t`, whatever is larger.

See also [`isconj`](@ref).
"""
function degree_complex(t::AbstractTermLike, var::AbstractVariable)
    return degree_complex(monomial(t), var)
end
degree_complex(v::AbstractVariable, var::AbstractVariable) = (v == var ? 1 : 0)
function degree_complex(m::AbstractMonomial, v::AbstractVariable)
    deg = 0
    deg_c = 0
    c_v = conj(v)
    for (var, exp) in powers(m)
        (isrealpart(var) || isimagpart(var)) && error(
            "Cannot calculate complex degrees when real or imaginary parts are present",
        )
        if var == v
            deg += exp
        elseif var == c_v
            deg_c += exp
        end
    end
    return max(deg, deg_c)
end

"""
    mindegree_complex(p::Union{AbstractPolynomialLike, AbstractVector{<:AbstractTermLike}})

Return the minimal total complex degree of the monomials of `p`, i.e., `minimum(degree_complex, terms(p))`.

    mindegree_complex(p::Union{AbstractPolynomialLike, AbstractVector{<:AbstractTermLike}}, v::AbstractVariable)

Return the minimal complex degree of the monomials of `p` in the variable `v`, i.e., `minimum(degree_complex.(terms(p), v))`.
"""
function mindegree_complex(X::AbstractVector{<:AbstractTermLike}, args...)
    return isempty(X) ? 0 :
           minimum(t -> degree_complex(t, args...), X, init = 0)
end
function mindegree_complex(p::_APL, args...)
    return mindegree_complex(terms(p), args...)
end

"""
    minhalfdegree(p::Union{AbstractPolynomialLike, AbstractVector{<:AbstractTermLike}})

Return the minmal half degree of the monomials of `p`, i.e., `minimum(halfdegree, terms(p))`
"""
function minhalfdegree(X::AbstractVector{<:AbstractTermLike}, args...)
    return isempty(X) ? 0 : minimum(halfdegree, X, init = 0)
end
minhalfdegree(p::_APL) = minhalfdegree(terms(p))

"""
    maxdegree_complex(p::Union{AbstractPolynomialLike, AbstractVector{<:AbstractTermLike}})

Return the maximal total complex degree of the monomials of `p`, i.e., `maximum(degree_complex, terms(p))`.

    maxdegree_complex(p::Union{AbstractPolynomialLike, AbstractVector{<:AbstractTermLike}}, v::AbstractVariable)

Return the maximal complex degree of the monomials of `p` in the variable `v`, i.e., `maximum(degree_complex.(terms(p), v))`.
"""
function maxdegree_complex(X::AbstractVector{<:AbstractTermLike}, args...)
    return mapreduce(t -> degree_complex(t, args...), max, X, init = 0)
end
function maxdegree_complex(p::_APL, args...)
    return maxdegree_complex(terms(p), args...)
end

"""
    maxhalfdegree(p::Union{AbstractPolynomialLike, AbstractVector{<:AbstractTermLike}})

Return the maximal half degree of the monomials of `p`, i.e., `maximum(halfdegree, terms(p))`
"""
function maxhalfdegree(X::AbstractVector{<:AbstractTermLike}, args...)
    return isempty(X) ? 0 : maximum(halfdegree, X, init = 0)
end
maxhalfdegree(p::_APL) = maxhalfdegree(terms(p))

"""
    extdegree(p::Union{AbstractPolynomialLike, AbstractVector{<:AbstractTermLike}})

Returns the extremal total complex degrees of the monomials of `p`, i.e., `(mindegree_complex(p), maxdegree_complex(p))`.

    extdegree(p::Union{AbstractPolynomialLike, AbstractVector{<:AbstractTermLike}}, v::AbstractVariable)

Returns the extremal complex degrees of the monomials of `p` in the variable `v`, i.e.,
`(mindegree_complex(p, v), maxdegree_complex(p, v))`.
"""
function extdegree_complex(
    p::Union{_APL,AbstractVector{<:AbstractTermLike}},
    args...,
)
    return (mindegree_complex(p, args...), maxdegree_complex(p, args...))
end

"""
    exthalfdegree(p::Union{AbstractPolynomialLike, AbstractVector{<:AbstractTermLike}})

Return the extremal half degree of the monomials of `p`, i.e., `(minhalfdegree(p), maxhalfdegree(p))`
"""
function exthalfdegree(p::Union{_APL,AbstractVector{<:AbstractTermLike}})
    return (minhalfdegree(p), maxhalfdegree(p))
end

function ordinary_variable(x::AbstractVector{<:AbstractVariable})
    # let's assume the number of elements in x is small, else a conversion to a dict (probably better OrderedDict) would
    # be better
    results = similar(x, 0)
    sizehint!(results, length(x))
    j = 0
    for el in x
        ov = ordinary_variable(el)
        found = false
        for i in 1:j
            if results[i] == ov
                found = true
                break
            end
        end
        if !found
            push!(results, ov)
            j += 1
        end
    end
    return results
end

# TODO We should take gcd between numerator and denominator
struct RationalPoly{NT<:_APL,DT<:_APL}
    num::NT
    den::DT
end

# This constructor is called from LinearAlgebra in the method Matrix{T}(s::UniformScaling{Bool}, dims)
function RationalPoly{NT,DT}(x::Bool) where {NT,DT}
    return ifelse(x, one(RationalPoly{NT,DT}), zero(RationalPoly{NT,DT}))
end

Base.numerator(r::RationalPoly) = r.num
Base.denominator(r::RationalPoly) = r.den

function Base.convert(
    ::Type{RationalPoly{NT,DT}},
    q::RationalPoly{NT,DT},
) where {NT,DT}
    return q
end
function Base.convert(
    ::Type{RationalPoly{NTout,DTout}},
    q::RationalPoly{NTin,DTin},
) where {NTout,DTout,NTin,DTin}
    return convert(NTout, q.num) / convert(DTout, q.den)
end
#function Base.convert(::Type{RationalPoly{NT, DT}}, p::NT) where {NT, DT}
#    p / one(DT)
#end
function Base.convert(::Type{RationalPoly{NT,DT}}, p::_APL) where {NT,DT}
    return convert(NT, p) / one(DT)
end
function Base.convert(::Type{RationalPoly{NT,DT}}, α) where {NT,DT}
    return convert(NT, α) / one(DT)
    #convert(RationalPoly{NT, DT}, convert(NT, α))
end

# This is called by the default implementation of `Base.oneunit`, still in Julia v1.8 at least
RationalPoly{NT,DT}(r::RationalPoly{NT,DT}) where {NT,DT} = r

Base.inv(r::RationalPoly) = r.den / r.num
Base.inv(p::_APL{T}) where {T} = one(T) / p
Base.:/(r::RationalPoly, p) = r.num / (r.den * p)
Base.:/(r::RationalPoly, p::_APL) = r.num / (r.den * p)
Base.:/(r::RationalPoly, s::RationalPoly) = (r.num * s.den) / (s.num * r.den)
function Base.:/(num::NT, den::DT) where {NT<:_APL,DT<:_APL}
    return RationalPoly{NT,DT}(num, den)
end
function Base.:/(num, den::_APL)
    return constant_term(num, den) / den
end
# Polynomial divided by coefficient is a polynomial not a rational polynomial
# (1/den) * num would not be correct in case of noncommutative coefficients
Base.:/(num::_APL, den) = map_coefficients(α -> α / den, num, nonzero = true)

function Base.:+(r::RationalPoly, s::RationalPoly)
    return (r.num * s.den + r.den * s.num) / (r.den * s.den)
end
function _plus(r::RationalPoly, p)
    return (p * r.den + r.num) / r.den
end
Base.:+(p::_APL, r::RationalPoly) = _plus(r, p)
Base.:+(r::RationalPoly, p::_APL) = _plus(r, p)
Base.:+(r::RationalPoly, α) = _plus(r, α)
Base.:+(α, r::RationalPoly) = _plus(r, α)
function Base.:-(r::RationalPoly, s::RationalPoly)
    return (r.num * s.den - r.den * s.num) / (r.den * s.den)
end
_minus(p, s::RationalPoly) = (p * s.den - s.num) / s.den
_minus(s::RationalPoly, p) = (s.num - p * s.den) / s.den
Base.:-(p::_APL, r::RationalPoly) = _minus(p, r)
Base.:-(r::RationalPoly, p::_APL) = _minus(r, p)
Base.:-(r::RationalPoly, α) = _minus(r, α)
Base.:-(α, r::RationalPoly) = _minus(α, r)
Base.:-(r::RationalPoly) = (-r.num) / r.den

Base.:*(r::RationalPoly, s::RationalPoly) = (r.num * s.num) / (r.den * s.den)
Base.:*(p::_APL, r::RationalPoly) = (p * r.num) / r.den
Base.:*(r::RationalPoly, p::_APL) = (r.num * p) / r.den
Base.:*(α, r::RationalPoly) = (α * r.num) / r.den
Base.:*(r::RationalPoly, α) = (r.num * α) / r.den

Base.zero(r::RationalPoly) = zero(typeof(r))
Base.zero(::Type{RationalPoly{NT,DT}}) where {NT,DT} = zero(NT) / one(DT)
Base.one(r::RationalPoly) = one(typeof(r))
Base.one(::Type{RationalPoly{NT,DT}}) where {NT,DT} = one(NT) / one(DT)

const TypesWithShow = Union{
    AbstractVariable,
    AbstractMonomial,
    AbstractTerm,
    AbstractPolynomial,
    RationalPoly,
}
function Base.show(io::IO, mime::MIME"text/latex", p::TypesWithShow)
    print(io, "\$\$ ")
    _show(io, mime, p)
    return print(io, " \$\$")
end

# If the MIME is not specified, IJulia thinks that it supports images, ...
# and then use the result of show and tries to interpret it as an svg, ...
# We need the two methods to avoid ambiguity
function Base.show(io::IO, mime::MIME"text/plain", p::TypesWithShow)
    return _show(io, mime, p)
end
function Base.show(io::IO, mime::MIME"text/print", p::TypesWithShow)
    return _show(io, mime, p)
end

Base.print(io::IO, p::TypesWithShow) = show(io, MIME"text/print"(), p)
Base.show(io::IO, p::TypesWithShow) = show(io, MIME"text/plain"(), p)

# VARIABLES
function _show(io::IO, mime::MIME, var::AbstractVariable)
    base, indices = name_base_indices(var)
    if isconj(var)
        for c in String(base)
            print(io, c, '\u0305') # displays as overbar (̄z)
        end
    else
        print(io, base)
    end
    if !isempty(indices)
        print_subscript(io, mime, indices)
    end
    isrealpart(var) && print(io, "ᵣ") # suffixes for real and imaginary part: zᵣ, zᵢ
    return isimagpart(var) && print(io, "ᵢ")
end

function print_subscript(io::IO, ::MIME"text/print", index)
    return print(io, "[", join(index, ","), "]")
end
function print_subscript(io::IO, ::MIME"text/latex", index)
    return print(io, "_{", join(index, ","), "}")
end
function print_subscript(io::IO, mime, indices)
    if length(indices) == 1
        print(io, unicode_subscript(indices[1]))
    else
        print(io, join(unicode_subscript.(indices), "\u208B"))
    end
end

const unicode_subscripts = ("₀", "₁", "₂", "₃", "₄", "₅", "₆", "₇", "₈", "₉")
unicode_subscript(i) = join(unicode_subscripts[d+1] for d in reverse(digits(i)))

# MONOMIALS
function _show(io::IO, mime, m::AbstractMonomial)
    if isconstant(m)
        print(io, '1')
    else
        printed_var = false
        vars = variables(m)
        n = length(vars)
        for (i, var, exp) in zip(1:n, vars, exponents(m))
            if !iszero(exp)
                if mime isa MIME"text/print" && printed_var && i > 0
                    print(io, "*")
                end
                _show(io, mime, var)
                printed_var = true
                if !isone(exp)
                    print_exponent(io, mime, exp)
                end
            end
        end
    end
end

print_exponent(io::IO, ::MIME"text/latex", exp) = print(io, "^{", exp, "}")
print_exponent(io::IO, ::MIME"text/print", exp) = print(io, "^", exp)
function print_exponent(io::IO, mime, exp)
    return print(io, join(unicode_superscript.(reverse(digits(exp)))))
end

const unicode_superscripts = ("⁰", "¹", "²", "³", "⁴", "⁵", "⁶", "⁷", "⁸", "⁹")
unicode_superscript(i) = unicode_superscripts[i+1]

# TERM
function _show(io::IO, mime, t::AbstractTerm)
    if isconstant(t)
        print_coefficient(io, mime, coefficient(t))
    else
        if should_print_coefficient(coefficient(t))
            if !should_print_coefficient(-coefficient(t))
                print(io, '-')
            else
                print_coefficient(io, mime, coefficient(t))
                if !iszero(t)
                    # Print a multiplication sign between coefficent and monmomial
                    # depending on the mime type
                    print_maybe_multiplication_sign(io, mime)
                end
            end
        end
        if !iszero(t)
            _show(io, mime, monomial(t))
        end
    end
end

"""
    print_maybe_multiplication_sign(io, mime)

Prints a multiplication sign depending on the `mime` type.
"""
print_maybe_multiplication_sign(io::IO, ::MIME"text/print") = print(io, "*")
print_maybe_multiplication_sign(io::IO, mime) = nothing

should_print_coefficient(x) = true  # By default, just print all coefficients
should_print_coefficient(x::Number) = !isone(x) # For numbers, we omit any "one" coefficients
# `Int`, `Float64` don't support MIME"text/latex".
# We could add a check with `showable` if a `Real` subtype supports it and
# the feature is requested.
print_coefficient(io::IO, mime, coeff::Real) = print(io, coeff)
# Scientific notation does not display well in LaTeX so we rewrite it
function print_coefficient(io::IO, mime::MIME"text/latex", coeff::AbstractFloat)
    s = string(coeff)
    if occursin('e', s)
        s = replace(s, 'e' => " \\cdot 10^{") * '}'
    end
    return print(io, s)
end

function _trim_LaTeX(s::AbstractString)
    i = firstindex(s)
    j = lastindex(s)
    while true
        if i < j && isspace(s[i])
            i = nextind(s, i)
        elseif i < j && isspace(s[j])
            j = prevind(s, j)
        elseif i < j && s[i] == '$' && s[j] == '$'
            i = nextind(s, i)
            j = prevind(s, j)
        elseif i < j && (
            (s[i:nextind(s, i)] == "\\(" && s[prevind(s, j):j] == "\\)") ||
            (s[i:nextind(s, i)] == "\\[" && s[prevind(s, j):j] == "\\]")
        )
            i = nextind(s, i, 2)
            j = prevind(s, j, 2)
        else
            return s[i:j]
        end
    end
end

# JuMP expressions supports LaTeX output so `showable` will return `true`
# for them. It is important for anonymous variables to display properly as well:
# https://github.com/jump-dev/SumOfSquares.jl/issues/256
# Since they add `$$` around it, we need to trim it with `_trim_LaTeX`
function print_coefficient(io::IO, mime, coeff)
    print(io, "(")
    if showable(mime, coeff)
        print(io, _trim_LaTeX(sprint(show, mime, coeff)))
    else
        show(io, coeff)
    end
    return print(io, ")")
end

# POLYNOMIAL
function _show(io::IO, mime, p::AbstractPolynomial{T}) where {T}
    ts = terms(p)
    if isempty(ts)
        print(io, zero(T))
    else
        _show(io, mime, first(ts))
        for t in Iterators.drop(ts, 1)
            if isnegative(coefficient(t))
                print(io, " - ")
                _show(io, mime, abs(coefficient(t)) * monomial(t))
            else
                print(io, " + ")
                _show(io, mime, t)
            end
        end
    end
end

isnegative(x::Real) = x < 0
isnegative(x) = false

# RATIONAL POLY
function _show(io::IO, mime, p::RationalPoly)
    print(io, mime isa MIME"text/latex" ? "\\frac{" : "(")
    _show(io, mime, p.num)
    print(io, mime isa MIME"text/latex" ? "}{" : ") / (")
    _show(io, mime, p.den)
    return print(io, mime isa MIME"text/latex" ? "}" : ")")
end

@testset "Comparison" begin
    @testset "Graded Lex Order" begin
        Mod.@polyvar x y z
        O = Graded{LexOrder}
        @test ordering(x) == O
        @test ordering(x * y) == O
        @test ordering(variables(x * y)) == O
        @test x > y > z
        @test x^2 * y > y^3 > z
        @test y^2 >= x
        # Examples from p. 58, 59 of the 4th edition of "Ideals, Varieties, and Algorithms" of Cox, Little and O'Shea
        @test x^1 * y^2 * z^3 > x^3 * y^2
        @test !(x^1 * y^2 * z^3 < x^3 * y^2)
        @test x^1 * y^2 * z^4 > x^1 * y^1 * z^5
        @test !(x^1 * y^2 * z^4 < x^1 * y^1 * z^5)
        @test x^4 * y^7 * z > x^4 * y^2 * z^3
        @test !(x^4 * y^7 * z < x^4 * y^2 * z^3)
        @test x * y^5 * z^2 < x^4 * y * z^3
        @test !(x * y^5 * z^2 > x^4 * y * z^3)
        @test x^5 * y * z > x^4 * y * z^2
        @test !(x^5 * y * z < x^4 * y * z^2)
    end
    @testset "Equality" begin
        @testset "Monomial equality" begin
            Mod.@polyvar x y
            @test 1 == constant_monomial(x)
            @test 1 ≈ constant_monomial(x)
            @test 2 != constant_monomial(x)
            @test !(2 ≈ constant_monomial(x))
            @test 2 != x
            @test !(2 ≈ x)
            @test 2 != x * y
            @test !(2 ≈ x * y)
            @test x * y != x
            @test !(x * y ≈ x)
            @test 1x * y == x * y
            @test 1x * y ≈ x * y
            @test 2x * y != x * y
            @test !(2x * y ≈ x * y)
            @test x == monomial(x)
            @test x ≈ monomial(x)
            @test x * y^0 == x
            @test x * y^0 ≈ x
            @test x != x^0 * y
            @test !(x ≈ x^0 * y)
            @test x^2 != x * y
            @test !(x^2 ≈ x * y)
        end
        @testset "Polynomial equality" begin
            Mod.@polyvar x y
            @test isapproxzero(0.0x, ztol = 0.0)
            @test polynomial(CustomTerms(x + 1 - x)) isa AbstractPolynomial
            @test MultivariatePolynomials.right_constant_eq(
                polynomial(CustomTerms(x + 1 - x)),
                1,
            )
            @test MultivariatePolynomials.right_constant_eq(
                CustomTerms(x + 1 - x),
                1,
            )
            @test 2 * CustomPoly(x + 1 - x) == 2
            @test 2 != CustomTerms(x + 1 - x)
            @test 3x^2 == CustomTerms(x - x + x^2) * 3
            @test CustomPoly(-x + x^2) != x^2
            @test 2 * x * y + 3 * y^2 == 3 * y^2 + 2 * y * x
            @test 3 * x * y + 2 * y^2 != 3 * y^2 + 2 * y * x
            @test x + y != x * (1 + y)
            @test x * y == 3x + 2x * y - x - x * y - 2x
            @test isapproxzero((1 + 1e-8)x - x, ztol = 1e-7)
            @test !isapproxzero((1 + 1e-6)x - x, ztol = 1e-7)
            @test isapprox(
                (2 - 1e-3) * x * y + (3 + 1e-3) * y^2,
                3 * y^2 + 2 * y * x,
                rtol = 1e-2,
            )
            @test !isapprox(
                (2 - 1e-3) * x * y + (3 + 1e-1) * y^2,
                3 * y^2 + 2 * y * x,
                rtol = 1e-2,
            )
            @test isapprox(
                1e-3 * x * y + 3 * y^2 + x^2,
                x^2 + 3 * y^2,
                rtol = 1e-2,
                ztol = 1e-2,
            )
            @test isapprox(
                1e-3 * x * y + 3 * y^2 + x^2,
                x^2 + 3 * y^2,
                rtol = 1e-2,
                atol = 1e-2,
            )
            @test isapprox(
                3 * y^2 + x^2,
                x^2 + 1e-3 * x * y + 3 * y^2,
                rtol = 1e-2,
                ztol = 1e-2,
            )
            @test isapprox(
                3 * y^2 + x^2,
                x^2 + 1e-3 * x * y + 3 * y^2,
                rtol = 1e-2,
                atol = 1e-2,
            )
            @test !isapprox(
                3 * y^2 + x^2,
                x^2 + 1e-1 * x * y + 3 * y^2,
                rtol = 1e-2,
                ztol = 1e-2,
            )
            @test !isapprox(
                3.0 * y^2 + x + x^2,
                x + 3 * y^2,
                rtol = 1e-2,
                ztol = 1e-2,
            )
            @test isapprox(x + 1 - x, 1 + 1e-8, rtol = 1e-7)
            @test !isapprox(1 + 1e-8, x + 1 - x, rtol = 1e-9)
        end
        @testset "RationalPoly equality" begin
            Mod.@polyvar x y
            @test (x^2 - x - 6) / (x + 2) != x + 3
            @test x - 3 == (x^2 - x - 6) / (x + 2)
            @test (x^2 - x - 6) / (x - 3) == x + 2
            @test 3 != 4x / 2x
            @test 4x / 2x == 2
            @test 3 != 4x / 2x
            @test 1 - 1 / x == (x - 1) / x
            @test 1 - 1 / x != (1 - x) / x
            @test x + x / x == 1 + x^2 / x
            @test x - x / x == -(1 - x^2 / x)
            @test (1 + x) / x - 1 == 1 / x
            @test isapprox((1 + 1e-8)x, (x * y) / y, rtol = 1e-7)
            @test isapproxzero(((1 + 1e-8)x - x) / y, ztol = 1e-7)
            @test !isapproxzero(((1 + 1e-8)x - y) / y, ztol = 1e-9)
            @test isapprox(((1 + 1e-8)x * y) / y^2, x / y, rtol = 1e-7)
            @test isapprox((2x) / x, 2.001, rtol = 1e-2)
            @test !isapprox(2.001, (2x) / x, rtol = 1e-4)
        end
    end
    @testset "Equality between a Polynomial and a type not defining zero #22" begin
        Mod.@polyvar x
        # Polynomial of multiple terms
        p = x + x^2
        @test nothing !== p
        @test p !== nothing
        @test Dict{Int,Int}() != p
        @test p !== Dict{Int,Int}()
        # Polynomial of one term
        p = x + x^2 - x
        @test p !== nothing
        @test p !== Dict{Int,Int}()
        # Polynomial of no term
        # See https://github.com/blegat/MultivariatePolynomials.jl/issues/22
        p = x - x
        @test p !== nothing
        @test p !== Dict{Int,Int}()
    end
    lex = LexOrder
    grlex = Graded{lex}
    rinvlex = Reverse{InverseLexOrder}
    grevlex = Graded{rinvlex}
    @static if Symbol(Mod) == :DynamicPolynomials
        @testset "compare $M" for M in [lex, grlex, rinvlex, grevlex]
            Mod.@polyvar x y z monomial_order = M
            # [CLO13, p. 58]
            sgn = (M == lex || M == rinvlex) ? -1 : 1
            @test sgn * compare(x * y^2 * z^3, x^3 * y^2) > 0
            @test compare(x * y^2 * z^4, x * y * z^5) > 0
            # [CLO13, p. 59]
            @test compare(x^5 * y * z, x^4 * y * z^2) > 0
            # [CLO13] Cox, D., Little, J., & OShea, D.
            # *Ideals, varieties, and algorithms: an introduction to computational algebraic geometry and commutative algebra*.
            # Springer Science & Business Media, **2013**.
        end
    end

    @testset "Comparison with NaN" begin
        Mod.@polyvar x y
        @testset "$poly1 and $poly2" for (poly1, poly2) in [
            (NaN * x, NaN * x),
            (NaN * x + 0, NaN * x + 0),
            (NaN * x, NaN * x + 0),
            (NaN * x / y, NaN * x / y),
            (x / (NaN * y), x / (NaN * y)),
            ((NaN * x) / (NaN * y), (NaN * x) / (NaN * y)),
            ((NaN * x + 0) / (NaN * y + 0), (NaN * x + 0) / (NaN * y + 0)),
        ]
            @test poly1 != poly2
            @test poly1 != poly1
            @test isequal(poly1, poly2)
            @test isequal(poly1, poly1)
            # RationalPoly equality multiplies and thus allocates
            if !(poly1 isa RationalPoly)
                @test (@allocated poly1 != poly2) == 0
                @test (@allocated poly1 != poly1) == 0
                @test (@allocated isequal(poly1, poly2)) == 0
                @test (@allocated isequal(poly1, poly1)) == 0
            end
        end
    end
end

@testset "Norm of polynomial" begin
    Mod.@polyvar x y
    @test norm(x) == norm(x, 2) == 1.0
    @test norm(2x) == norm(2x, 2) == 2.0
    @test norm(2x + 1) == norm(2x + 1, 2) ≈ sqrt(5)
    @test norm(2x * y + x^2 + 3) ≈ norm(2x * y + x^2 + 3, 2) ≈ sqrt(14)
end

struct CustomLaTeXPrint
    s::String
end

Base.:-(s::CustomLaTeXPrint) = s
Base.iszero(::CustomLaTeXPrint) = false
function Base.show(io::IO, ::MIME"text/latex", s::CustomLaTeXPrint)
    return print(io, s.s)
end

@testset "Show" begin
    Mod.@polyvar x y z
    @test sprint(show, (x * y^2 + x + 1 + y)) == "1 + y + x + xy²"
    @test sprint(show, (x + 1 + y) / x^2) == "(1 + y + x) / (x²)"
    @test sprint(show, (x - y - x + y) / (x^2 - x)) == "(0) / (-x + x²)"
    cp = CustomPoly(1 + x)
    @test sprint(show, cp) == "$(typeof(cp))(1 + x)"
    # Test taken from TypedPolynomials
    @test sprint(show, x) == "x"
    @test sprint(show, x^0) == "1"
    @test sprint(show, x^1) == "x"
    @test sprint(show, x^2) == "x²"
    @test sprint(show, 1x^2) == "x²"
    @test sprint(show, 5x) == "5x"
    @test sprint(show, x * y) == "xy"
    @test sprint(show, y * x) == "xy"
    @test sprint(show, 5 + y + x) == "5 + y + x"
    @test sprint(show, y + 5 + x) == "5 + y + x"
    @test sprint(show, x + x^2) == "x + x²"
    @test sprint(show, x^2 + x) == "x + x²"
    @test sprint(show, x^2 - 3.0x) == "-3.0x + x²"
    @test sprint(show, -x^3) == "-x³"
    @test sprint(show, -x^3 + y^2 - x) == "-x + y² - x³"
    @test sprint(show, -2.0x^2) == "-2.0x²"
    @test sprint(show, (1.0 + 3.1im) * x * z) == "(1.0 + 3.1im)xz"
    @test sprint(show, -(1.0 + 3.1im) * z * x) == "(-1.0 - 3.1im)xz"
    @test sprint(show, x^2 + (1.0 + 3.1im) * x) == "(1.0 + 3.1im)x + x²"
    @test sprint(show, x^2 - (1.0 + 3.1im) * x) == "(-1.0 - 3.1im)x + x²"

    @test sprint(show, 1e-8 + 3.2e7 * x + 4.5 * x^2) ==
          "1.0e-8 + 3.2e7x + 4.5x²"
    @test sprint(show, "text/plain", 1e-8 + 3.2e7 * x + 4.5 * x^2) ==
          "1.0e-8 + 3.2e7x + 4.5x²"
    @test sprint(show, "text/latex", 1e-8 + 3.2e7 * x + 4.5 * x^2) ==
          "\$\$ 1.0 \\cdot 10^{-8} + 3.2 \\cdot 10^{7}x + 4.5x^{2} \$\$"

    Mod.@polyvar x[0:9]
    @test sprint(show, sum(i * x[i]^i for i in 1:10)) ==
          "x₀ + 2x₁² + 3x₂³ + 4x₃⁴ + 5x₄⁵ + 6x₅⁶ + 7x₆⁷ + 8x₇⁸ + 9x₈⁹ + 10x₉¹⁰"
    @test sprint(show, "text/latex", sum(i * x[i]^i for i in 1:10)) ==
          "\$\$ x_{0} + 2x_{1}^{2} + 3x_{2}^{3} + 4x_{3}^{4} + 5x_{4}^{5} + 6x_{5}^{6} + 7x_{6}^{7} + 8x_{7}^{8} + 9x_{8}^{9} + 10x_{9}^{10} \$\$"
    @test sprint(show, "text/latex", (x[2] + 1) / x[3]^2) ==
          "\$\$ \\frac{1 + x_{1}}{x_{2}^{2}} \$\$"

    Mod.@polyvar x[1:11]
    @test sprint(show, "text/latex", x[10]) == "\$\$ x_{10} \$\$"
    @test sprint(show, x[10]) == "x₁₀"

    @test sprint(print, 2x[1]^2 + 3x[3] + 1 + x[4]) ==
          "1 + x[4] + 3*x[3] + 2*x[1]^2"

    a = CustomLaTeXPrint(" \$\$ \\[\\(α_β∀ \\) \\]\t  \$\$")
    @test sprint((io, x) -> show(io, "text/latex", x), term(a, x[1]^2)) ==
          "\$\$ (α_β∀)x_{1}^{2} \$\$"
    @test sprint(
        (io, x) -> show(io, "text/latex", x),
        polynomial([a, a], [x[1]^2, x[2]]),
    ) == "\$\$ (α_β∀)x_{2} + (α_β∀)x_{1}^{2} \$\$"
    # Test that the check for `\\)` handles unicode well
    a = CustomLaTeXPrint("\\(β∀")
    @test sprint((io, x) -> show(io, "text/latex", x), term(a, x[1]^2)) ==
          "\$\$ (\\(β∀)x_{1}^{2} \$\$"
end

using MultivariatePolynomials
using DynamicPolynomials
#using TypedPolynomials
using BenchmarkTools

#   let
#       using MultiPoly
#       x, y = generators(MPoly{Float64}, :x, :y)
#       p = x + y + 2x^2 + y^3
#
#       println(@benchmark(evaluate($p, 1.0, 2.0)))
#   end

let
    @polyvar x y
    p = x + y + 2x^2 + y^3

    varst = (x, y)
    varsv = [x, y]
    valst = (1.0, 2.0)
    valsv = [1.0, 2.0]

    display(@benchmark(($p)(variables($p) => $valst)))
    display(@benchmark(($p)(variables($p) => $valsv)))
    display(@benchmark(($p)($varst => $valst)))
    display(@benchmark(($p)($varsv => $valsv)))

#    vars_out_of_order = [vars[2], vars[1]]
#    println(@benchmark(($p)($vals, $vars_out_of_order)))
end

module TestAllocations
include("utils.jl")

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$name", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
end

using MutableArithmetics
import MultivariatePolynomials
const MP = MultivariatePolynomials
using TypedPolynomials

function test_polynomial_merge()
    @polyvar x
    p = x^2 + x + 1
    # Want to avoid it converting everything to polynomial
    Q = AbstractPolynomialLike[x, x^2, 2x, 2x+3]
    for q in Q
        alloc_test(0) do
            return add!!(p, q)
        end
        alloc_test(0) do
            return sub!!(p, q)
        end
        for r in Q
            if q isa AbstractPolynomial && r isa AbstractPolynomial
                continue
            end
            alloc_test(0) do
                return add_mul!!(p, q, r)
            end
            alloc_test(0) do
                return sub_mul!!(p, q, r)
            end
        end
    end
end

function __test_leading(p)
    alloc_test(0) do
        return leading_term(p)
    end
    alloc_test(0) do
        return leading_coefficient(p)
    end
    alloc_test(0) do
        return leading_monomial(p)
    end
end
function _test_leading(T)
    @polyvar x y
    __test_leading(T(4) * x^2 * y + x * y + 2x)
    return __test_leading(T(4) * x^2 * y)
end

function test_leading()
    _test_leading(Int)
    return _test_leading(BigInt)
end

function test_promotion()
    @polyvar x y
    p = x * y + x + y + 1
    alloc_test(0) do
        return promote_operation(
            MP.substitute,
            MP.Subs,
            typeof(p),
            Pair{typeof(x),Int},
        )
    end
end

function test_isapproxzero()
    @polyvar x y
    p = x * y + x + y + 1
    alloc_test(0) do
        return isapproxzero(p)
    end
    q = 1e-10 * x * y + 1e-12 * x
    alloc_test(0) do
        return isapproxzero(q)
    end
    alloc_test(0) do
        return isapproxzero(q; ztol = 1e-8)
    end
    alloc_test(0) do
        return iszero(q)
    end
    alloc_test(0) do
        return isone(q)
    end
end

function _test_term_gcd(T)
    o = one(T)
    @polyvar x y
    t1 = o * x * y
    t2 = o * x
    alloc_test(0) do
        return gcd(t1, t2)
    end
end

function test_term_gcd()
    return _test_term_gcd(Int)
end

function _pseudo_rem_test(p1, p2, algo)
    backup_1 = deepcopy(p1)
    MA_copy_1 = mutable_copy(p1)
    backup_2 = deepcopy(p2)
    MA_copy_2 = mutable_copy(p2)
    buffer =
        buffer_for(MP.rem_or_pseudo_rem, typeof(p1), typeof(p2), typeof(algo))
    mutable_alloc_test(p1, 0) do p1
        return buffered_operate!!(buffer, MP.rem_or_pseudo_rem, p1, p2, algo)
    end
    @test backup_1 == MA_copy_1
    @test backup_2 == MA_copy_2
    @test backup_2 == p2
    return MA_copy_1, p2
end

function _test_div(T)
    o = one(T)
    @polyvar x y
    p1 = 1o * x^2 + 3o * x + 1o
    p2 = 1o * x + 1o
    @testset "primitive_rem=$primitive_rem" for primitive_rem in [false, true]
        @testset "skip_last=$skip_last" for skip_last in [false, true]
            algo = GeneralizedEuclideanAlgorithm(primitive_rem, skip_last)
            p1, p2 = _pseudo_rem_test(p1, p2, algo)
        end
    end
end

function test_div()
    @testset "$T" for T in [Int] # FIXME , BigInt] # TODO add Rational{BigInt} when https://github.com/jump-dev/MutableArithmetics.jl/issues/187 is fixed
        _test_div(T)
    end
end

function _test_univ_gcd(T, algo)
    o = one(T)
    @polyvar x
    p1 = o * x^2 + 2o * x + o
    p2 = o * x + o
    mutable_alloc_test(mutable_copy(p1), 0) do p1
        return MP.univariate_gcd(p1, p2, algo, IsMutable(), IsMutable())
    end
end

function test_univ_gcd()
    algo = GeneralizedEuclideanAlgorithm()
    return _test_univ_gcd(Int, algo)
    #_test_univ_gcd(BigInt, algo) # TODO
end

end

TestAllocations.runtests()

const MP = MultivariatePolynomials

function effective_variables_test()
    Mod.@polyvar x
    Mod.@polyvar y[1:7]
    T = variable_union_type(x)
    @test x isa T
    @test y[2] isa T
    @test T[x, y[2]] == @inferred effective_variables(x * y[2])
    @test T[x, y[2]] == @inferred effective_variables(y[2] * x)
    @test T[x] == @inferred effective_variables(x * y[2]^0)
    @test T[x] == @inferred effective_variables(y[2]^0 * x)
    @test T[y[2]] == @inferred effective_variables(x^0 * y[2])
    @test T[y[2]] == @inferred effective_variables(y[2] * x^0)
    @test T[x, y[2]] == @inferred effective_variables(y[3]^0 * x * y[2])
    @test T[x, y[2]] == @inferred effective_variables(y[2] * y[3]^0 * x)
    @test T[x, y[2]] == @inferred effective_variables(y[2] * x * y[3]^0)
end

function map_exponents_test()
    Mod.@polyvar x y
    a = x^2
    b = x * y
    c = MP.map_exponents!(+, a, b)
    @test variables(c) == variables(b)
    a = x^3
    d = MP.map_exponents_to!(a, -, b, b)
    @test variables(d) == variables(b)
end

@testset "Monomial" begin
    Mod.@polyvar x

    @test zero(x^2) == 0
    @test zero(x^2) isa AbstractPolynomial{Int}
    @inferred zero(x^2)
    @test (@inferred one(x^2)) == 1
    @test one(x^2) isa AbstractMonomial
    @test (@inferred one(typeof(x^2))) == 1
    @test one(typeof(x^2)) isa AbstractMonomial
    # @test ordering(x) === GradedLex #FIXME add it back once it's implemented

    Mod.@polyvar y[1:7]
    mono = y[1] * y[3] * y[5] * y[7]
    alloc_test(() -> convert(typeof(mono), mono), 0)
    @test issorted(variables(y[2] * mono), rev = true)
    @test issorted(variables(mono * y[4]), rev = true)
    @test issorted(variables(y[6] * mono), rev = true)

    @test nvariables(monomial_vector([x^2, prod(y[2:4])])) == 4

    @test nterms(x^2) == 1
    @test @inferred(terms(x^2)) == [x^2]

    @test degree(x * y[2]^2, x) == 1
    @test degree(x * y[2]^2, y[1]) == 0
    @test degree(x * y[2]^2, y[2]) == 2

    @test_throws InexactError variable(x^2)
    @test_throws InexactError variable(x * y[1])
    @test_throws InexactError variable(constant_monomial(typeof(x)))

    @test x != constant_monomial(typeof(x))
    @test constant_monomial(typeof(x)) != x

    m = x^2
    @test x != m
    @test m != x
    typetests(m)
    typetests([x^2, x^3])
    @test (@inferred polynomial(m)) isa AbstractPolynomial{Int}
    @test (@inferred polynomial(m, Float64)) isa AbstractPolynomial{Float64}

    @test variable(x^1) == x
    @test variable(x^1) isa AbstractVariable
    @test variable(x^2 + x - x^2) == x
    @test variable(x^2 + x - x^2) isa AbstractVariable
    @test variable(1.0x) == x
    @test variable(1.0x) isa AbstractVariable
    @test_throws InexactError variable(x + 2x) == x

    @test monic(x^2) == x^2

    @test MP.div_multiple(2x^2 * y[1]^3, x * y[1]^2) == 2x * y[1]

    @test transpose(x) == x
    @test adjoint(x) == x
    @test transpose(x^2) == x^2
    @test adjoint(x^2) == x^2

    @testset "Effective variables" begin
        effective_variables_test()
    end
    @testset "map_exponents" begin
        map_exponents_test()
    end
end

"""
    monomial_type(p::AbstractPolynomialLike)

Return the type of the monomials of `p`.

    monomial_type(::Type{PT}) where PT<:AbstractPolynomialLike

Returns the type of the monomials of a polynomial of type `PT`.
"""
monomial_type(::Union{M,Type{M}}) where {M<:AbstractMonomial} = M
function monomial_type(::Union{PT,Type{PT}}) where {PT<:_APL}
    return monomial_type(term_type(PT))
end
function monomial_type(
    ::Union{AbstractVector{PT},Type{<:AbstractVector{PT}}},
) where {PT<:_APL}
    return monomial_type(PT)
end

"""
    variables(p::AbstractPolynomialLike)

Returns the tuple of the variables of `p` in decreasing order. It could contain variables of zero degree, see the example section.

### Examples

Calling `variables(x^2*y)` should return `(x, y)` and calling `variables(x)` should return `(x,)`.
Note that the variables of `m` does not necessarily have nonzero degree.
For instance, `variables([x^2*y, y*z][1])` is usually `(x, y, z)` since the two monomials have been promoted to a common type.
"""
function variables end
variables(t::AbstractTerm) = variables(monomial(t))
function variables(
    ::Type{PT},
) where {PT<:Union{AbstractPolynomial,AbstractTerm}}
    return variables(monomial_type(PT))
end

"""
    nvariables(p::AbstractPolynomialLike)

Returns the number of variables in `p`, i.e. `length(variables(p))`. It could be more than the number of variables with nonzero degree (see the Examples section of [`variables`](@ref)).

### Examples

Calling `nvariables(x^2*y)` should return at least 2 and calling `nvariables(x)` should return at least 1.
"""
nvariables(::Union{AbstractVariable,Type{<:AbstractVariable}}) = 1
nvariables(t::AbstractTerm) = nvariables(monomial(t))
nvariables(::Type{TT}) where {TT<:AbstractTerm} = variables(monomial_type(TT))
nvariables(p::_APL) = length(variables(p))

"""
    exponents(t::AbstractTermLike)

Returns the exponent of the variables in the monomial of the term `t`.

### Examples

Calling `exponents(x^2*y)` should return `(2, 1)`.
"""
exponents(t::AbstractTerm) = exponents(monomial(t))
exponents(::AbstractVariable) = (1,)

"""
    degree(t::AbstractTermLike)

Returns the *total degree* of the monomial of the term `t`, i.e. `sum(exponents(t))`.

    degree(t::AbstractTermLike, v::AbstractVariable)

Returns the exponent of the variable `v` in the monomial of the term `t`.

### Examples

Calling `degree(x^2*y)` should return 3 which is ``2 + 1``.
Calling `degree(x^2*y, x)` should return 2 and calling `degree(x^2*y, y)` should return 1.

"""
degree(t::AbstractTermLike) = sum(exponents(t); init = 0)

degree(t::AbstractTermLike, var::AbstractVariable) = degree(monomial(t), var)
degree(v::AbstractVariable, var::AbstractVariable) = (v == var ? 1 : 0)
#_deg(v::AbstractVariable) = 0
#_deg(v::AbstractVariable, power, powers...) = v == power[1] ? power[2] : _deg(v, powers...)
#degree(m::AbstractMonomial, v::AbstractVariable) = _deg(v, powers(t)...)

function degree(m::AbstractMonomial, v::AbstractVariable)
    deg = 0
    # With Noncommutative variables, there may be several powers with the same variable
    for (var, exp) in powers(m)
        if var == v
            deg += exp
        end
    end
    return deg
end

"""
    isconstant(t::AbstractTermLike)

Returns whether the monomial of `t` is constant.
"""
isconstant(t::AbstractTerm) = isconstant(monomial(t))
isconstant(t::AbstractMonomialLike) = all(iszero, exponents(t))
isconstant(v::AbstractVariable) = false

"""
    powers(t::AbstractTermLike)

Returns an iterator over the powers of the monomial of `t`.

### Examples

Calling `powers(3x^4*y)` should return `((x, 4), (y, 1))`.
"""
powers(t::AbstractTermLike) = _zip(variables(t), exponents(t))

"""
    constant_monomial(p::AbstractPolynomialLike)

Returns a constant monomial of the monomial type of `p` with the same variables as `p`.

    constant_monomial(::Type{PT}) where {PT<:AbstractPolynomialLike}

Returns a constant monomial of the monomial type of a polynomial of type `PT`.
"""
function constant_monomial end
function constant_monomial(::Type{MT}) where {MT<:AbstractMonomial}
    return error("`constant_monomial` not implemented for $MT.")
end
function constant_monomial(::Type{PT}) where {PT<:_APL}
    return constant_monomial(monomial_type(PT))
end
constant_monomial(t::AbstractTerm) = constant_monomial(monomial(t))

"""
    map_exponents(f, m1::AbstractMonomialLike, m2::AbstractMonomialLike)

If ``m_1 = \\prod x^{\\alpha_i}`` and ``m_2 = \\prod x^{\\beta_i}`` then it returns the monomial ``m = \\prod x^{f(\\alpha_i, \\beta_i)}``.

### Examples

The multiplication `m1 * m2` is equivalent to `map_exponents(+, m1, m2)`, the unsafe division `div_multiple(m1, m2)` is equivalent to `map_exponents(-, m1, m2)`, `gcd(m1, m2)` is equivalent to `map_exponents(min, m1, m2)`, `lcm(m1, m2)` is equivalent to `map_exponents(max, m1, m2)`.
"""
function map_exponents(f, m1::AbstractMonomialLike, m2::AbstractMonomialLike)
    return map_exponents(f, monomial(m1), monomial(m2))
end

function map_exponents_to! end
function map_exponents! end

map_exponents(f, a, b, ::MA.IsMutable) = map_exponents!(f, a, b)
map_exponents(f, a, b, ::MA.IsNotMutable) = map_exponents(f, a, b)

Base.one(::Type{TT}) where {TT<:AbstractMonomialLike} = constant_monomial(TT)
Base.one(t::AbstractMonomialLike) = constant_monomial(t)
function MA.promote_operation(::typeof(one), MT::Type{<:AbstractMonomialLike})
    return monomial_type(MT)
end
# See https://github.com/JuliaAlgebra/MultivariatePolynomials.jl/issues/82
# By default, Base do oneunit(v::VT) = VT(one(v)).
# This tries to convert a monomial to a variable which does not work.
# The issue here is there is no way to represent the multiplicative identity
# using the variable type. The best we can do is return a monomial even
# if it does not exactly match the definition of oneunit.
Base.oneunit(v::AbstractVariable) = one(v)
Base.oneunit(VT::Type{<:AbstractVariable}) = one(VT)

import MutableArithmetics as MA
import MultivariatePolynomials as MP

struct CoefNotComparable end
Base.iszero(::CoefNotComparable) = false

struct Term2{T,M} <: MP.AbstractTermLike{T}
    monomial::M
end
MP.coefficient(t::Term2{T}) where {T} = 2one(T)
MP.monomial(t) = t.monomial
MP.term_type(::Type{Term2{T,M}}) where {T,M} = MP.Term{T,M}

@testset "Term" begin
    Mod.@polyvar x
    @test convert(Any, 1x) == 1x
    @test one(1x) == one(1.0x) == 1
    @test zero(1x) == zero(1.0x) == 0
    @test nvariables(0.0x) == 1
    @test nvariables(1x) == 1
    #@inferred one(1x)
    @inferred zero(1x)
    #@inferred one(1.0x)
    @inferred zero(1.0x)

    @test !isapproxzero((1 + 1e-10im) * x^2)
    @test isapproxzero(1e-10im * x^2)

    @test monic(2.0x) isa AbstractTerm{Float64}
    @test monic(2.0x) == x
    @test monic(2x^2) isa AbstractTerm{Int}
    @test monic(2x^2) == x^2

    @test leading_term(2x^2) == 2x^2
    @test nterms(2x^2) == 1
    @test terms(2x^2) == [2x^2]
    @test nterms(0 * x) == 0
    @test terms(0 * x) == typeof(0 * x)[]
    @test nterms(0.0x) == 0
    @test terms(0.0x) == typeof(0.0x)[]

    @test nterms(polynomial(0.0x)) == 0
    @test nterms(convert(polynomial_type(0.0x), 0.0x)) == 0

    @test term(x) isa AbstractTerm
    @test term(x^2) == x^2
    @test term(1x^2) isa AbstractTerm
    @test term(1x) == x
    @test zero_term(1x) == 0 * x

    Mod.@polyvar y
    @test degree(2x^2, x) == 2
    @test degree(2x^2, y) == 0
    @test degree(2x^2, y) == 0

    t = 3x^2 * y^4
    alloc_test(() -> convert(typeof(t), t), 0)
    typetests(t)
    typetests([t, 2x])
    @test (@inferred polynomial(t)) isa AbstractPolynomial{Int}
    @test (@inferred polynomial(t, Float64)) isa AbstractPolynomial{Float64}

    @test_throws InexactError push!([1], 2x)
    @test_throws InexactError push!([x^2], 2x)

    t = MP.term(1, x)
    @test convert(MP.Term{Number,MP.monomial_type(t)}, t) isa
          MP.Term{Number,MP.monomial_type(t)}

    @testset "Effective variables" begin
        T = variable_union_type(x)
        @test x isa T
        @test y isa T
        @test T[x, y] == @inferred effective_variables(x * y)
        @test T[x, y] == @inferred effective_variables(y * x)
        @test T[x] == @inferred effective_variables(x * y^0)
        @test T[x] == @inferred effective_variables(y^0 * x)
        @test T[y] == @inferred effective_variables(x^0 * y)
        @test T[y] == @inferred effective_variables(y * x^0)
    end

    @testset "Compare terms" begin
        t1 = 1 * x
        t2 = 2 * x
        @test t1 < t2
        @test t1 <= t2
        @test !(t1 > t2)
        @test !(t1 >= t2)

        t1 = (1 + 1im) * x
        t2 = (2 + 2im) * x
        @test t1 < t2
        @test t1 <= t2
        @test !(t1 > t2)
        @test !(t1 >= t2)

        a = CoefNotComparable()
        b = CoefNotComparable()
        t1 = a * x
        t2 = b * y
        @test t1 > t2
        @test t1 >= t2
        @test !(t1 < t2)
        @test !(t1 <= t2)
        t1 = a * x
        t2 = b * x
        @test !(t1 > t2)
        @test t1 >= t2
        @test !(t1 < t2)
        @test t1 <= t2
    end

    @testset "MA $T" for T in [Int, BigInt]
        M = typeof(x^2)
        t = one(T) * x
        s = MA.operate!!(*, t, x)
        @test monomial(s) == x^2
        if T == BigInt && MA.mutability(M) isa MA.IsMutable
            @test monomial(t) == x^2
        end
        u = MA.operate!!(*, s, Term2{T,M}(x^3))
        @test monomial(u) == x^5
        @test coefficient(u) == 2
        if T == BigInt && MA.mutability(M) isa MA.IsMutable
            @test monomial(t) == x^5
            @test coefficient(t) == 2
        end
    end
end

# Copied from TypedPolynomials
module Sequences

import MutableArithmetics
const MA = MutableArithmetics

function merge_sorted!(
    result,
    v1::AbstractArray,
    v2::AbstractArray,
    compare,
    combine,
    filter = x -> !iszero(x),
)
    i = firstindex(result)
    i1 = firstindex(v1)
    i2 = firstindex(v2)
    while i1 <= lastindex(v1) && i2 <= lastindex(v2)
        x1 = v1[i1]
        x2 = v2[i2]
        Δ = compare(x1, x2)
        if Δ < 0
            if filter(x1)
                result[i] = x1
                i += 1
            end
            i1 += 1
        elseif Δ > 0
            if filter(x2)
                result[i] = x2
                i += 1
            end
            i2 += 1
        else
            c = combine(x1, x2)
            if filter(c)
                result[i] = combine(x1, x2)
                i += 1
            end
            i1 += 1
            i2 += 1
        end
    end
    for j in i1:lastindex(v1)
        if filter(v1[j])
            result[i] = v1[j]
            i += 1
        end
    end
    for j in i2:lastindex(v2)
        if filter(v2[j])
            result[i] = v2[j]
            i += 1
        end
    end
    resize!(result, i - 1)
    return result
end

function merge_sorted(
    v1::AbstractArray,
    v2::AbstractArray,
    compare,
    combine = Base.:+,
    filter = x -> !iszero(x),
)
    T = MA.promote_operation(combine, eltype(v1), eltype(v2))
    result = Vector{T}(undef, length(v1) + length(v2))
    return merge_sorted!(result, v1, v2, compare, combine, filter)
end

end

using Test
using MultivariatePolynomials

# Allocating size for allocating a `BigInt`.
# Half size on 32-bit.
const BIGINT_ALLOC = Sys.WORD_SIZE == 64 ? 48 : 24

function mutable_alloc_test(f, x, n)
    y = MultivariatePolynomials.MA.mutable_copy(x)
    f(y) # compile
    @test n == @allocated f(x)
end

function alloc_test(f, n)
    f() # compile
    @test n == @allocated f()
end

struct CustomPoly{T,P<:AbstractPolynomial{T}} <: AbstractPolynomialLike{T}
    p::P
end
function MultivariatePolynomials.term_type(::Type{CustomPoly{T,P}}) where {T,P}
    return MultivariatePolynomials.term_type(P)
end
MultivariatePolynomials.polynomial(p::CustomPoly) = p.p
MultivariatePolynomials.polynomial(p::CustomPoly, T::Type) = polynomial(p.p, T)
MultivariatePolynomials.variables(p::CustomPoly) = variables(p.p)
function MultivariatePolynomials.monomial_type(
    ::Type{<:CustomPoly{T,P}},
) where {T,P}
    return monomial_type(P)
end
function MultivariatePolynomials.constant_monomial(p::CustomPoly)
    return constant_monomial(p.p)
end
Base.copy(p::CustomPoly) = CustomPoly(copy(p.p))

struct CustomTerms{T,P<:AbstractPolynomial{T}} <: AbstractPolynomialLike{T}
    p::P
end
function MultivariatePolynomials.term_type(::Type{CustomTerms{T,P}}) where {T,P}
    return MultivariatePolynomials.term_type(P)
end
MultivariatePolynomials.terms(p::CustomTerms) = terms(p.p)
MultivariatePolynomials.variables(p::CustomTerms) = variables(p.p)
function MultivariatePolynomials.monomial_type(
    ::Type{<:CustomTerms{T,P}},
) where {T,P}
    return monomial_type(P)
end
Base.copy(p::CustomTerms) = CustomTerms(copy(p.p))

function _typetests(x, ::Type{T}) where {T}
    @test (@inferred coefficient_type(x)) == Int

    @test (@inferred monomial_type(x)) <: AbstractMonomial

    @test (@inferred term_type(x)) <: AbstractTerm{Int}
    @test (@inferred term_type(x, Float64)) <: AbstractTerm{Float64}

    @test (@inferred polynomial_type(x)) <: AbstractPolynomial{Int}
    @test (@inferred polynomial_type(x, Float64)) <: AbstractPolynomial{Float64}

    @test (@inferred monomial_vector_type(x)) <:
          AbstractArray{<:AbstractMonomial}
end

function typetests(
    x::Union{AbstractPolynomialLike{T},Vector{<:AbstractPolynomialLike{T}}},
) where {T}
    _typetests(x, T)
    return _typetests(typeof(x), T)
end

function print_row(s1, s2, s3, s4, c)
    print("|", c)
    print(lpad(s1, 18, c))
    print(c, "|", c)
    print(lpad(s2, 10, c))
    print(c, "|", c)
    print(lpad(s3, 10, c))
    print(c, "|", c)
    print(lpad(s4, 10, c))
    println(c, "|")
end
function prettyprint(name, ::Nothing)
    print_row(
        name,
        "",
        "",
        "",
        ' ',
    )
end
function prettyprint(name, b::BenchmarkTools.Trial)
    print_row(
        name,
        BenchmarkTools.prettytime(time(b)),
        allocs(b),
        BenchmarkTools.prettymemory(memory(b)),
        ' ',
    )
end

function prettyprint(bs, bd, bt)
    print_row("", "Time", "Alloc", "Memory", ' ')
    print_row("", "", "", "", '-')
    prettyprint("SIMDPolynomials", bs)
    prettyprint("DynamicPolynomials", bd)
    prettyprint("TypedPolynomials", bt)
end

using Test
import MutableArithmetics as MA
using MultivariatePolynomials
import MultivariatePolynomials as MP
using LinearAlgebra

@testset "Promotion" begin
    Mod.@polyvar x y
    @inferred x * y + x
    @test [x, x * y + x, x] isa Vector{<:AbstractPolynomial{Int}}
    @test eltype([1, x / y, x]) <:
          RationalPoly{<:AbstractTerm{Int},<:AbstractTerm{Int}}
    @test [(x^2-2x+2) x; x x^2] isa Matrix{<:AbstractPolynomial{Int}}
    @test [2.0x, 3x] isa Vector{<:AbstractTerm{Float64}}
    @inferred Any[x*y, x+y]
    @test Any[x*y, x+y] isa Vector{Any}
    @test [x * y, x + y] isa Vector{<:AbstractPolynomial{Int}}
    @test [2x * y, x + y] isa Vector{<:AbstractPolynomial{Int}}
    @test eltype([2.0x, x / y]) <:
          RationalPoly{<:AbstractTerm{Float64},<:AbstractTerm{Int}}
    @test eltype([2.0x, x / y, 1y]) <:
          RationalPoly{<:AbstractTerm{Float64},<:AbstractTerm{Int}}
    @test eltype([2x + y, x / 2.0y, x + 1y]) <:
          RationalPoly{<:AbstractPolynomial{Int},<:AbstractTerm{Float64}}
    @test eltype([-1 / x^2, 1]) <:
          RationalPoly{<:AbstractTerm{Int},<:AbstractTerm{Int}}

    X = [x, y]
    Y = [1 2; 3 4] * X
    @test Y[1] == x + 2y
    @test Y[2] == 3x + 4y
    Y = X' * [1 2; 3 4]
    @test Y[1] == x + 3y
    @test Y[2] == 2x + 4y
    @test dot(X, [1 2; 3 4] * X) == x^2 + 5x * y + 4y^2

    function _t(a, b, T)
        if VERSION < v"1.6"
            @test typeof(@inferred vcat(a, b)) in [Vector{T}, Vector{Any}]
            @test typeof(@inferred vcat(b, a)) in [Vector{T}, Vector{Any}]
        else
            @test typeof(@inferred vcat(a, b)) == Vector{T}
            @test typeof(@inferred vcat(b, a)) == Vector{T}
        end
    end

    function __test(a, PT, TT, MT)
        @test typeof(a) == Vector{MT(Int)}
        _t(a, 1, Any)
        _t(a, x, MT(Int))
        _t(a, x^2, MT(Int))
        _t(a, 1x, TT(Int))
        _t(a, 1.0x, TT())
        _t(a, x + y, PT(Int))
        return _t(a, 1.0x + y, PT())
    end

    function _test(a, af, TT)
        __test(a, apl, TT, TT)
        # `x isa _APL{Int}` so here we don't have `Float64`:
        pt() = apl()
        pt(T) = apl()
        tt() = TT()
        tt(T) = TT()
        __test(af, pt, tt, tt)
        @test typeof(af) == Vector{TT()}
        return _t(af, a, TT())
    end

    apl() = MP._APL
    apl(T::Type) = MP._APL{T}
    p = [i == 1 ? x + y : x for i in 1:2]
    pf = [i == 1 ? 1.0x + y : x for i in 1:2]
    _test(p, pf, apl)

    atl() = MP.AbstractTermLike
    atl(T::Type) = MP.AbstractTermLike{T}
    t = [i == 1 ? 2x : x for i in 1:2]
    tf = [i == 1 ? 2.0x : x for i in 1:2]
    _test(t, tf, atl)
    _t(p, t, apl(Int))
    _t(pf, t, apl())
    _t(p, tf, apl())
    _t(pf, tf, apl())

    __pt = Base.promote_typejoin(typeof(x + 2), typeof(x + 2.0))
    _pt() = __pt
    _pt(::Type) = __pt
    __test([i == 1 ? x + 2 : x + 2.0 for i in 1:2], _pt, _pt, _pt)

    __tt = Base.promote_typejoin(typeof(2x), typeof(2.0x))
    _tt() = __tt
    _tt(::Type) = __tt
    __test([i == 1 ? 2x : 2.0x for i in 1:2], _pt, _tt, _tt)

    aml(args...) = MP.AbstractMonomialLike
    a = [i == 1 ? x^2 : x for i in 1:2]
    __test(a, apl, atl, aml)
    _t(a, t, atl(Int))
    _t(a, tf, atl())
    _t(a, p, apl(Int))
    _t(a, pf, apl())
end

struct A end
Base.zero(::Type{A}) = A()
Base.:*(::A, ::A) = B()
struct B end
Base.zero(::Type{B}) = B()
Base.:+(::B, ::B) = C()
struct C end
Base.:+(::B, ::C) = C()
Base.:+(::C, ::B) = C()
Base.:+(::C, ::C) = C()
@testset "promote_operation with tricky types" begin
    Mod.@polyvar x
    @test MA.promote_operation(
        *,
        polynomial_type(x, A),
        polynomial_type(x, A),
    ) == polynomial_type(x, C)
    @test MA.promote_operation(*, polynomial_type(x, A), A) ==
          polynomial_type(x, B)
    @test MA.promote_operation(*, A, polynomial_type(x, A)) ==
          polynomial_type(x, B)
end

function __promote_prod(::Type{A}, ::Type{B}, ::Type{C}) where {A,B,C}
    @test MA.promote_operation(*, A, B) == C
    @test MA.promote_operation(*, B, A) == C
end

@testset "promote_operation with Rational" begin
    Mod.@polyvar x
    V = typeof(x)
    M = monomial_type(V)
    T = term_type(V, Int)
    P = polynomial_type(V, Float64)
    function _promote_prod(::Type{A}, ::Type{B}, ::Type{C}) where {A,B,C}
        __promote_prod(A, B, C)
        __promote_prod(RationalPoly{A,B}, RationalPoly{B,A}, RationalPoly{C,C})
        __promote_prod(RationalPoly{A,A}, RationalPoly{B,B}, RationalPoly{C,C})
        for U in [V, M, T, P]
            __promote_prod(A, RationalPoly{B,U}, RationalPoly{C,U})
        end
    end
    _promote_prod(V, V, M)
    for U in [V, M]
        _promote_prod(U, M, M)
    end
    for U in [V, M, T]
        _promote_prod(U, T, T)
    end
    for U in [V, M, T, P]
        _promote_prod(U, P, P)
    end
end

@testset "promote_operation with polynomial coefficient" begin
    Mod.@polyvar x
    Mod.@polyvar y
    X = typeof(x)
    MX = monomial_type(X)
    TX = term_type(X, Int)
    PX = polynomial_type(X, Int)
    Y = typeof(y)
    TXY = term_type(Y, PX)
    PXY = polynomial_type(Y, PX)
    TY = term_type(Y, Int)
    PY = polynomial_type(Y, Int)
    for T in [X, MX, TX, PX]
        __promote_prod(TY, TY, TY)
        __promote_prod(TXY, TY, TXY)
        __promote_prod(TXY, TXY, TXY)
        __promote_prod(PY, PY, PY)
        __promote_prod(PXY, PY, PXY)
        __promote_prod(PXY, PXY, PXY)
    end
end

import StarAlgebras as SA

@testset "ExponentMap" begin
    # Vector exponent map
    map_v = MP.ExponentMap([2, 3], 4)
    @test map_v([5, 7]) == [0, 5, 7, 0]

    # Tuple exponent map
    map_t = MP.ExponentMap((2, 3), Val(4))
    @test map_t((5, 7)) == (0, 5, 7, 0)

    # Identity-like map (all slots filled)
    map_id = MP.ExponentMap([1, 2], 2)
    @test map_id([3, 4]) == [3, 4]
end

@testset "promote_variables_with_maps" begin
    # Same variables: no maps needed
    Mod.@polyvar a b
    vars_ab = MP.variables(a + b)
    (va, ma), (vb, mb) = MP.promote_variables_with_maps(vars_ab, vars_ab)
    @test va == vars_ab
    @test vb == vars_ab
    @test ma === nothing
    @test mb === nothing

    # Different variables from separate @polyvar calls: maps should be created
    Mod.@polyvar x
    Mod.@polyvar y
    vars_x = MP.variables(x^2)
    vars_y = MP.variables(y^2)
    @test vars_x != vars_y
    (vx, mx), (vy, my) = MP.promote_variables_with_maps(vars_x, vars_y)
    @test length(vx) == 2
    @test vx == vy  # both should be the same merged variable set
    @test mx isa MP.ExponentMap
    @test my isa MP.ExponentMap

    exp_x = MP.exponents(x^3)
    new_exp_x = mx(exp_x)
    @test sum(new_exp_x) == sum(exp_x)
    @test length(new_exp_x) == length(vx)

    exp_y = MP.exponents(y^2)
    new_exp_y = my(exp_y)
    @test sum(new_exp_y) == sum(exp_y)
    @test length(new_exp_y) == length(vy)

    # The expanded exponents should not overlap (different slots)
    @test all(new_exp_x .* new_exp_y .== 0)
end

@testset "promote_bases_with_maps" begin
    # Same variables: no promotion needed (maybe_promote is a no-op)
    Mod.@polyvar a b
    p = a^2 + a
    q = a^2 + 2a
    (pp, mp), (qq, mq) = SA.promote_bases_with_maps(p, q)
    @test pp === p
    @test qq === q
    @test mp === nothing
    @test mq === nothing

    # Same variables via promote_bases
    pp2, qq2 = SA.promote_bases(p, q)
    @test pp2 === p
    @test qq2 === q
end

@testset "promote_bases end-to-end" begin
    # Monomials with different variables
    Mod.@polyvar x
    Mod.@polyvar y
    px, py = SA.promote_bases(x^2, y^2)
    @test MP.variables(px) == MP.variables(py)
    @test length(MP.variables(px)) == 2
    @test MP.degree(px) == 2
    @test MP.degree(py) == 2
    # The original exponent structure is preserved
    @test MP.degree(px, x) == 2
    @test MP.degree(px, y) == 0
    @test MP.degree(py, x) == 0
    @test MP.degree(py, y) == 2

    # Variables with different variables
    px2, py2 = SA.promote_bases(x, y^3)
    @test MP.variables(px2) == MP.variables(py2)
    @test length(MP.variables(px2)) == 2
    @test MP.degree(px2) == 1
    @test MP.degree(py2) == 3

    # promote_bases_with_maps returns maps for different variables
    (rx, mx), (ry, my) = SA.promote_bases_with_maps(x^2, y^2)
    @test MP.variables(rx) == MP.variables(ry)
    @test mx isa MP.ExponentMap
    @test my isa MP.ExponentMap

    # Term with Monomial
    t = 3x^2
    m = y^2
    pt, pm = SA.promote_bases(t, m)
    @test MP.variables(pt) == MP.variables(pm)
    @test length(MP.variables(pt)) == 2
    @test MP.coefficient(pt) == 3
    @test MP.degree(pt) == 2
    @test MP.degree(pt, x) == 2
    @test MP.degree(pt, y) == 0
    @test MP.degree(pm, x) == 0
    @test MP.degree(pm, y) == 2

    # Term with Term
    t1 = 2x^2
    t2 = 5y^3
    pt1, pt2 = SA.promote_bases(t1, t2)
    @test MP.variables(pt1) == MP.variables(pt2)
    @test MP.coefficient(pt1) == 2
    @test MP.coefficient(pt2) == 5
    @test MP.degree(pt1, x) == 2
    @test MP.degree(pt1, y) == 0
    @test MP.degree(pt2, x) == 0
    @test MP.degree(pt2, y) == 3

    # Term with same variables (no promotion needed)
    t3 = 4x^2
    t4 = 7x^3
    pt3, pt4 = SA.promote_bases(t3, t4)
    @test MP.coefficient(pt3) == 4
    @test MP.coefficient(pt4) == 7

    # Polynomial with Monomial
    p = 2x^2 + 3x
    m = y^2
    pp, pm = SA.promote_bases(p, m)
    @test MP.variables(pp) == MP.variables(pm)
    @test length(MP.variables(pp)) == 2
    @test MP.degree(pm, y) == 2
    @test MP.degree(pm, x) == 0

    # Polynomial with Polynomial (different variables)
    p1 = x^2 + 2x
    p2 = y^3 + 3y
    pp1, pp2 = SA.promote_bases(p1, p2)
    @test MP.variables(pp1) == MP.variables(pp2)
    @test length(MP.variables(pp1)) == 2
end

using Test
using LinearAlgebra

using MultivariatePolynomials
const MP = MultivariatePolynomials

# Tests that do not need any specific polynomial implementation
include("comparison.jl")

include("utils.jl")

# Taken from JuMP/test/solvers.jl
function try_import(name::Symbol)
    try
        @eval import $name
        return true
    catch e
        return false
    end
end

if try_import(:DynamicPolynomials)
    Mod = DynamicPolynomials
    include("commutativetests.jl")
    include("noncommutativetests.jl")
end

if try_import(:TypedPolynomials)
    Mod = TypedPolynomials
    include("commutativetests.jl")
    include("allocations.jl")
end

module MultivariatePolynomialsChainRulesCoreExt

import ChainRulesCore
using MultivariatePolynomials
using MultivariatePolynomials: _APL, MA

ChainRulesCore.@scalar_rule +(x::_APL) true
ChainRulesCore.@scalar_rule -(x::_APL) -1

ChainRulesCore.@scalar_rule +(x::_APL, y::_APL) (true, true)
ChainRulesCore.@scalar_rule -(x::_APL, y::_APL) (true, -1)

function ChainRulesCore.frule((_, Δp, Δq), ::typeof(*), p::_APL, q::_APL)
    return p * q, MA.add_mul!!(p * Δq, q, Δp)
end
function ChainRulesCore.rrule(::typeof(*), p::_APL, q::_APL)
    function times_pullback2(ΔΩ̇)
        #ΔΩ = ChainRulesCore.unthunk(Ω̇)
        #return (ChainRulesCore.NoTangent(), ChainRulesCore.ProjectTo(p)(ΔΩ * q'), ChainRulesCore.ProjectTo(q)(p' * ΔΩ))
        return (ChainRulesCore.NoTangent(), ΔΩ̇ * q', p' * ΔΩ̇)
    end
    return p * q, times_pullback2
end

function ChainRulesCore.frule((_, Δp, _), ::typeof(differentiate), p, x)
    return differentiate(p, x), differentiate(Δp, x)
end
function pullback(Δdpdx, x)
    return ChainRulesCore.NoTangent(),
    x * differentiate(x * Δdpdx, x),
    ChainRulesCore.NoTangent()
end
function ChainRulesCore.rrule(::typeof(differentiate), p, x)
    dpdx = differentiate(p, x)
    return dpdx, Base.Fix2(pullback, x)
end

end

function convert_constant end
Base.convert(::Type{P}, α) where {P<:_APL} = convert_constant(P, α)
function convert_constant(::Type{TT}, α) where {T,TT<:AbstractTerm{T}}
    return term(convert(T, α), constant_monomial(TT))
end
function convert_constant(::Type{PT}, α) where {PT<:AbstractPolynomial}
    return convert(PT, convert(term_type(PT), α))
end
function Base.convert(::Type{P}, p::_APL) where {T,P<:AbstractPolynomial{T}}
    return error("`convert` not implemented for $P")
end

function Base.convert(
    ::Type{V},
    mono::AbstractMonomial,
) where {V<:AbstractVariable}
    variable = nothing
    for v in variables(mono)
        d = degree(mono, v)
        if isone(d)
            if variable === nothing
                variable = v
            else
                throw(InexactError(:convert, V, mono))
            end
        elseif !iszero(d)
            throw(InexactError(:convert, V, mono))
        end
    end
    if variable === nothing
        throw(InexactError(:convert, V, mono))
    end
    return variable
end

function Base.convert(
    ::Type{M},
    t::AbstractTerm,
) where {M<:AbstractMonomialLike}
    if isone(coefficient(t))
        return convert(M, monomial(t))
    else
        throw(InexactError(:convert, M, t))
    end
end
function Base.convert(
    TT::Type{<:AbstractTerm{T}},
    m::AbstractMonomialLike,
) where {T}
    return convert(TT, term(one(T), convert(monomial_type(TT), m)))
end
function Base.convert(TT::Type{<:AbstractTerm{T}}, t::AbstractTerm) where {T}
    return convert(
        TT,
        term(
            convert(T, coefficient(t)),
            convert(monomial_type(TT), monomial(t)),
        ),
    )
end

# Base.convert(::Type{T}, t::T) where {T <: AbstractTerm} is ambiguous with above method.
# we need the following:
function Base.convert(::Type{TT}, t::TT) where {T,TT<:AbstractTerm{T}}
    return t
end

function Base.convert(
    ::Type{T},
    p::AbstractPolynomial,
) where {T<:AbstractTermLike}
    if iszero(nterms(p))
        convert(T, zero_term(p))
    elseif isone(nterms(p))
        convert(T, leading_term(p))
    else
        throw(InexactError(:convert, T, p))
    end
end

MA.scaling(p::AbstractPolynomialLike{T}) where {T} = convert(T, p)
# Conversion polynomial -> constant
# We don't define a method for `Base.convert` to reduce invalidations;
# see https://github.com/JuliaAlgebra/MultivariatePolynomials.jl/pull/172
function convert_to_constant(::Type{S}, p::_APL) where {S}
    s = zero(S)
    for t in terms(p)
        if !isconstant(t)
            # The polynomial is not constant
            throw(InexactError(:convert_to_constant, S, p))
        end
        s = MA.add!!(s, convert(S, coefficient(t)))
    end
    return s
end
Base.convert(::Type{T}, p::_APL) where {T<:Number} = convert_to_constant(T, p)
function convert_to_constant(p::_APL{S}) where {S}
    return convert_to_constant(S, p)
end

# Also covers, e.g., `convert(_APL, ::P)` where `P<:_APL`
Base.convert(::Type{PT}, p::PT) where {PT<:_APL} = p

module MultivariatePolynomials

import LinearAlgebra

import DataStructures

import MutableArithmetics as MA

import StarAlgebras as SA

"""
    AbstractPolynomialLike{T}

Abstract type for a value that can act like a polynomial. For instance, an
`AbstractTerm{T}` is an `AbstractPolynomialLike{T}` since it can act as a
polynomial of only one term.
"""
abstract type AbstractPolynomialLike{T} <: MA.AbstractMutable end

"""
    AbstractTermLike{T}

Abstract type for a value that can act like a term. For instance, an `AbstractMonomial` is an `AbstractTermLike{Int}` since it can act as a term with coefficient `1`.
"""
abstract type AbstractTermLike{T} <: AbstractPolynomialLike{T} end

"""
    AbstractMonomialLike

Abstract type for a value that can act like a monomial. For instance, an `AbstractVariable` is an `AbstractMonomialLike` since it can act as a monomial of one variable with degree `1`.
"""
abstract type AbstractMonomialLike <: AbstractTermLike{Int} end

"""
    AbstractVariable <: AbstractMonomialLike

Abstract type for a variable.
"""
abstract type AbstractVariable <: AbstractMonomialLike end

"""
    AbstractMonomial <: AbstractMonomialLike

Abstract type for a monomial, i.e. a product of variables elevated to a nonnegative integer power.
"""
abstract type AbstractMonomial <: AbstractMonomialLike end

"""
    AbstractTerm{T} <: AbstractTermLike{T}

Abstract type for a term of coefficient type `T`, i.e. the product between a value of type `T` and a monomial.
"""
abstract type AbstractTerm{T} <: AbstractTermLike{T} end

"""
    AbstractPolynomial{T} <: AbstractPolynomialLike{T}

Abstract type for a polynomial of coefficient type `T`, i.e. a sum of `AbstractTerm{T}`s.
"""
abstract type AbstractPolynomial{T} <: AbstractPolynomialLike{T} end

const _APL{T} = AbstractPolynomialLike{T}

include("zip.jl")
include("lazy_iterators.jl")

include("variable.jl")
include("monomial.jl")
include("term.jl")
include("polynomial.jl")
include("monomial_vector.jl")

include("rational.jl")

include("show.jl")
include("hash.jl")

include("promote.jl")
include("conversion.jl")

include("complex.jl")
include("operators.jl")
include("comparison.jl")

include("substitution.jl")
include("differentiation.jl")
include("antidifferentiation.jl")
include("division.jl")
include("gcd.jl")
include("det.jl")

include("default_term.jl")
include("sequences.jl")
include("default_polynomial.jl")

include("deprecate.jl")

const _EXCLUDE_SYMBOLS = [Symbol(@__MODULE__), :eval, :include]

for sym in names(@__MODULE__; all = true)
    sym_string = string(sym)
    if sym in _EXCLUDE_SYMBOLS ||
       startswith(sym_string, "_") ||
       startswith(sym_string, "@_")
        continue
    end
    if !(
        Base.isidentifier(sym) ||
        (startswith(sym_string, "@") && Base.isidentifier(sym_string[2:end]))
    )
        continue
    end
    @eval export $sym
end

end # module

# Subtitution

Given a polynomial, say ``p(x, y) = 3x^2y + x + 2y + 1``, one can evaluate it at a given point, e.g. ``p(2, 1) = 12 + 2 + 2 + 1 = 17`` or substitute one or more variable by a value or polynomial, e.g. ``p(x, xy^2 + 1) = 3x^2(xy^2+1) + x + 2(xy^2+1) + 1 = 3x^3y^2 + 2xy^2 + 3x^2 + x + 3``.
We distinguish the two operation as follows

* We call an evaluation an operation where **every** variable should be replace by a new value or polynomial, the syntax is `p(x => 2, y => 1)`.
* We call a subsitution an operation where **some** (or all variables) are subtituted into a new value or polynomial, the syntax is `subs(p, y => x*y^2 + 1)`.

The distinction is important for type stability for some implementations (it is important for [DynamicPolynomials](https://github.com/blegat/DynamicPolynomials.jl) but not for [TypedPolynomials](https://github.com/rdeits/TypedPolynomials.jl)).
Indeed consider a polynomial with `Int` coefficients for which we ask to replace some variables with `Int` values. If all the variables are replaced with `Int`s, the return type should be `Int`.
However, if some variables only are replaced by `Int` then the return type should be a polynomial with `Int` coefficients.

```@docs
subs
substitute
```

```@meta
CurrentModule = MultivariatePolynomials
```

# Types

## Variables

```@docs
AbstractVariable
variable
name
name_base_indices
variable_union_type
similar_variable
@similar_variable
conj(::AbstractVariable)
real(::AbstractVariable)
imag(::AbstractVariable)
isreal(::AbstractVariable)
isrealpart
isimagpart
isconj
ordinary_variable
is_commutative
```

## Monomials

```@docs
AbstractMonomialLike
AbstractMonomial
monomial_type
variables
effective_variables
nvariables
exponents
degree
isconstant
powers
constant_monomial
map_exponents
multiplication_preserves_monomial_order
promote_variables
promote_variables_with_maps
```

### Ordering

```@docs
AbstractMonomialOrdering
ordering
compare
LexOrder
InverseLexOrder
Graded
Reverse
ExponentsIterator
```

## Terms

```@docs
AbstractTermLike
AbstractTerm
Term
term
term_type
coefficient
coefficient_type
monomial
constant_term
zero_term
degree_complex
halfdegree
```

## Polynomials

```@docs
AbstractPolynomialLike
AbstractPolynomial
Polynomial
polynomial
polynomial_type
terms
nterms
coefficients
coefficient(p::AbstractPolynomialLike, m::AbstractMonomialLike, vars)
monomials
mindegree
maxdegree
extdegree
leading_term
leading_coefficient
leading_monomial
deg_num_leading_terms
remove_leading_term
remove_monomials
filter_terms
OfDegree
monic
map_coefficients
map_coefficients!
map_coefficients_to!
conj(::_APL)
real(::_APL)
imag(::_APL)
isreal(::_APL)
mindegree_complex
minhalfdegree
maxdegree_complex
maxhalfdegree
extdegree_complex
exthalfdegree
```

## Rational Polynomial Function

A rational polynomial function can be constructed with the `/` operator. Common operations such as `+`, `-`, `*`, `-` have been implemented between rational functions.
The numerator and denominator polynomials can be retrieved by the `numerator` and `denominator` functions.

## Monomial Vectors

```@docs
monomial_vector
monomial_vector_type
empty_monomial_vector
sort_monomial_vector
merge_monomial_vectors
conj(::AbstractVector{<:AbstractMonomial})
real(::AbstractVector{<:AbstractMonomial})
imag(::AbstractVector{<:AbstractMonomial})
isreal(::AbstractVector{<:AbstractMonomial})
```

# MultivariatePolynomials

[MultivariatePolynomials.jl](https://github.com/blegat/MultivariatePolynomials.jl) is an implementation independent library for manipulating multivariate polynomials.
It defines abstract types and an API for multivariate monomials, terms, polynomials and gives default implementation for common operations on them using the API.

On the one hand, This packages allows you to implement algorithms on multivariate polynomials that will be independant on the representation of the polynomial that will be chosen by the user.
On the other hand, it allows the user to easily switch between different representations of polynomials to see which one is faster for the algorithm that he is using.

Supported operations are : basic arithmetic, rational polynomials, evaluation/substitution, differentiation and division.

The following packages provide representations of multivariate polynomials that implement the interface:

* [TypedPolynomials](https://github.com/rdeits/TypedPolynomials.jl) : Commutative polynomials of arbitrary coefficient types
* [DynamicPolynomials](https://github.com/blegat/DynamicPolynomials.jl) : Commutative and non-commutative polynomials of arbitrary coefficient types

The following packages extend the interface and/or implement algorithms using the interface:

* [SemialgebraicSets](https://github.com/blegat/SemialgebraicSets.jl) : Sets defined by inequalities and equalities between polynomials and algorithms for solving polynomial systems of equations.
* [HomotopyContinuation](https://github.com/saschatimme/HomotopyContinuation.jl) : Solving systems of polynomials via homotopy continuation.
* [MultivariateBases](https://github.com/JuliaAlgebra/MultivariateBases.jl/) : Standardized API for multivariate polynomial bases.
* [MultivariateMoments](https://github.com/blegat/MultivariateMoments.jl) : Moments of multivariate measures and their scalar product with polynomials.
* [PolyJuMP](https://github.com/JuliaOpt/PolyJuMP.jl) : A [JuMP](https://github.com/JuliaOpt/JuMP.jl) extension for Polynomial Optimization.
* [SumOfSquares](https://github.com/JuliaOpt/SumOfSquares.jl) : Certifying the nonnegativity of polynomials, minimizing/maximizing polynomials and optimization over sum of squares polynomials using Sum of Squares Programming.

## Contents
```@contents
Pages = ["types.md", "substitution.md", "differentiation.md", "division.md", "internal.md"]
Depth = 3
```

# Division

Given two polynomials, ``p`` and ``d``, there are unique ``r`` and ``q`` such that ``p = q d + r`` and the leading term of ``d`` does not divide the leading term of ``r``.
You can obtain ``q`` using the `div` function and ``r`` using the `rem` function.
The `divrem` function returns ``(q, r)``.

Given a polynomial ``p`` and divisors ``d_1, \ldots, d_n``, one can find ``r`` and ``q_1, \ldots, q_n`` such that ``p = q_1 d_1 + \cdots + q_n d_n + r`` and none of the leading terms of ``q_1, \ldots, q_n`` divide the leading term of ``r``.
You can obtain the vector ``[q_1, \ldots, q_n]`` using `div(p, d)` where ``d = [d_1, \ldots, d_n]`` and ``r`` using the `rem` function with the same arguments.
The `divrem` function returns ``(q, r)``.
```@docs
divides
div_multiple
```

Note that the coefficients of the polynomials need to be a field for `div`,
`rem` and `divrem` to work.
If the coefficient type is not a field, it is promoted to a field using [`promote_to_field`](@ref).
```@docs
promote_to_field
```
Alternatively, [`pseudo_rem`](@ref) or [`pseudo_divrem`](@ref) can be used
instead as they do not require the coefficient type to be a field.
```@docs
pseudo_rem
pseudo_divrem
rem_or_pseudo_rem
```

## Greatest Common Divisor (GCD)

The Greatest Common Divisor (GCD) and Least Common Multiple (LCM) can be
obtained for integers respectively with the `gcd` and `lcm` functions.
The same functions can be used with monomials and polynomials:
```@docs
gcd
lcm
AbstractUnivariateGCDAlgorithm
GeneralizedEuclideanAlgorithm
SubresultantAlgorithm
```
Internal functions of the `gcd` algorithm:
```@docs
isolate_variable
primitive_univariate_gcd!
univariate_gcd
content
primitive_part
primitive_part_content
```

# Differentiation

Given a polynomial, say ``p(x, y) = 3x^2y + x + 2y + 1``, we can differentiate it by a variable, say ``x`` and get ``\partial p(x, y) / \partial x = 6xy + 1``.
We can also differentiate it by both of its variable and get the vector ``[6xy+1, 3x^2+1]``.

```@docs
differentiate
```

# Antidifferentiation

Given a polynomial, say `p(x, y) = 3x^2y + x + 2y + 1`, we can antidifferentiate it by a variable, say `x` and get ``\int_0^x p(X, y)\mathrm{d}X = x^3y + 1/2x^2 + 2xy + x``.
We can also antidifferentiate it by both of its variable and get the vector `[x^3y + 1/2x^2 + 2xy + x, 3/2x^2y^2 + xy + y^2 + y]`.

```@docs
antidifferentiate
```
